// EnvelopeWindow.cpp : implementation file
//

#include "stdafx.h"
#include "kibibu Serpent.h"
#include "EnvelopeWindow.h"


// CEnvelopeWindow

IMPLEMENT_DYNAMIC(CEnvelopeWindow, CWnd)
CEnvelopeWindow::CEnvelopeWindow()
{
	m_pntMousePos.SetPoint(-1,-1);

	int i = 0;

	// In lieu of building a generic skinnable interface,
	// the pixel coordinates of buttons etc. are entered manually here
	int t = 259;
	int b = 271;
	m_rectHalfSecond.SetRect(260, t, 291, b); m_allRects[i++] = &m_rectHalfSecond;
	m_rectTwoSecond.SetRect(293, t, 318, b); m_allRects[i++] = &m_rectTwoSecond;
	m_rectFiveSecond.SetRect(320, t, 345, b); m_allRects[i++] = &m_rectFiveSecond;
	m_rectTenSecond.SetRect(347, t, 374, b); m_allRects[i++] = &m_rectTenSecond;

	m_rectStereoLeft.SetRect(311, 277, 327, 290); m_allRects[i++] = &m_rectStereoLeft;
	m_rectStereoRight.SetRect(353, 277, 374, 290); m_allRects[i++] = &m_rectStereoRight;
	m_rectStereoLinked.SetRect(328, 283, 352, 292); m_allRects[i++] = &m_rectStereoLinked;

	m_rectWorkspace.SetRect(55,23,384,248);

	t = 263;
	b = 279;
	m_rectMoveTool.SetRect(70,t,89,b); m_allRects[i++] = &m_rectMoveTool;
	m_rectDeleteTool.SetRect(111,t,130,b); m_allRects[i++] = &m_rectDeleteTool;
	m_rectSusStartTool.SetRect(142,t,161,b); m_allRects[i++] = &m_rectSusStartTool;
	m_rectSusEndTool.SetRect(165,t,184,b); m_allRects[i++] = &m_rectSusEndTool;

	m_rectGrid.SetRect(198,263,221,276); m_allRects[i++] = &m_rectGrid;
	m_rectSnap.SetRect(198,277,221,290); m_allRects[i++] = &m_rectSnap;
	m_bGrid = m_bSnap = true;
	m_iTimeDivisions = 20;
	m_iValueDivisions = 10;

	m_bMouseOverBox = false;

	// scrollbar bits
	m_rectScrollTrack.SetRect(67,252,373,259); m_allRects[i++] = &m_rectScrollTrack;
	m_rectScrollLeft.SetRect(57,250,68,261); m_allRects[i++] = &m_rectScrollLeft;
	m_rectScrollRight.SetRect(372,250,383,261); m_allRects[i++] = &m_rectScrollRight;

	// the scrollbar box itself. This moves
	m_rectScrollBox.SetRect(67,250,373,261);

	m_rectTimeTicksTop.SetRect(55,15,384,21);
	m_rectTimeTicksBottom.SetRect(55,238,384,244);

	m_rectValueTicksLeft.SetRect(47,23,53,252);
	m_rectValueTicksRight.SetRect(386,23,392,252);

	m_rectTimeFeedback.SetRect(11,257,50,269);
	m_rectValueFeedback.SetRect(11,271,50,284);

	m_rectValuesLeft.SetRect(3,11,46,256);
	m_rectTimeBottom.SetRect(56,8,384,13);

	// pointer to the currently selected rectangle/button
	m_pSelectedRect = NULL;

	// maximum value the envelope can go to. Can be set.
	m_fMaximumValue = 1.0f;
	m_fMinimumValue = 0.0f;

	// time range limits. Can be set.
	m_dMinimumTime = 0.0;
	m_dMaximumTime = 5.0;
	m_dDisplayLength = 5.0;

	m_psepSelected = NULL;
	m_psepPrevious = NULL;
	m_psepNext = NULL;

	// whether the left or right envelope is being edited
	m_bStereoLeft = true;

	// These could probably be better done with a single STATE variable
	m_bDragging = false; // currently in "drag a point around" mode
	m_bCutting = false; // currently in "split a bezier curve" mode
	m_bDeleting = false; // currently in "deleting" mode
	m_bSustainStart = false; // currently setting the sustain start
	m_bSustainEnd = false; // currently setting the sustain end

	// Menu that pops up when you right click a point
	CMenu m_muContextPoint;
	m_muContextPoint.CreatePopupMenu();

	// whether an offscreen buffer has been initialised or not 
	// for this envelope window
	this->m_bOffscreenInitialised = false;

}

CEnvelopeWindow::~CEnvelopeWindow()
{
}


// MFC Message map stuff
BEGIN_MESSAGE_MAP(CEnvelopeWindow, CWnd)
	ON_WM_MOUSEMOVE()
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_MENUSELECT()
END_MESSAGE_MAP()



// Snaps a given time to the grid
double CEnvelopeWindow::SnapTime(double dParamTime, bool bGrid)
{
	// grid is based on iTimeDivisions
	// Snap will snap to half gridsteps
	double dGridTimeSnap;

	double dTime = dParamTime;

	if(bGrid)
	{
		dGridTimeSnap = this->m_dDisplayLength / (m_iTimeDivisions);
	} else {
		dGridTimeSnap = this->m_dDisplayLength / (m_iTimeDivisions * 2);
	}

	// round the time to the nearest multiple of dGridTimeSnap
	if(dGridTimeSnap != 0.0)
	{
		dTime /= dGridTimeSnap;
		dTime += 0.5;
		dTime = (double)((int)dTime);
		dTime *= dGridTimeSnap;
		// if(dTime > m_dMaximumTime) dTime = m_dMaximumTime;
		if(dTime < 0.0) dTime = m_dMinimumTime;
	}

	return dTime;

}

// Same as SnapTime, but for values
float CEnvelopeWindow::SnapValue(float fValue)
{
	float fGridValueSnap = (this->m_fMaximumValue - this->m_fMinimumValue) / (m_iValueDivisions * 2);
	if(fGridValueSnap != 0.0f)
	{
		fValue /= fGridValueSnap;
		if(fValue > 0) fValue += 0.49f;
		if(fValue < 0) fValue -= 0.49f;
		fValue = (float)((int)fValue);
		fValue *= fGridValueSnap;
		if(fValue > m_fMaximumValue) fValue = m_fMaximumValue;
		if(fValue < m_fMinimumValue) fValue = m_fMinimumValue;
	}

	return fValue;

}


void CEnvelopeWindow::SnapPoint(CSerpentEnvelopePoint * p)
{
	p->t = SnapTime(p->t, false);
	p->v = SnapValue(p->v);

}


// CEnvelopeWindow message handlers


void CEnvelopeWindow::OnMouseMove(UINT nFlags, CPoint point)
{
	if(m_iMouseX == point.x && m_iMouseY == point.y) return;

	this->m_iMouseX = point.x;
	this->m_iMouseY = point.y;

	// If we aren't currently dragging a point around,
	// cutting a bezier or dragging the scroll box
	if(!m_bDragging && !m_bCutting && !m_bDraggingBox)
	{
		// If the mouse is in the envelope workspace
		if(m_rectWorkspace.PtInRect(point))
		{
			CSerpentEnvelopePoint * pPrev;
			CSerpentEnvelopePoint * pNext;
			CSerpentEnvelopePoint * pOldSel = m_psepSelected;

			// Find the envelope point they are mousing over
			m_psepSelected = this->FindPoint(point.x,point.y,&pPrev, &pNext);

			// I forget why this is here. Its gotta be there for something though.
			if(m_psepSelected && m_psepSelected->IsControl() ) m_psepSelected = NULL;

			if(m_psepSelected != pOldSel)
			{			
				Redraw();
			}

			// Change the cursor depending on the current mode
			if(m_bDeleting)
			{			
				::SetCursor(m_hcDelete);
			} else if(m_bSustainStart)
			{			
				::SetCursor(m_hcSustainStart);
			} else if(m_bSustainEnd)
			{
				::SetCursor(m_hcSustainEnd);
			} else {
				::SetCursor(m_hcMoveSplit);
			}
		} else {
			// otherwise, set to normal cursor
			HCURSOR hCurs = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
			::SetCursor(hCurs);
		}
	}

	// if we are currently dragging, and a point is selected
	if(m_bDragging && m_psepSelected)
	{

		float fV;
		double dT;

		this->ClientToPoint((float)point.x, (float)point.y, &fV, &dT);

		// If snap to grid is on
		if(m_bSnap)
		{
			// snap!
			dT = SnapTime(dT, false);
			fV = SnapValue(fV);
		}

		// clamp the time and value
		if(fV > this->m_fMaximumValue) fV = m_fMaximumValue;
		if(fV < this->m_fMinimumValue) fV = m_fMinimumValue;

		if(dT > this->m_dMaximumTime) dT = m_dMaximumTime;
		if(dT < this->m_dMinimumTime) dT = m_dMinimumTime;

		// if the currently selected envelope point has
		// an envelope point before it
		if(m_psepPrevious != NULL)
		{
			// make sure we can't set this time
			// to before the previous time
			if(dT < m_psepPrevious->t)
			{
				dT = m_psepPrevious->t;
			}

		}

		// and the same with the next point
		if(m_psepNext != NULL)
		{
			if(dT > m_psepNext->t)
			{
				dT = m_psepNext->t;
			}

		}

		float fOldV = m_psepSelected->v;
		double dOldT = m_psepSelected->t;

		// only allow vertical movement of the first point
		if(!(m_psepSelected->flags & SEP_FLAGS_FIXED_VALUE ))
		{
			m_psepSelected->v = fV;
		}

		if(m_psepPrevious)
			m_psepSelected->t = dT;

		// if anything has changed
		if((fOldV != m_psepSelected->v) || (dOldT != m_psepSelected->t))
		{
			// update the envelope
			this->m_pEnvelope->UpdateEnvelopeDetails();

			// and redraw
			Redraw();
		}

	} else if(m_bCutting)	// if currently splitting a bezier
	{
		if(m_pntMousePos.x != point.x)
		{
			m_pntMousePos.SetPoint(point.x, point.y);

			// don't screw with the display of the envelope
			CopyBackgroundToScreen();
			// just redraw the splitter bar
			RedrawOverlays();
		}
	} else if(m_bDraggingBox) // if sliding the scroll box
	{
		double dTime;

		double dMax = this->m_pEnvelope->GetLastTime() * 1.1;
		double dMin = 0.0;

		double dRatio = (double)(point.x - m_rectScrollTrack.left) / (double)m_rectScrollTrack.Width();
		if(dRatio < 0.0) dRatio = 0.0;
		if(dRatio > 1.0) dRatio = 1.0;
		dTime = dRatio * dMax;

		// treat dTime as a middle
		this->m_dMinimumTime = dTime - (this->m_dDisplayLength * 0.5);
		this->m_dMaximumTime = dTime + (this->m_dDisplayLength * 0.5);
		if(m_dMinimumTime < 0.0)
		{
			m_dMinimumTime = 0.0;
			m_dMaximumTime = m_dMinimumTime + this->m_dDisplayLength;
		} else if(m_dMaximumTime > dMax)
		{
			m_dMaximumTime = dMax;
			m_dMinimumTime = dMax - this->m_dDisplayLength;
		}
		if(m_dMinimumTime < 0.0)
		{
			m_dMinimumTime = 0.0;
			m_dMaximumTime = m_dMinimumTime + this->m_dDisplayLength;
		} 

		this->m_dMaximumTime = m_dMinimumTime + (this->m_dDisplayLength);

		Redraw();	// redraw everything
	}
	else {	// otherwise

		// if mousing over the scroll box
		if(m_rectScrollBox.PtInRect(point) && !m_bMouseOverBox)
		{			
			m_bMouseOverBox = true;
			Redraw();

		} else {	// not over the scroll box
			bool bRequireRedraw = false;

			if(!m_rectScrollBox.PtInRect(point) && m_bMouseOverBox)
			{			
				m_bMouseOverBox = false;
				bRequireRedraw = true;
			}

			// just moving around
			CRect * pNewSelection = NULL;

			for(int i = 0; i < NUM_ENVELOPE_RECTS; i++)
			{
				if(m_allRects[i].PtInRect(point))
				{
					// found one
					pNewSelection = &(m_allRects[i]);
					break;
				}
			}

			if(pNewSelection != m_pSelectedRect)
			{
				m_pSelectedRect = pNewSelection;
				bRequireRedraw = true;

			}

			if(bRequireRedraw) Redraw();
		}
	}

	// CWnd::OnMouseMove(nFlags, point);

	// Invalidate(FALSE);
}

// This stuff is used for funky antialiased text, 
// as long as you aren't dragging stuff around
#define PADDING (4)
#define MIN_SAMPLING (1)
#define MAX_SAMPLING (2)

// Function to draw a bezier, its control points, and
// some other bits and pieces.
void CEnvelopeWindow::DrawBezier(CDC &dcWorkspace,
								 CDC &dcBltSrc,
								 CSerpentEnvelope * pCurrentEnvelope,
								 int iVertRange, int iHorizRange,
								 int iBottom, int iLeft,
								 int SUPERSAMPLING, 
								 bool bDrawControls)
{
	float fValueRange = this->m_fMaximumValue - this->m_fMinimumValue;
	double dTimeRange = this->m_dMaximumTime - this->m_dMinimumTime;

	BITMAP bmPointInfo;
	m_bmPoint.GetBitmap(&bmPointInfo);
	int iPointWidth2 = (bmPointInfo.bmWidth * SUPERSAMPLING ) >> 1;
	int iPointHeight2 = (bmPointInfo.bmHeight * SUPERSAMPLING )  >> 1;

	BITMAP bmControlInfo;
	m_bmControl.GetBitmap(&bmControlInfo);
	int iControlWidth2 = (bmControlInfo.bmWidth * SUPERSAMPLING)  >> 1;
	int iControlHeight2 = (bmControlInfo.bmHeight * SUPERSAMPLING)  >> 1;


	CPen cWidePen;	
	cWidePen.CreatePen(PS_SOLID,SUPERSAMPLING,RGB(0,0,0));

	CPen cGreyPen;
	cGreyPen.CreatePen(PS_SOLID,SUPERSAMPLING,RGB(160,160,160));

	CPen cGhostPen;
	cGhostPen.CreatePen(PS_SOLID, SUPERSAMPLING, RGB(200,200,200));

	// bottom up
	double fy, fx;

	fy = (((pCurrentEnvelope->env.p1.v - m_fMinimumValue) / fValueRange)
		* (-iVertRange)) + iBottom;

	fx = (((pCurrentEnvelope->env.p1.t - m_dMinimumTime) / dTimeRange)
		* (iHorizRange)) + iLeft;

	points[0].x = (int)fx;
	points[0].y = (int)fy;

	// c1
	fy = (((pCurrentEnvelope->env.c1.v - m_fMinimumValue) / fValueRange)
		* (-iVertRange)) + iBottom;

	fx = (((pCurrentEnvelope->env.c1.t - m_dMinimumTime) / dTimeRange)
		* (iHorizRange)) + iLeft;

	points[1].x = (int)fx;
	points[1].y = (int)fy;

	// c2
	fy = (((pCurrentEnvelope->env.c2.v - m_fMinimumValue) / fValueRange)
		* (-iVertRange)) + iBottom;

	fx = (((pCurrentEnvelope->env.c2.t - m_dMinimumTime) / dTimeRange)
		* (iHorizRange)) + iLeft;

	points[2].x = (int)fx;
	points[2].y = (int)fy;

	CSerpentEnvelopePoint * pCurrentPoint = &pCurrentEnvelope->env.p2;
	if(pCurrentEnvelope->pNextEnvelope)
	{
		pCurrentPoint = &(pCurrentEnvelope->pNextEnvelope->env.p1);
	}

	// p2
	fy = (((pCurrentPoint->v - m_fMinimumValue) / fValueRange)
		* (-iVertRange)) + iBottom;

	fx = (((pCurrentPoint->t - m_dMinimumTime) / dTimeRange)
		* (iHorizRange)) + iLeft;

	points[3].x = (int)fx;
	points[3].y = (int)fy;

	if(bDrawControls)
	{
		// draw control lines
		dcWorkspace.SelectObject(&cGreyPen);
		dcWorkspace.MoveTo(points[0]);
		dcWorkspace.LineTo(points[1]);
		dcWorkspace.MoveTo(points[2]);
		dcWorkspace.LineTo(points[3]);

		dcWorkspace.SelectObject(&cWidePen);

	} else 
	{
		// select a ghosting pen
		dcWorkspace.SelectObject(&cGhostPen);
	}


	// draw the bezier spline
	dcWorkspace.PolyBezier(points, 4);



	if(bDrawControls)
	{
		// draw the points
		dcBltSrc.SelectObject(&m_bmPoint);
		dcWorkspace.StretchBlt(
			points[0].x - iPointWidth2,
			points[0].y - iPointHeight2,
			iPointWidth2 << 1,
			iPointHeight2 << 1,
			&dcBltSrc,0,0,bmPointInfo.bmWidth, bmPointInfo.bmHeight, SRCCOPY);

		dcWorkspace.StretchBlt(
			points[3].x - iPointWidth2,
			points[3].y - iPointHeight2,
			iPointWidth2 << 1,
			iPointHeight2 << 1,
			&dcBltSrc,0,0,bmPointInfo.bmWidth, bmPointInfo.bmHeight, SRCCOPY);

		// and the control points
		dcBltSrc.SelectObject(&m_bmControl);
		dcWorkspace.StretchBlt(
			points[1].x - iControlWidth2,
			points[1].y - iControlHeight2,
			iControlWidth2 << 1,
			iControlHeight2 << 1,
			&dcBltSrc,0,0,bmControlInfo.bmWidth, bmControlInfo.bmHeight, SRCCOPY);

		dcWorkspace.StretchBlt(
			points[2].x - iControlWidth2,
			points[2].y - iControlHeight2,
			iControlWidth2 << 1,
			iControlHeight2 << 1,
			&dcBltSrc,0,0,bmControlInfo.bmWidth, bmControlInfo.bmHeight, SRCCOPY);
	}


}


// Draw the workspace (the envelope bit)
void CEnvelopeWindow::DrawWorkspace(CDC &dc, CDC &dcBltSrc)
{

	// Draw the workspace

	// If you are dragging stuff around, don't supersample

	// int SUPERSAMPLING = (m_bDragging || m_bCutting || m_bDraggingBox ?MIN_SAMPLING:MAX_SAMPLING);
	int SUPERSAMPLING = (m_bDragging || m_bDraggingBox ?MIN_SAMPLING:MAX_SAMPLING);
	int SSPADDING = (PADDING * SUPERSAMPLING);

	bool bZero = false;	// whether a zero line is visible

	if(m_fMinimumValue < 0.0f && m_fMaximumValue > 0.0f)
	{
		bZero = true;
	}

	// create an offscreen buffer for the workspace
	// supersampled width and height
	int iWorkspaceWidthSS = m_rectWorkspace.Width() * SUPERSAMPLING;
	int iWorkspaceHeightSS = m_rectWorkspace.Height() * SUPERSAMPLING;

	// normal width and height
	int iWorkspaceWidthNormal = m_rectWorkspace.Width();
	int iWorkspaceHeightNormal = m_rectWorkspace.Height();

	CDC dcWorkspace;
	dcWorkspace.CreateCompatibleDC(&dc);
	dcWorkspace.SelectObject(&m_bmWorkspace);
	dcWorkspace.SetStretchBltMode(COLORONCOLOR);
	dcWorkspace.SetBrushOrg(0,0);

	dcWorkspace.StretchBlt(0,0,iWorkspaceWidthSS, iWorkspaceHeightSS,&dcBltSrc,
		m_rectWorkspace.left,
		m_rectWorkspace.top,
		m_rectWorkspace.Width(),
		m_rectWorkspace.Height(),
		SRCCOPY);

	int iVertRange = iWorkspaceHeightSS - (SSPADDING * 2);
	int iVertRangeNormal = iWorkspaceHeightNormal - (PADDING * 2);

	int iHorizRange = iWorkspaceWidthSS - (SSPADDING * 2);
	int iHorizRangeNormal = iWorkspaceWidthNormal - (PADDING * 2);

	int iBottom = iWorkspaceHeightSS - SSPADDING;
	int iBottomNormal = iWorkspaceHeightNormal - PADDING;

	int iLeft = SSPADDING;
	int iLeftNormal = PADDING;

	CSerpentEnvelope * pCurrentEnvelope;

	pCurrentEnvelope = this->m_pEnvelope;
	if(pCurrentEnvelope == NULL) return;

	float fValueRange = this->m_fMaximumValue - this->m_fMinimumValue;
	double dTimeRange = this->m_dMaximumTime - this->m_dMinimumTime;

	BITMAP bmPointInfo;
	m_bmPoint.GetBitmap(&bmPointInfo);
	int iPointWidth2 = (bmPointInfo.bmWidth * SUPERSAMPLING ) >> 1;
	int iPointHeight2 = (bmPointInfo.bmHeight * SUPERSAMPLING )  >> 1;

	BITMAP bmControlInfo;
	m_bmControl.GetBitmap(&bmControlInfo);
	int iControlWidth2 = (bmControlInfo.bmWidth * SUPERSAMPLING)  >> 1;
	int iControlHeight2 = (bmControlInfo.bmHeight * SUPERSAMPLING)  >> 1;


	double fx, fy;

	CPen cWidePen;	
	cWidePen.CreatePen(PS_SOLID,SUPERSAMPLING,RGB(0,0,0));


	// draw the grid
	CPen cGridPen;
	cGridPen.CreatePen(PS_SOLID, 1, RGB(193,194,178));

	CFont fLabelFont;
	fLabelFont.CreateFont(8,0,0,0,FW_NORMAL,0,0, 0,ANSI_CHARSET,OUT_DEVICE_PRECIS,CLIP_DEFAULT_PRECIS,NONANTIALIASED_QUALITY,
		DEFAULT_PITCH | FF_SWISS , "Small Fonts");	

	CString sLabel;

	dc.SelectObject(&fLabelFont);

	CRect rLabelRect;
	dcWorkspace.SelectObject(&cGridPen);

	dc.SetBkMode(TRANSPARENT);

	double dGridTimeSnap = this->m_dDisplayLength / m_iTimeDivisions;
	double dCurrentGridSpot = SnapTime(m_dMinimumTime, true);

	// only draw every second timeline
	bool bDraw = true;

	while(dCurrentGridSpot <= m_dMaximumTime)
	{
		fx = (((dCurrentGridSpot - m_dMinimumTime) / dTimeRange)
			* (iHorizRange)) + iLeft;

		if(m_bGrid)
		{
			dcWorkspace.MoveTo((int)fx,0);
			dcWorkspace.LineTo((int)fx,iWorkspaceHeightSS);
		}

		fx /= SUPERSAMPLING;
		fx += this->m_rectTimeBottom.left;

		sLabel.Format("%.2f",dCurrentGridSpot);
		dc.DrawTextEx(sLabel,&rLabelRect,DT_CALCRECT, NULL);
		rLabelRect.MoveToY(this->m_rectTimeBottom.top - 2);
		fx -= (rLabelRect.Width() * 0.5);			

		// if at least half the rectangle is on screen draw it
		if(fx < m_rectTimeBottom.left - rLabelRect.Width() * 0.5) bDraw = false;

		if(bDraw)
		{
			if(fx < m_rectTimeBottom.left) fx = m_rectTimeBottom.left;
			if(fx + rLabelRect.Width() > m_rectTimeBottom.right) fx = m_rectTimeBottom.right - rLabelRect.Width();
			rLabelRect.MoveToX((int)fx);

			dc.DrawTextEx(sLabel,&rLabelRect,DT_CENTER, NULL);
		}

		bDraw = !bDraw;

		dCurrentGridSpot += dGridTimeSnap;
	}

	float fGridValueSnap = fValueRange / m_iValueDivisions;
	float fCurrentGridSpot = SnapValue(m_fMinimumValue);

	while(fCurrentGridSpot <= m_fMaximumValue)
	{
		fy = (((fCurrentGridSpot - m_fMinimumValue) / fValueRange)
			* (-iVertRange)) + iBottom;

		if(m_bGrid)
		{
			dcWorkspace.MoveTo(0,(int)fy);
			dcWorkspace.LineTo(iWorkspaceWidthSS,(int)fy);
		}

		fy /= SUPERSAMPLING;
		fy += this->m_rectWorkspace.top;

		sLabel.Format("%.2f",fCurrentGridSpot);
		dc.DrawTextEx(sLabel,&rLabelRect,DT_CALCRECT, NULL);
		rLabelRect.MoveToX(this->m_rectValuesLeft.right - rLabelRect.Width());
		fy -= (rLabelRect.Height() * 0.5);
		if(fy < m_rectValuesLeft.top) fy = m_rectValuesLeft.top;

		rLabelRect.MoveToY((int)fy);

		dc.DrawTextEx(sLabel,&rLabelRect,DT_CENTER, NULL);

		fCurrentGridSpot += fGridValueSnap;
	}




	// draw this envelope

	// draw ghosted stereo
	if(!this->m_pEnvelopeLeft->bLinked)
	{
		if(this->m_bStereoLeft)
		{
			pCurrentEnvelope = this->m_pEnvelopeRight;
			do
			{
				DrawBezier(dcWorkspace, dcBltSrc, pCurrentEnvelope, iVertRange, iHorizRange, iBottom, iLeft, SUPERSAMPLING, false);			
				pCurrentEnvelope = pCurrentEnvelope->pNextEnvelope;			
			} while (pCurrentEnvelope != NULL);
			pCurrentEnvelope = this->m_pEnvelope;

		} else {

			pCurrentEnvelope = this->m_pEnvelopeLeft;
			do{
				DrawBezier(dcWorkspace, dcBltSrc, pCurrentEnvelope, iVertRange, iHorizRange, iBottom, iLeft, SUPERSAMPLING, false);
				pCurrentEnvelope = pCurrentEnvelope->pNextEnvelope;	
			} while (pCurrentEnvelope != NULL);

			pCurrentEnvelope = this->m_pEnvelope;
		}
	}

	do
	{
		DrawBezier(dcWorkspace, dcBltSrc, pCurrentEnvelope, iVertRange, iHorizRange, iBottom, iLeft, SUPERSAMPLING, true);
		pCurrentEnvelope = pCurrentEnvelope->pNextEnvelope;

	} while (pCurrentEnvelope != NULL);


	int iX, iY;



	// then draw the selected point/control
	// easier than checking each point
	if(m_psepSelected != NULL)
	{
		if(m_psepSelected->flags & SEP_FLAGS_CONTROL)
		{
			dcBltSrc.SelectObject(&m_bmControlSelected);
		} else {
			dcBltSrc.SelectObject(&m_bmPointSelected);
		}

		fy = (((m_psepSelected->v - m_fMinimumValue) / fValueRange)
			* (-iVertRange)) + iBottom;

		fx = (((m_psepSelected->t - m_dMinimumTime) / dTimeRange)
			* (iHorizRange)) + iLeft;


		iX = (int)fx;
		iY = (int)fy;

		dcWorkspace.StretchBlt(
			iX - iControlWidth2,
			iY - iControlHeight2,
			iControlWidth2 << 1,
			iControlHeight2 << 1,
			&dcBltSrc,0,0,bmControlInfo.bmWidth, bmControlInfo.bmHeight, SRCCOPY);

	}

	dc.SetStretchBltMode(HALFTONE);
	dc.SetBrushOrg(0,0);

	// Shrink workspace down
	dc.StretchBlt(m_rectWorkspace.left,m_rectWorkspace.top,
		m_rectWorkspace.Width(),m_rectWorkspace.Height(),&dcWorkspace,
		0,0,iWorkspaceWidthSS,iWorkspaceHeightSS,SRCCOPY);

	// ANTIALIASED STUFF SHOULD NOW BE FINISHED!

	// Draw tick marks
	if(m_psepSelected != NULL)
	{
		iY = (int) ((((m_psepSelected->v - m_fMinimumValue) / fValueRange)
			* (-iVertRangeNormal)) + iBottomNormal );

		iX = (int) ((((m_psepSelected->t - m_dMinimumTime) / dTimeRange)
			* (iHorizRangeNormal)) + iLeftNormal );

		iX += m_rectWorkspace.left;
		iY += m_rectWorkspace.top;

		CPen cTickPen;
		cTickPen.CreatePen(PS_SOLID, 1, RGB(113,113,113));

		// also, draw the bits around the edge
		dc.SelectObject(&cTickPen);
		dc.MoveTo(iX, m_rectTimeTicksTop.top);
		dc.LineTo(iX, m_rectTimeTicksTop.bottom);
		// dc.MoveTo(iX, m_rectTimeTicksBottom.top);
		// dc.LineTo(iX, m_rectTimeTicksBottom.bottom);

		dc.MoveTo(m_rectValueTicksLeft.left, iY);
		dc.LineTo(m_rectValueTicksLeft.right, iY);
		dc.MoveTo(m_rectValueTicksRight.left, iY);
		dc.LineTo(m_rectValueTicksRight.right, iY);
	}

	// draw the sustain lines
	CSerpentEnvelopePoint * pSusStart = m_pEnvelope->GetSustainStart();

	CSerpentEnvelopePoint * pSusEnd = m_pEnvelope->GetSustainEnd();


	// if both points are the same, and not null
	if(pSusStart && (pSusStart == pSusEnd))
	{
		CPen cSustainBothPen;
		cSustainBothPen.CreatePen(PS_SOLID, 1, RGB(192,0,192));

		iY = (int) ((((pSusStart->v - m_fMinimumValue) / fValueRange)
			* (-iVertRangeNormal)) + iBottomNormal );

		iX = (int) ((((pSusStart->t - m_dMinimumTime) / dTimeRange)
			* (iHorizRangeNormal)) + iLeftNormal );

		iX += m_rectWorkspace.left;
		iY += m_rectWorkspace.top;

		dc.SelectObject(&cSustainBothPen);
		dc.MoveTo(iX,m_rectWorkspace.top);
		dc.LineTo(iX,m_rectWorkspace.bottom);

	} else 
	{
		if(pSusStart)
		{
			CPen cSustainStartPen;
			cSustainStartPen.CreatePen(PS_SOLID, 1, RGB(192,0,0));

			iY = (int) ((((pSusStart->v - m_fMinimumValue) / fValueRange)
				* (-iVertRangeNormal)) + iBottomNormal );

			iX = (int) ((((pSusStart->t - m_dMinimumTime) / dTimeRange)
				* (iHorizRangeNormal)) + iLeftNormal );

			iX += m_rectWorkspace.left;
			iY += m_rectWorkspace.top;

			dc.SelectObject(&cSustainStartPen);
			dc.MoveTo(iX,m_rectWorkspace.top);
			dc.LineTo(iX,m_rectWorkspace.bottom);

		}

		if(pSusEnd)
		{
			CPen cSustainEndPen;
			cSustainEndPen.CreatePen(PS_SOLID, 1, RGB(0,0,192));

			iY = (int) ((((pSusEnd->v - m_fMinimumValue) / fValueRange)
				* (-iVertRangeNormal)) + iBottomNormal );

			iX = (int) ((((pSusEnd->t - m_dMinimumTime) / dTimeRange)
				* (iHorizRangeNormal)) + iLeftNormal );

			iX += m_rectWorkspace.left;
			iY += m_rectWorkspace.top;

			dc.SelectObject(&cSustainEndPen);
			dc.MoveTo(iX,m_rectWorkspace.top);
			dc.LineTo(iX,m_rectWorkspace.bottom);
		}
	}



}

void CEnvelopeWindow::RedrawWorkspace()
{
	CBitmap * pOldBitmap;
	CDC dc;
	dc.CreateCompatibleDC(NULL);
	pOldBitmap = dc.SelectObject(&m_bmOffscreen);

	CDC dcBltSrc; 
	dcBltSrc.CreateCompatibleDC(&dc);

	CBitmap * pOldBltSrcBitmap = dcBltSrc.SelectObject(&m_bmEnvelope);

	BITMAP bmInfo;
	m_bmEnvelope.GetBitmap(&bmInfo);

	dc.BitBlt(
		m_rectWorkspace.left, m_rectWorkspace.top,		
		m_rectWorkspace.Width(), m_rectWorkspace.bottom,&dcBltSrc,
		m_rectWorkspace.left,m_rectWorkspace.top,SRCCOPY);

	// now, to draw various bits
	DrawWorkspace(dc, dcBltSrc);

	dc.SelectObject(pOldBitmap);
	dcBltSrc.SelectObject(pOldBltSrcBitmap);

	Invalidate(FALSE);
}

void CEnvelopeWindow::CopyBackgroundToScreen()
{
	CDC * dc = this->GetDC();
	if(!dc) return;

	CRect rectClient;
	this->GetClientRect(&rectClient);

	// draw the offscreen bitmap first
	CDC dcOffscreen;
	dcOffscreen.CreateCompatibleDC(dc);
	CBitmap * pOldOffscreen = dcOffscreen.SelectObject(&m_bmOffscreen);

	dc->BitBlt(0,0, rectClient.Width(),rectClient.Height(),&dcOffscreen,0,0,SRCCOPY);

	this->ReleaseDC(dc);
}

void CEnvelopeWindow::RedrawOverlays()
{
	CDC * dc = this->GetDC();
	if(!dc) return;

	CDC dcBltSrc;
	dcBltSrc.CreateCompatibleDC(dc);


	CPen penCut;
	penCut.CreatePen(PS_SOLID,1,RGB(128,0,0));

	CFont fFeedback;
	fFeedback.CreateFont(11,0,0,0,FW_NORMAL,0,0, 0,ANSI_CHARSET,OUT_DEVICE_PRECIS,CLIP_DEFAULT_PRECIS,NONANTIALIASED_QUALITY,
		DEFAULT_PITCH | FF_SWISS , "Small Fonts");

	// if cutting, draw in the mouse pos
	if(m_bCutting)
	{
		int xCut = this->m_iMouseX;

		float fValue;
		double dTime;

		this->ClientToPoint((float)m_iMouseX, (float)m_iMouseY, &fValue, &dTime);

		CString sCutStringT;
		CString sCutStringV;

		if(xCut < this->m_rectWorkspace.right && xCut > this->m_rectWorkspace.left)
		{

			dc->SelectObject(&penCut);
			dc->MoveTo(xCut, m_rectWorkspace.top);
			dc->LineTo(xCut, m_rectWorkspace.bottom);

			CSerpentEnvelope * pFound;
			float f = this->m_pEnvelope->GetValueAtTimeSlow(dTime,&pFound);
			float fClientX, fClientY;
			this->PointToClient(f, dTime,&fClientX, &fClientY);

			dc->MoveTo(m_rectWorkspace.left, (int)fClientY);
			dc->LineTo(m_rectWorkspace.right, (int)fClientY);


			sCutStringT.Format("%.3f", dTime);
			sCutStringV.Format("%.3f", f);

		} else {
			sCutStringT = "cancel";
			sCutStringV = "";
		}

		dc->SelectObject(&fFeedback);
		dc->DrawText(sCutStringT, &m_rectTimeFeedback,DT_LEFT);
		dc->DrawText(sCutStringV, &m_rectValueFeedback,DT_LEFT);

	} else if(m_bDragging && m_psepSelected)
	{
		dc->SelectObject(&fFeedback);

		CString sCutString;
		sCutString.Format("%.3f", m_psepSelected->t);
		dc->DrawText(sCutString, &m_rectTimeFeedback,DT_LEFT);

		sCutString.Format("%.3f", m_psepSelected->v);
		dc->DrawText(sCutString, &m_rectValueFeedback,DT_LEFT);


	}

	// then draw the mouseover stuff
	// draw the selected rect
	if(m_pSelectedRect != NULL)
	{
		dcBltSrc.SelectObject(&m_bmEnvelopeOver);
		dc->BitBlt(m_pSelectedRect->left, m_pSelectedRect->top,
			m_pSelectedRect->Width(), m_pSelectedRect->Height(),
			&dcBltSrc,m_pSelectedRect->left, m_pSelectedRect->top, SRCCOPY);
	}


	//	dcOffscreen.SelectObject(pOldOffscreen);

	this->ReleaseDC(dc);

}

// Yechh
void CEnvelopeWindow::RedrawOffscreen()
{
	if(!m_bOffscreenInitialised) return;	

	// double buffering stuff
	CRect rectPaintSize;
	this->GetClientRect(&rectPaintSize);

	int iDestWidth = rectPaintSize.Width();
	int iDestHeight = rectPaintSize.Height();

	// create off-screen DC
	CDC dc;
	dc.CreateCompatibleDC(NULL);
	dc.SelectObject(&m_bmOffscreen);

	// create blt source DC for copying items
	CDC dcBltSrc;
	dcBltSrc.CreateCompatibleDC(&dc);

	BITMAP bmInfo;
	m_bmEnvelope.GetBitmap(&bmInfo);

	CBitmap * pOldBltSrcBitmap = dcBltSrc.SelectObject(&m_bmEnvelope);

	dc.BitBlt(0, 0, bmInfo.bmWidth, bmInfo.bmHeight,&dcBltSrc,0,0,SRCCOPY);
	// dc.SetStretchBltMode(COLORONCOLOR);
	// dc.StretchBlt(0,0,iDestWidth, iDestHeight, &dcBltSrc,0,0,
	//	bmInfo.bmWidth, bmInfo.bmHeight, SRCCOPY);

	// now, to draw various bits
	DrawWorkspace(dc, dcBltSrc);

	dcBltSrc.SelectObject(&m_bmEnvelopeSelected);
	if(this->m_pEnvelopeLeft->bLinked)
	{
		dc.BitBlt(m_rectStereoLinked.left, m_rectStereoLinked.top,
			m_rectStereoLinked.Width(), m_rectStereoLinked.Height(),
			&dcBltSrc,m_rectStereoLinked.left, m_rectStereoLinked.top, SRCCOPY);
	} else {
		if(m_bStereoLeft)
		{
			dc.BitBlt(m_rectStereoLeft.left, m_rectStereoLeft.top,
				m_rectStereoLeft.Width(), m_rectStereoLeft.Height(),
				&dcBltSrc,m_rectStereoLeft.left, m_rectStereoLeft.top, SRCCOPY);
		} else {
			dc.BitBlt(m_rectStereoRight.left, m_rectStereoRight.top,
				m_rectStereoRight.Width(), m_rectStereoRight.Height(),
				&dcBltSrc,m_rectStereoRight.left, m_rectStereoRight.top, SRCCOPY);
		}
	}

	if(m_bGrid)
	{
		dc.BitBlt(m_rectGrid.left, m_rectGrid.top,
			m_rectGrid.Width(), m_rectGrid.Height(),
			&dcBltSrc,m_rectGrid.left, m_rectGrid.top, SRCCOPY);
	}

	if(m_bSnap)
	{
		dc.BitBlt(m_rectSnap.left, m_rectSnap.top,
			m_rectSnap.Width(), m_rectSnap.Height(),
			&dcBltSrc,m_rectSnap.left, m_rectSnap.top, SRCCOPY);
	}


	if(m_bDeleting)
	{
		dc.BitBlt(m_rectDeleteTool.left, m_rectDeleteTool.top,
			m_rectDeleteTool.Width(), m_rectDeleteTool.Height(),
			&dcBltSrc,m_rectDeleteTool.left, m_rectDeleteTool.top, SRCCOPY);
	} else if(m_bSustainStart)
	{
		dc.BitBlt(m_rectSusStartTool.left, m_rectSusStartTool.top,
			m_rectSusStartTool.Width(), m_rectSusStartTool.Height(),
			&dcBltSrc,m_rectSusStartTool.left, m_rectSusStartTool.top, SRCCOPY);
	} else if(m_bSustainEnd)
	{
		dc.BitBlt(m_rectSusEndTool.left, m_rectSusEndTool.top,
			m_rectSusEndTool.Width(), m_rectSusEndTool.Height(),
			&dcBltSrc,m_rectSusEndTool.left, m_rectSusEndTool.top, SRCCOPY);
	} else
	{
		dc.BitBlt(m_rectMoveTool.left, m_rectMoveTool.top,
			m_rectMoveTool.Width(), m_rectMoveTool.Height(),
			&dcBltSrc,m_rectMoveTool.left, m_rectMoveTool.top, SRCCOPY);
	}

	// draw the scrollbar
	double dEnvelopeLength = this->m_pEnvelope->GetLastTime() * 1.1;

	// check the scroll box
	CPoint pMouse(m_iMouseX, m_iMouseY);
	bool bMouseOverBox = this->m_bMouseOverBox;

	int iBoxTop = m_rectScrollBox.top;
	int iBoxHeight = m_rectScrollBox.Height();

	if(bMouseOverBox)
	{
		iBoxTop += iBoxHeight;
		iBoxTop--;
		iBoxHeight = -iBoxHeight;
	}



	m_bmScrollboxLeft.GetBitmap(&bmInfo);
	int iBoxLeft = (int)( m_rectScrollTrack.left + (m_rectScrollTrack.Width() * this->m_dMinimumTime / dEnvelopeLength));
	int iCentreLeft = iBoxLeft + bmInfo.bmWidth;

	// set left of scrollbox
	m_rectScrollBox.left = iBoxLeft;

	dcBltSrc.SelectObject(m_bmScrollboxLeft);
	dc.StretchBlt(iBoxLeft,
		iBoxTop, bmInfo.bmWidth, iBoxHeight,&dcBltSrc,0,0,bmInfo.bmWidth, bmInfo.bmHeight, SRCCOPY);

	m_bmScrollboxRight.GetBitmap(&bmInfo);
	int iBoxRight = (int)(m_rectScrollTrack.left + (m_rectScrollTrack.Width() * this->m_dMaximumTime / dEnvelopeLength));
	if(iBoxRight > m_rectScrollTrack.right) iBoxRight = m_rectScrollTrack.right;

	// set right of scrollbox
	m_rectScrollBox.right = iBoxRight;

	// subtract bitmap width for drawing
	iBoxRight -= bmInfo.bmWidth;

	int iCentreRight = iBoxRight;	
	dcBltSrc.SelectObject(m_bmScrollboxRight);
	dc.StretchBlt(iBoxRight,
		iBoxTop, bmInfo.bmWidth, iBoxHeight,&dcBltSrc,0,0,bmInfo.bmWidth, bmInfo.bmHeight, SRCCOPY);

	m_bmScrollboxMid.GetBitmap(&bmInfo);	
	dcBltSrc.SelectObject(m_bmScrollboxMid);
	dc.StretchBlt(iCentreLeft,
		iBoxTop, iCentreRight - iCentreLeft,iBoxHeight, &dcBltSrc,0,0,bmInfo.bmWidth, bmInfo.bmHeight, SRCCOPY);

	// set bottom of scrollbox
	m_rectScrollBox.bottom = m_rectScrollBox.top + bmInfo.bmHeight;

	// restore old objects
	dcBltSrc.SelectObject(pOldBltSrcBitmap);


}

void CEnvelopeWindow::OnPaint()
{
	CPaintDC dcPaint(this); // device context for painting

	PAINTSTRUCT ps = dcPaint.m_ps;

	CRect rectPaintSize;
	this->GetClientRect(&rectPaintSize);

	int iDestWidth = rectPaintSize.Width();
	int iDestHeight = rectPaintSize.Height();

	if(!m_bOffscreenInitialised)
	{

		// create off-screen buffer
		this->m_bmOffscreen.CreateCompatibleBitmap(
			&dcPaint,
			iDestWidth,
			iDestHeight);


		m_bmWorkspace.CreateCompatibleBitmap(
			&dcPaint,
			m_rectWorkspace.Width() * MAX_SAMPLING,
			m_rectWorkspace.Height() * MAX_SAMPLING);

		m_bOffscreenInitialised = true;

		RedrawOffscreen();

	}

	CDC dcOffscreen;
	dcOffscreen.CreateCompatibleDC(&dcPaint);
	CBitmap * pOldOffscreen = dcOffscreen.SelectObject(&m_bmOffscreen);

	CRect rcPaint = ps.rcPaint;


	dcPaint.BitBlt(rcPaint.left,
		rcPaint.top,
		rcPaint.Width(),rcPaint.Height(),&dcOffscreen,rcPaint.left,rcPaint.top,SRCCOPY);

	dcOffscreen.SelectObject(pOldOffscreen);


	RedrawOverlays();



}

int CEnvelopeWindow::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Load up the bitmaps
	m_bmEnvelope.LoadBitmap(IDB_ENVELOPE);
	m_bmEnvelopeOver.LoadBitmap(IDB_ENVELOPE_OVER);
	m_bmEnvelopeSelected.LoadBitmap(IDB_ENVELOPE_SELECTED);
	m_bmPoint.LoadBitmap(IDB_POINT);
	m_bmControl.LoadBitmap(IDB_CONTROL);
	m_bmControlSelected.LoadBitmap(IDB_CONTROL_SELECTED);
	m_bmPointSelected.LoadBitmap(IDB_POINT_SELECTED);

	m_bmScrollboxLeft.LoadBitmap(IDB_SCROLLBOX_LEFT);
	m_bmScrollboxRight.LoadBitmap(IDB_SCROLLBOX_RIGHT);
	m_bmScrollboxMid.LoadBitmap(IDB_SCROLLBOX_MID);

	BITMAP bmInfo;
	m_bmEnvelope.GetBitmap(&bmInfo);

	CWinApp * pApp = AfxGetApp();

	m_hcMoveSplit = pApp->LoadCursor(IDC_MOVESPLIT);
	m_hcDelete = pApp->LoadCursor(IDC_DELETE);
	m_hcSustainStart = pApp->LoadCursor(IDC_SUSTAIN_START);
	m_hcSustainEnd = pApp->LoadCursor(IDC_SUSTAIN_END);

	CRect rWindow;
	CRect rClient;
	this->GetWindowRect(rWindow);
	this->GetClientRect(rClient);

	// calculate the difference to determine the best size
	int iWindowExtraWidth = rWindow.Width() - rClient.Width();
	int iWindowExtraHeight = rWindow.Height() - rClient.Height();

	int iWindowWidth = bmInfo.bmWidth + iWindowExtraWidth;
	int iWindowHeight = bmInfo.bmHeight + iWindowExtraHeight;

	this->SetWindowPos(NULL,0,0,iWindowWidth, iWindowHeight, SWP_NOZORDER | SWP_NOMOVE );

	this->SetIcon(::LoadIcon(::AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_SNAKE)),FALSE);

	return 0;
}

void CEnvelopeWindow::PointToClient(float fV, double fT, float * fX, float * fY )
{
	float fValueRange = this->m_fMaximumValue - this->m_fMinimumValue;
	double dTimeRange = this->m_dMaximumTime - this->m_dMinimumTime;

	int iVertRange = m_rectWorkspace.Height() - (PADDING * 2);
	int iHorizRange = m_rectWorkspace.Width() - (PADDING * 2);

	int iBottom = m_rectWorkspace.bottom - PADDING;
	int iLeft = m_rectWorkspace.left + PADDING;

	*fY = (((fV - m_fMinimumValue) / fValueRange)
		* (-iVertRange)) + iBottom;

	*fX = (float)(((fT - m_dMinimumTime) / dTimeRange)
		* (iHorizRange)) + iLeft;


}

void CEnvelopeWindow::ClientToPoint(float fX, float fY, float * fV, double * fT )
{
	float fValueRange = this->m_fMaximumValue - this->m_fMinimumValue;
	double dTimeRange = this->m_dMaximumTime - this->m_dMinimumTime;

	int iVertRange = m_rectWorkspace.Height() - (PADDING * 2);
	int iHorizRange = m_rectWorkspace.Width() - (PADDING * 2);

	int iBottom = m_rectWorkspace.bottom - PADDING;
	int iLeft = m_rectWorkspace.left + PADDING;

	float v;
	v = fY - iBottom;
	v /= -iVertRange;
	v *= fValueRange;
	v += m_fMinimumValue;
	*fV = v;

	double t;
	t = fX - iLeft;
	t /= iHorizRange;
	t *= dTimeRange;
	t += m_dMinimumTime;
	*fT = t;


}

void CEnvelopeWindow::CalculatePointLocation(CSerpentEnvelopePoint p, float * fX, float * fY)
{
	PointToClient(p.v, p.t, fX, fY);

}

bool CEnvelopeWindow::IsClose(CSerpentEnvelopePoint p, int iX, int iY)
{
	float fXDist, fYDist;
	float fX, fY;

	CalculatePointLocation(p, &fX, &fY);

	fXDist = (iX - fX); fXDist *= fXDist;
	fYDist = (iY - fY); fYDist *= fYDist;

	if( (fXDist <= 9) && (fYDist <= 9) )	// Does this need tweaking?
	{
		return true;
	}

	return false;

}

// Find a control point
// Note that this is intentionally NOT a "find nearest point"
// There is a bias towards bezier end points rather than control points
CSerpentEnvelopePoint * CEnvelopeWindow::FindPoint(int xClient, int yClient, CSerpentEnvelopePoint ** ppPreviousPoint, CSerpentEnvelopePoint ** ppNextPoint, CSerpentEnvelope ** ppEnvelope)
{
	// uses client coordinates

	CSerpentEnvelope * pCurrentEnvelope;

	pCurrentEnvelope = this->m_pEnvelope;
	if(pCurrentEnvelope == NULL) return NULL;

	CSerpentEnvelopePoint * pPoint;

	*ppPreviousPoint = NULL;
	*ppNextPoint = NULL;

	CSerpentEnvelopePoint * pFoundPoint = NULL;

	if(ppEnvelope)
	{
		*ppEnvelope = NULL;
	}

	do
	{
		// first point
		// prev will be last c2, or null
		// next will be c1
		pPoint =  &(pCurrentEnvelope->env.p1);
		if(IsClose(*pPoint,xClient,yClient)) 
		{
			pFoundPoint = pPoint;
			*ppNextPoint = &(pCurrentEnvelope->env.c1);
			break;
		}

		// second point (p2) 
		// prev will be last c2
		// next will be NULL
		// Only checked if this is the last envelope
		if(!pCurrentEnvelope->pNextEnvelope)
		{
			pPoint =  &(pCurrentEnvelope->env.p2);

			if(IsClose(*pPoint,xClient,yClient)) 
			{
				pFoundPoint = pPoint;
				*ppNextPoint = NULL;
				*ppPreviousPoint = &(pCurrentEnvelope->env.c2);

				break;
			}
		}

		// First control
		// last will be p1
		// next will be c2
		pPoint =  &(pCurrentEnvelope->env.c1);
		if(IsClose(*pPoint,xClient,yClient)) 
		{
			pFoundPoint = pPoint;
			*ppNextPoint = &(pCurrentEnvelope->env.c2);
			*ppPreviousPoint = &(pCurrentEnvelope->env.p1);
			break;
		}


		// second control
		// last will be c1
		// next will be p2 or next->p1
		pPoint =  &(pCurrentEnvelope->env.c2);
		if(IsClose(*pPoint,xClient,yClient)) 
		{
			pFoundPoint = pPoint;
			if(pCurrentEnvelope->pNextEnvelope)
			{
				*ppNextPoint = &(pCurrentEnvelope->pNextEnvelope->env.p1);
			} else {
				*ppNextPoint = &(pCurrentEnvelope->env.p2);;
			}

			*ppPreviousPoint = &(pCurrentEnvelope->env.c1);

			break;
		}

		*ppPreviousPoint = pPoint;

		pCurrentEnvelope = pCurrentEnvelope->pNextEnvelope;

	} while (pCurrentEnvelope);

	if(ppEnvelope)
	{
		*ppEnvelope = pCurrentEnvelope;
	}

	return pFoundPoint;

}

void CEnvelopeWindow::Redraw()
{
	RedrawOffscreen();
	Invalidate(FALSE);
}



void CEnvelopeWindow::OnLButtonDown(UINT nFlags, CPoint point)
{

	m_pntMousePos.SetPoint(point.x, point.y);
	this->m_iMouseX = point.x;
	this->m_iMouseY = point.y;


	// if somebody clicked on the workspace
	if(m_rectWorkspace.PtInRect(point))
	{
		CSerpentEnvelope * pFoundEnvelope = NULL;
		// Determine which point was clicked on
		CSerpentEnvelopePoint * pEnvelopePoint = FindPoint(point.x, point.y, &m_psepPrevious, &m_psepNext, &pFoundEnvelope);

		m_psepSelected = pEnvelopePoint;

		if(pEnvelopePoint && pFoundEnvelope)
		{
			// found a point. check what to do with it
			if(m_bDeleting)
			{
				// if this isn't a start or end point, and its not a control
				if(m_psepPrevious && m_psepNext && pFoundEnvelope->pPrevEnvelope && !(m_psepSelected->flags & SEP_FLAGS_CONTROL) )
				{
					CSingleLock sl(&m_serpent->csEnvelopes, TRUE);

					// then delete it
					// all non-starting spans are assigned with new,
					// so actually delete-delete it
					pFoundEnvelope->pPrevEnvelope->pNextEnvelope = pFoundEnvelope->pNextEnvelope;

					// set up the points so it appears only the point is being deleted, not
					// the entire span
					pFoundEnvelope->pPrevEnvelope->env.p2 = pFoundEnvelope->env.p2;
					pFoundEnvelope->pPrevEnvelope->env.c2 = pFoundEnvelope->env.c2;
					delete pFoundEnvelope;

					m_pEnvelope->UpdateEnvelopeDetails();

					sl.Unlock();

				}

			} else if(m_bSustainStart)
			{
				// must be a point, not a control
				if(!(m_psepSelected->flags & SEP_FLAGS_CONTROL))
				{
					CSerpentEnvelopePoint * pEndPoint = this->m_pEnvelope->GetSustainEnd();
					// if there was no end point, or if it is after the selected point
					if(!pEndPoint || m_psepSelected->t <= pEndPoint->t)
					{
						// clear flags
						this->m_pEnvelope->ClearFlags(SEP_FLAGS_SUSTAIN_START);
						m_psepSelected->flags |= SEP_FLAGS_SUSTAIN_START;
					}
				}
			} else if(m_bSustainEnd)
			{

				// must be a point, not a control
				if(!(m_psepSelected->flags & SEP_FLAGS_CONTROL))
				{
					CSerpentEnvelopePoint * pStartPoint = this->m_pEnvelope->GetSustainStart();

					// if there was no start point, or if it is before the selected point
					if(!pStartPoint || m_psepSelected->t >= pStartPoint->t)
					{
						// clear flags
						this->m_pEnvelope->ClearFlags(SEP_FLAGS_SUSTAIN_END);
						m_psepSelected->flags |= SEP_FLAGS_SUSTAIN_END;
					}
				}
			} else {
				// not deleting or setting sustain points
				// moving then
				m_bDragging = true;
				if(m_psepPrevious)
				{
					m_dPrevTimeOffset = m_psepSelected->t - m_psepPrevious->t;
					m_fPrevValueOffset = m_psepSelected->v - m_psepPrevious->v;
				}

				if(m_psepNext)
				{
					m_dNextTimeOffset = m_psepSelected->t - m_psepNext->t;
					m_fNextValueOffset = m_psepSelected->v - m_psepNext->v;
				}

				// start capture
				this->SetCapture();
			}

		} else {

			// no point found
			// try to do a split instead

			m_bCutting = true;

			// start capture
			this->SetCapture();
		}

		Redraw();
	} else if(m_rectScrollBox.PtInRect(point))
	{
		// scroll box
		m_bDraggingBox = true;

		// start capture
		this->SetCapture();
	}
	else if(m_rectStereoLeft.PtInRect(point))
	{
		// clicked on the left link
		// unlink stereo
		m_bStereoLeft = true;

		m_pEnvelopeLeft->bLinked = false;
		m_pEnvelopeRight->bLinked = false;

		m_pEnvelope = m_pEnvelopeLeft;
		m_psepSelected = NULL;

	} else if(m_rectStereoRight.PtInRect(point))
	{
		// clicked on the right link
		m_bStereoLeft = false;

		m_pEnvelopeLeft->bLinked = false;
		m_pEnvelopeRight->bLinked = false;

		m_pEnvelope = m_pEnvelopeRight;

		m_psepSelected = NULL;

	} else if(m_rectStereoLinked.PtInRect(point))
	{
		// clicked on the linked link
		if( m_pEnvelopeLeft->bLinked )
		{			
			m_pEnvelopeLeft->bLinked = false;
			m_pEnvelopeRight->bLinked = false;

		} else {

			m_pEnvelopeLeft->bLinked = true;
			m_pEnvelopeRight->bLinked = true;

			m_pEnvelope = this->m_pEnvelopeLeft;

			m_psepSelected = NULL;
		}
	} else if(m_rectDeleteTool.PtInRect(point))
	{
		if( m_bDeleting )
		{
			m_bDeleting = false;
		} else {
			m_bDeleting = true;
			m_bSustainStart = m_bSustainEnd = false;
		}
	} else if(m_rectMoveTool.PtInRect(point))
	{
		if( m_bDeleting || m_bSustainStart || m_bSustainEnd )
		{
			m_bDeleting = m_bSustainStart = m_bSustainEnd = false;
		}
	} else if(m_rectSusStartTool.PtInRect(point))
	{
		if(m_bSustainStart)
		{
			m_bSustainStart = false;
		} else {
			m_bSustainStart = true;
			m_bDeleting = m_bSustainEnd = false;
		}
	} else if(m_rectSusEndTool.PtInRect(point))
	{
		if(m_bSustainEnd)
		{
			m_bSustainEnd = false;
		} else {
			m_bDeleting = m_bSustainStart = m_bSustainEnd = false;
			m_bSustainEnd = true;
		}
	}
	// time display
	else if(this->m_rectHalfSecond.PtInRect(point))
	{
		m_dDisplayLength = 0.5;
	} else if(this->m_rectTwoSecond.PtInRect(point))
	{
		m_dDisplayLength = 2.0;
	} else if(this->m_rectFiveSecond.PtInRect(point))
	{
		m_dDisplayLength = 5.0;
	} else if(this->m_rectTenSecond.PtInRect(point))
	{
		m_dDisplayLength = 10.0;
	} else if(this->m_rectScrollRight.PtInRect(point))
	{
		m_dMinimumTime += m_dDisplayLength * 0.2;
	} else if(this->m_rectScrollLeft.PtInRect(point))
	{
		if(m_dMinimumTime > 0.0)
		{
			m_dMinimumTime -= m_dDisplayLength * 0.2;
		}
	} 
	// grid
	else if(this->m_rectGrid.PtInRect(point))
	{
		m_bGrid = !m_bGrid;
	} else if(m_rectSnap.PtInRect(point))
	{
		m_bSnap = !m_bSnap;
	}


	m_dMaximumTime = m_dMinimumTime + m_dDisplayLength;

	double dMaxTime = this->m_pEnvelope->GetLastTime();
	dMaxTime *= 1.2;

	if(dMaxTime < m_dDisplayLength)
	{
		m_dMinimumTime = 0.0;
		m_dMaximumTime = m_dDisplayLength;
	}

	if((m_dMaximumTime) > (dMaxTime))
	{
		this->m_dMaximumTime = dMaxTime;
		this->m_dMinimumTime = m_dMaximumTime - m_dDisplayLength;
		if(m_dMinimumTime < 0.0) m_dMinimumTime = 0.0;
		m_dMaximumTime = m_dMinimumTime + m_dDisplayLength;
	}

	Redraw();

	CWnd::OnLButtonDown(nFlags, point);
}

void CEnvelopeWindow::OnLButtonUp(UINT nFlags, CPoint point)
{	
	m_bDragging = false;

	m_pntMousePos.SetPoint(point.x, point.y);
	this->m_iMouseX = point.x;
	this->m_iMouseY = point.y;

	::ReleaseCapture();

	m_bDraggingBox = false;

	if(m_bCutting)
	{
		double dNewTime;
		float fNewValue;
		CSerpentEnvelope * envSplitEnvelope;
		double dU;

		// only cut if the mouse was dragged inside the box
		if(point.x > this->m_rectWorkspace.left && point.x < this->m_rectWorkspace.right)
		{
			// lock the envelopes
			CSingleLock sl(&m_serpent->csEnvelopes, TRUE);

			this->ClientToPoint((float)point.x, (float)point.y, &fNewValue, &dNewTime);
			dU = this->m_serpent->FindUFromT(this->m_pEnvelope,dNewTime,&envSplitEnvelope);

			if(envSplitEnvelope)
			{

				envSplitEnvelope->Split(dU);
			}

			// unlock em
			sl.Unlock();
		}

		m_bCutting = false;
	} 

	Redraw();

	CWnd::OnLButtonUp(nFlags, point);
}

#define MID_SUSTAIN_START (0)
#define MID_SUSTAIN_END (10)
#define MID_DELETE (20)


void CEnvelopeWindow::OnRButtonUp(UINT nFlags, CPoint point)
{
	CWnd::OnRButtonUp(nFlags, point);
}

void CEnvelopeWindow::OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu)
{
	CWnd::OnMenuSelect(nItemID, nFlags, hSysMenu);
}
