#pragma once


// CEnvelopeWindow

#define NUM_ENVELOPE_RECTS (16)

class CEnvelopeWindow : public CWnd
{
	DECLARE_DYNAMIC(CEnvelopeWindow)

public:
	CEnvelopeWindow();
	virtual ~CEnvelopeWindow();

	CSerpentEnvelope * m_pEnvelope;
	CSerpentEnvelope * m_pEnvelopeLeft;
	CSerpentEnvelope * m_pEnvelopeRight;

	mi * m_serpent;

	int m_iTimeDivisions;
	int m_iValueDivisions;

	float m_fMinimumValue;
	float m_fMaximumValue;

	double m_dMinimumTime;
	double m_dMaximumTime;
	double m_dDisplayLength;

	bool m_bStereoLeft;


protected:

	POINT points[3];

	CPoint m_pntMousePos;
	int m_iMouseX;
	int m_iMouseY;

	bool m_bDragging;
	bool m_bCutting;
	bool m_bDeleting;
	bool m_bSustainStart;
	bool m_bSustainEnd;

	bool m_bMouseOverBox;
	bool m_bDraggingBox;

	CBitmap m_bmEnvelope;
	CBitmap m_bmEnvelopeSelected;
	CBitmap m_bmEnvelopeOver;
	CBitmap m_bmPoint;
	CBitmap m_bmControl;
	CBitmap m_bmControlSelected;
	CBitmap m_bmPointSelected;

	CBitmap m_bmScrollboxLeft;
	CBitmap m_bmScrollboxRight;
	CBitmap m_bmScrollboxMid;

	CBitmap m_bmWorkspace;
	CBitmap m_bmOffscreen;
	bool m_bOffscreenInitialised;

	HCURSOR m_hcMoveSplit;
	HCURSOR m_hcDelete;
	HCURSOR m_hcSustainStart;
	HCURSOR m_hcSustainEnd;

	CRect m_rectHalfSecond;
	CRect m_rectTwoSecond;
	CRect m_rectFiveSecond;
	CRect m_rectTenSecond;

	CRect m_rectMoveTool;
	CRect m_rectDeleteTool;
	CRect m_rectSusStartTool;
	CRect m_rectSusEndTool;

	CRect m_rectGrid;
	CRect m_rectSnap;

	bool m_bGrid;
	bool m_bSnap;



	CRect m_rectScrollLeft;
	CRect m_rectScrollRight;

	CRect m_rectScrollBox;
	CRect m_rectScrollTrack;

	

	CRect m_rectWorkspace;

	CRect m_rectTimeTicksTop;
	CRect m_rectTimeTicksBottom;

	CRect m_rectValueTicksLeft;
	CRect m_rectValueTicksRight;

	CRect m_rectTimeFeedback;
	CRect m_rectValueFeedback;

	CRect m_rectValuesLeft;
	CRect m_rectTimeBottom;

	CRect m_rectStereoLeft;
	CRect m_rectStereoRight;
	CRect m_rectStereoLinked;

	CRect * m_pSelectedRect;
	CRect m_allRects[NUM_ENVELOPE_RECTS];

	CSerpentEnvelopePoint * m_psepSelected;
	CSerpentEnvelopePoint * m_psepPrevious;
	CSerpentEnvelopePoint * m_psepNext;

	double m_dPrevTimeOffset;
	double m_dNextTimeOffset;
	float m_fPrevValueOffset;
	float m_fNextValueOffset;

	CMenu m_muContextPoint;


	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);

	void CalculatePointLocation(CSerpentEnvelopePoint p, float * pX, float * pY);
	CSerpentEnvelopePoint * FindPoint(int xClient, int yClient, CSerpentEnvelopePoint ** ppPreviousPoint, CSerpentEnvelopePoint ** ppNextPoint, CSerpentEnvelope ** ppEnvelope = NULL);
	bool IsClose(CSerpentEnvelopePoint p, int iX, int iY);

	void SnapPoint(CSerpentEnvelopePoint * p);

	double SnapTime(double dTime, bool bGrid);
	float SnapValue(float fValue);	

	void PointToClient(float fV, double fT, float * fX, float * fY );
	void ClientToPoint(float fX, float fY, float * fV, double * fT );

	void DrawWorkspace(CDC &dc, CDC &dcBltSrc);
	void DrawBezier(CDC &dcWorkspace, CDC & dcBltSrc, CSerpentEnvelope * pCurrentEnvelope, int iVertRange, int iHorizRange, int iBottom, int iLeft, int SUPERSAMPLING, bool bDrawControls);

	void RedrawOffscreen();
	void RedrawWorkspace();
	void Redraw();

	void RedrawOverlays();
	void CopyBackgroundToScreen();


	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu);
};


