// RoutingWindow.cpp : implementation file
//

#include "stdafx.h"
#include "kibibu Serpent.h"
#include "../MDK/mdk.h"
#include "RoutingWindow.h"
#include "EnvelopeWindow.h"
#include "SavePresetDialog.h"




// CRoutingWindow

IMPLEMENT_DYNAMIC(CRoutingWindow, CWnd)
CRoutingWindow::CRoutingWindow()
{

	m_pntMousePos.SetPoint(-1,-1);

	int iRects = 0;

	int l = 11;
	int r = 42;
	// load and save buttons
	m_rectLoad.SetRect(l, 32, r, 47); m_allRects[iRects++] = m_rectLoad;
	m_rectSave.SetRect(l, 48, r, 63); m_allRects[iRects++] = m_rectSave;
	
	// Centre buttons
	l = 107;
	r = 185;

	m_rectNote1Note2.SetRect(l, 45, r, 66);
	m_allRects[iRects++] = m_rectNote1Note2;

	m_rectOctaveShift.SetRect(l, 73, r, 94);
	m_allRects[iRects++] = m_rectOctaveShift;

	m_rectFMPitch.SetRect(l, 101, r, 122);
	m_allRects[iRects++] = m_rectFMPitch;

	m_rectFMWaveformSine.SetRect(117,147,125,153);
	m_allRects[iRects++] = m_rectFMWaveformSine;

	m_rectFMWaveformSaw.SetRect(127,147,135,153);
	m_allRects[iRects++] = m_rectFMWaveformSaw;

	m_rectFMWaveformSquare.SetRect(137,147,145,153);
	m_allRects[iRects++] = m_rectFMWaveformSquare;

	m_rectFMWaveformTriangle.SetRect(147,147,155,153);
	m_allRects[iRects++] = m_rectFMWaveformTriangle;

	m_rectFMWaveformNoise1.SetRect(157,147,165,153);
	m_allRects[iRects++] = m_rectFMWaveformNoise1;

	m_rectFMWaveformNoise2.SetRect(167,147,175,153);
	m_allRects[iRects++] = m_rectFMWaveformNoise2;

	m_rectAmp.SetRect(l,395,r,416);
	m_allRects[iRects++] = m_rectAmp;

	// Oscillator 2
	m_rectFMOsc2.SetRect(l, 164, r, 185);
	m_allRects[iRects++] = m_rectFMOsc2;

	m_rectOsc2Pitch.SetRect(l, 192, r, 213);
	m_allRects[iRects++] = m_rectOsc2Pitch;

	m_rectOsc2WaveformSine.SetRect(117,238,125,244);
	m_allRects[iRects++] = m_rectOsc2WaveformSine;

	m_rectOsc2WaveformSaw.SetRect(127,238,135,244);
	m_allRects[iRects++] = m_rectOsc2WaveformSaw;

	m_rectOsc2WaveformSquare.SetRect(137,238,145,244);
	m_allRects[iRects++] = m_rectOsc2WaveformSquare;

	m_rectOsc2WaveformTriangle.SetRect(147,238,155,244);
	m_allRects[iRects++] = m_rectOsc2WaveformTriangle;

	m_rectOsc2WaveformNoise1.SetRect(157,238,165,244);
	m_allRects[iRects++] = m_rectOsc2WaveformNoise1;

	m_rectOsc2WaveformNoise2.SetRect(167,238,175,244);
	m_allRects[iRects++] = m_rectOsc2WaveformNoise2;

	m_rectOsc2Amp.SetRect(l,255,r,276);
	m_allRects[iRects++] = m_rectOsc2Amp;

	// Clip
	m_rectClipLevel.SetRect(l, 283, r, 304);
	m_allRects[iRects++] = m_rectClipLevel;

	// Left buttons
	l = 24;
	r = 102;
	m_rectFMOsc1.SetRect(l, 164, r, 185);
	m_allRects[iRects++] = m_rectFMOsc1;
	m_rectOsc1Pitch.SetRect(l, 192, r, 213);
	m_allRects[iRects++] = m_rectOsc1Pitch;
	m_rectOsc1WaveformSine.SetRect(34,238,42,244);
	m_allRects[iRects++] = m_rectOsc1WaveformSine;
	m_rectOsc1WaveformSaw.SetRect(44,238,52,244);
	m_allRects[iRects++] = m_rectOsc1WaveformSaw;
	m_rectOsc1WaveformSquare.SetRect(54,238,62,244);
	m_allRects[iRects++] = m_rectOsc1WaveformSquare;
	m_rectOsc1WaveformTriangle.SetRect(64,238,72,244);
	m_allRects[iRects++] = m_rectOsc1WaveformTriangle;
	m_rectOsc1WaveformNoise1.SetRect(74,238,82,244);
	m_allRects[iRects++] = m_rectOsc1WaveformNoise1;
	m_rectOsc1WaveformNoise2.SetRect(84,238,92,244);
	m_allRects[iRects++] = m_rectOsc1WaveformNoise2;
	m_rectOsc1Amp.SetRect(l,255,r,276);
	m_allRects[iRects++] = m_rectOsc1Amp;


	// right buttons
	l=190;
	r=267;
	m_rectFMOsc3.SetRect(l, 164, r, 185);
	m_allRects[iRects++] = m_rectFMOsc3;
	m_rectOsc3Pitch.SetRect(l, 192, r, 213);
	m_allRects[iRects++] = m_rectOsc3Pitch;
	m_rectOsc3WaveformSine.SetRect(200,238,208,244);
	m_allRects[iRects++] = m_rectOsc3WaveformSine;
	m_rectOsc3WaveformSaw.SetRect(210,238,218,244);
	m_allRects[iRects++] = m_rectOsc3WaveformSaw;
	m_rectOsc3WaveformSquare.SetRect(220,238,228,244);
	m_allRects[iRects++] = m_rectOsc3WaveformSquare;
	m_rectOsc3WaveformTriangle.SetRect(230,238,238,244);
	m_allRects[iRects++] = m_rectOsc3WaveformTriangle;
	m_rectOsc3WaveformNoise1.SetRect(240,238,248,244);
	m_allRects[iRects++] = m_rectOsc3WaveformNoise1;
	m_rectOsc3WaveformNoise2.SetRect(250,238,258,244);
	m_allRects[iRects++] = m_rectOsc3WaveformNoise2;
	m_rectOsc3Amp.SetRect(l,255,r,276);
	m_allRects[iRects++] = m_rectOsc3Amp;

	
	// filters
	int t = 315;
	int b = 327;
	m_rectFilter1Cutoff.SetRect(117,t,144,b);
	m_allRects[iRects++] = m_rectFilter1Cutoff;
	m_rectFilter1Res.SetRect(147,t,162,b);
	m_allRects[iRects++] = m_rectFilter1Res;
	m_rectFilter1LP.SetRect(165,t,179,b);
	m_allRects[iRects++] = m_rectFilter1LP;
	m_rectFilter1HP.SetRect(182,t,198,b);
	m_allRects[iRects++] = m_rectFilter1HP;
	m_rectFilter1BP.SetRect(201,t,217,b);
	m_allRects[iRects++] = m_rectFilter1BP;


	t = 343;
	b = 355;
	m_rectFilter2Cutoff.SetRect(164,t,191,b);
	m_allRects[iRects++] = m_rectFilter2Cutoff;
	m_rectFilter2Res.SetRect(194,t,209,b);
	m_allRects[iRects++] = m_rectFilter2Res;
	m_rectFilter2LP.SetRect(212,t,226,b);
	m_allRects[iRects++] = m_rectFilter2LP;
	m_rectFilter2HP.SetRect(229,t,245,b);
	m_allRects[iRects++] = m_rectFilter2HP;
	m_rectFilter2BP.SetRect(248,t,264,b);
	m_allRects[iRects++] = m_rectFilter2BP;

	
	t = 371;
	b = 383;
	m_rectFilter3Cutoff.SetRect(67,t,94,b);
	m_allRects[iRects++] = m_rectFilter3Cutoff;
	m_rectFilter3Res.SetRect(97,t,112,b);
	m_allRects[iRects++] = m_rectFilter3Res;
	m_rectFilter3LP.SetRect(115,t,129,b);
	m_allRects[iRects++] = m_rectFilter3LP;
	m_rectFilter3HP.SetRect(132,t,148,b);
	m_allRects[iRects++] = m_rectFilter3HP;
	m_rectFilter3BP.SetRect(151,t,167,b);
	m_allRects[iRects++] = m_rectFilter3BP;

	

}

CRoutingWindow::~CRoutingWindow()
{
}

#define ID_LOAD_ITEM 1

BEGIN_MESSAGE_MAP(CRoutingWindow, CWnd)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
END_MESSAGE_MAP()

BOOL CRoutingWindow::OnCommand( WPARAM wParam, LPARAM lParam)
{
	
	CString * pStringData = this->saMenuItems.GetData();

	if(!pStringData)
	{
		return CWnd::OnCommand(wParam, lParam);
	}

	int iMenuSelection = LOWORD(wParam);

	if(iMenuSelection >= 0xFFFF)
	{
		return CWnd::OnCommand(wParam, lParam);
	}


	CString * pSelectedString = pStringData + iMenuSelection;

	// got one

	// BUZZ SPECIFIC STUFF
	LPSTR sPath = ::GetCommandLine();
	TCHAR szBaseDirectory[MAX_PATH];
	TCHAR szFullDirectory[MAX_PATH + 1];

	szBaseDirectory[MAX_PATH - 1] = '\0';
	szFullDirectory[MAX_PATH] = '\0';

	_tcsncpy(szBaseDirectory,sPath, min(_tcsclen(sPath) + 1,MAX_PATH - 1));

	CString szSub = "Gear\\Generators\\Serpent Presets";

	::PathRemoveFileSpec(szBaseDirectory);

	::PathCombine(szFullDirectory, szBaseDirectory, szSub);
	_tcsncat(szFullDirectory, "\"", MAX_PATH - _tcslen(szFullDirectory));
	StrTrim(szFullDirectory,"\"");

	::PathCombine(szFullDirectory, szFullDirectory, *pSelectedString);

	CSerpentDataInput sdi(szFullDirectory);

	this->m_serpent->SerpentLoad(&sdi);

	return 0;
	
}




afx_msg void CRoutingWindow::OnPaint(void)
{
	CPaintDC dc(this);
	CDC dcBltSrc;
	dcBltSrc.CreateCompatibleDC(&dc);

	BITMAP bmInfo;
	m_bmRouting.GetBitmap(&bmInfo);
	
	CBitmap * pOldBitmap = dcBltSrc.SelectObject(&m_bmRouting);

	dc.BitBlt(0, 0, bmInfo.bmWidth, bmInfo.bmHeight,&dcBltSrc,0,0,SRCCOPY);

	
	// go through all the rects, and if the mouse is over any, draw them
	dcBltSrc.SelectObject(&m_bmRoutingOver);

	for(int i = 0; i < NUM_RECTS; i++)
	{
		if(m_allRects[i].PtInRect(m_pntMousePos))
		{			
			dc.BitBlt(m_allRects[i].left, m_allRects[i].top,m_allRects[i].Width(), m_allRects[i].Height(),
				&dcBltSrc,m_allRects[i].left, m_allRects[i].top, SRCCOPY);
		}
	}

	dcBltSrc.SelectObject(&m_bmRoutingSelected);

	// draw selected waveforms
	CRect rectSelected;



	// osc 1
	switch(m_serpent->wtOsc1)
	{
	case sine:
		rectSelected = m_rectOsc1WaveformSine;
		break;
	case saw:
		rectSelected = m_rectOsc1WaveformSaw;
		break;
	case square:
		rectSelected = m_rectOsc1WaveformSquare;
		break;
	case triangle:
		rectSelected = m_rectOsc1WaveformTriangle;
		break;
	case noise1:
		rectSelected = m_rectOsc1WaveformNoise1;
		break;
	case noise2:
		rectSelected = m_rectOsc1WaveformNoise2;
		break;
	}

	dc.BitBlt(
		rectSelected.left, rectSelected.top,
		rectSelected.Width(), rectSelected.Height(),
		&dcBltSrc,
		rectSelected.left,
		rectSelected.top, SRCCOPY);

	// osc 2
	switch(m_serpent->wtOsc2)
	{
	case sine:
		rectSelected = m_rectOsc2WaveformSine;
		break;
	case saw:
		rectSelected = m_rectOsc2WaveformSaw;
		break;
	case square:
		rectSelected = m_rectOsc2WaveformSquare;
		break;
	case triangle:
		rectSelected = m_rectOsc2WaveformTriangle;
		break;
	case noise1:
		rectSelected = m_rectOsc2WaveformNoise1;
		break;
	case noise2:
		rectSelected = m_rectOsc2WaveformNoise2;
		break;
	}

	dc.BitBlt(
		rectSelected.left, rectSelected.top,
		rectSelected.Width(), rectSelected.Height(),
		&dcBltSrc,
		rectSelected.left,
		rectSelected.top, SRCCOPY);

	// osc 3
	switch(m_serpent->wtOsc3)
	{
	case sine:
		rectSelected = m_rectOsc3WaveformSine;
		break;
	case saw:
		rectSelected = m_rectOsc3WaveformSaw;
		break;
	case square:
		rectSelected = m_rectOsc3WaveformSquare;
		break;
	case triangle:
		rectSelected = m_rectOsc3WaveformTriangle;
		break;
	case noise1:
		rectSelected = m_rectOsc3WaveformNoise1;
		break;
	case noise2:
		rectSelected = m_rectOsc3WaveformNoise2;
		break;
	}

	dc.BitBlt(
		rectSelected.left, rectSelected.top,
		rectSelected.Width(), rectSelected.Height(),
		&dcBltSrc,
		rectSelected.left,
		rectSelected.top, SRCCOPY);

	// osc FM
	switch(m_serpent->wtFM)
	{
	case sine:
		rectSelected = m_rectFMWaveformSine;
		break;
	case saw:
		rectSelected = m_rectFMWaveformSaw;
		break;
	case square:
		rectSelected = m_rectFMWaveformSquare;
		break;
	case triangle:
		rectSelected = m_rectFMWaveformTriangle;
		break;
	case noise1:
		rectSelected = m_rectFMWaveformNoise1;
		break;
	case noise2:
		rectSelected = m_rectFMWaveformNoise2;
		break;
	}

	dc.BitBlt(
		rectSelected.left, rectSelected.top,
		rectSelected.Width(), rectSelected.Height(),
		&dcBltSrc,
		rectSelected.left,
		rectSelected.top, SRCCOPY);

	dcBltSrc.SelectObject(pOldBitmap);

}

int CRoutingWindow::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// Load up the bitmaps
	m_bmRouting.LoadBitmap(IDB_ROUTING_BACK);
	m_bmRoutingOver.LoadBitmap(IDB_ROUTING_OVER);
	m_bmRoutingSelected.LoadBitmap(IDB_ROUTING_SELECTED);

	BITMAP bmInfo;
	m_bmRouting.GetBitmap(&bmInfo);

	CRect rWindow;
	CRect rClient;
	this->GetWindowRect(rWindow);
	this->GetClientRect(rClient);

	// calculate the difference to determine the best size
	int iWindowExtraWidth = rWindow.Width() - rClient.Width();
	int iWindowExtraHeight = rWindow.Height() - rClient.Height();

	int iWindowWidth = bmInfo.bmWidth + iWindowExtraWidth;
	int iWindowHeight = bmInfo.bmHeight + iWindowExtraHeight;

	this->SetWindowPos(NULL,0,0,iWindowWidth, iWindowHeight, SWP_NOZORDER    | SWP_NOMOVE );

	this->SetIcon(::LoadIcon(::AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_SNAKE)),FALSE);

	
	return 0;
}

void CRoutingWindow::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	m_pntMousePos = point;	
	
	CWnd::OnMouseMove(nFlags, point);	

	// determine whether or not to invalidate

	CRect * pNewSelection = NULL;

	for(int i = 0; i < NUM_RECTS; i++)
	{
		if(m_allRects[i].PtInRect(m_pntMousePos))
		{
			// found one
			pNewSelection = &(m_allRects[i]);
		}
	}

	if(pNewSelection != m_pSelectedRect)
	{
		this->Invalidate();
		m_pSelectedRect = pNewSelection;
	}
}




void CRoutingWindow::OnLButtonDown(UINT nFlags, CPoint point)
{
	CWnd::OnLButtonDown(nFlags, point);

	for(int i = 0; i < NUM_RECTS; i++)
	{
		if(m_allRects[i].PtInRect(m_pntMousePos))
		{
			// found one
			CRect rFound = m_allRects[i];

			// check load and save
			if(rFound == m_rectLoad || rFound == m_rectSave)
			{

				// popup a menu listing items in the proper dir

				// BUZZ SPECIFIC
				LPSTR sPath = ::GetCommandLine();
				TCHAR szBaseDirectory[MAX_PATH];
				TCHAR szFullDirectory[MAX_PATH + 1];

				szBaseDirectory[MAX_PATH - 1] = '\0';
				szFullDirectory[MAX_PATH] = '\0';

				_tcsncpy(szBaseDirectory,sPath, min(_tcsclen(sPath) + 1,MAX_PATH - 1));

				CString szSub = "Gear\\Generators\\Serpent Presets";

				::PathRemoveFileSpec(szBaseDirectory);

				::PathCombine(szFullDirectory, szBaseDirectory, szSub);
				_tcsncat(szFullDirectory, "\"", MAX_PATH - _tcslen(szFullDirectory));
				StrTrim(szFullDirectory,"\"");
				

				// create the directory
				if(! ::CreateDirectory(szFullDirectory, NULL) )
				{
					// create directory failed
					DWORD dwErr = ::GetLastError();

					// if the error wasn't simply that the dir exists already
					if(dwErr != 183)
					{
						CString sErr;
						sErr.Format("Creating Serpent Preset Directory Failed: Error %d", dwErr); 
						AfxMessageBox(sErr,MB_OK,0);
						return;
					}
				}

				// now either read or create
				// if reading
				if(rFound == m_rectLoad)
				{

					_tcsncpy(szBaseDirectory,szFullDirectory, min(_tcsclen(szFullDirectory) + 1,MAX_PATH - 1));

					szSub = "*.serpent";

					::PathCombine(szFullDirectory, szBaseDirectory, szSub);

					HANDLE hFile;
					WIN32_FIND_DATA fd;
					hFile = ::FindFirstFile(szFullDirectory, &fd);
					BOOL bFinished = (hFile == INVALID_HANDLE_VALUE);

					CMenu popupMenu;
					if(!popupMenu.CreatePopupMenu()) return;

					saMenuItems.RemoveAll();

					int i = 0;

					popupMenu.AppendMenu(MF_STRING, (UINT_PTR)-1, "- Cancel -");

					while(!bFinished)
					{
						saMenuItems.Add(fd.cFileName);
						::PathRemoveExtension(fd.cFileName);
						popupMenu.AppendMenu(MF_STRING, i++, fd.cFileName);

						bFinished = !::FindNextFile(hFile, &fd);
					}

					CPoint pntMenuOrigin;
					pntMenuOrigin.SetPoint(m_rectLoad.right, m_rectLoad.top);

					this->ClientToScreen(&pntMenuOrigin);

					popupMenu.TrackPopupMenu(TPM_LEFTALIGN, 
						pntMenuOrigin.x, pntMenuOrigin.y,this);

					popupMenu.DestroyMenu();

					return;
				} else {
					// writing
					// display a save box
					CSavePresetDialog spd;

					if(spd.DoModal() == IDOK)
					{
						if(spd.m_sPresetName.GetLength() > 0)
						{
							// valid preset name
							// create the file
							CString szFileName = spd.m_sPresetName + ".serpent";
							::PathCombine(szFullDirectory, szFullDirectory, szFileName);
							HANDLE hFile = ::CreateFile(szFullDirectory, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
							if(hFile != INVALID_HANDLE_VALUE)
							{
								// if the user doesn't click "Yes" to overwrite
								if(AfxMessageBox("File Exists. Overwrite?", MB_YESNO | MB_APPLMODAL | MB_ICONEXCLAMATION, 0) != IDYES)
								{
									// leave
									::CloseHandle(hFile);
									return;
								}
							}

							::CloseHandle(hFile);

							CSerpentDataOutput * sdo = new CSerpentDataOutput(szFullDirectory);
							m_serpent->SerpentSave(sdo);
							delete sdo;
							

						} else {
							// invalid preset name
							AfxMessageBox("No preset name entered. Preset NOT saved.");
						}
					}
					
					return;

				}
			} 

			// first check all the waveform rects
			// oscillator 1
			if(rFound == m_rectOsc1WaveformSine)
			{
				m_serpent->wtOsc1 = sine;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc1WaveformSaw)
			{
				m_serpent->wtOsc1 = saw;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc1WaveformSquare)
			{
				m_serpent->wtOsc1 = square;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc1WaveformTriangle)
			{
				m_serpent->wtOsc1 = triangle;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc1WaveformNoise1)
			{
				m_serpent->wtOsc1 = noise1;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc1WaveformNoise2)
			{
				m_serpent->wtOsc1 = noise2;
				Invalidate(FALSE);	return;
			}

			// oscillator 2
			else if(rFound == m_rectOsc2WaveformSine)
			{
				m_serpent->wtOsc2 = sine;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc2WaveformSaw)
			{
				m_serpent->wtOsc2 = saw;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc2WaveformSquare)
			{
				m_serpent->wtOsc2 = square;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc2WaveformTriangle)
			{
				m_serpent->wtOsc2 = triangle;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc2WaveformNoise1)
			{
				m_serpent->wtOsc2 = noise1;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc2WaveformNoise2)
			{
				m_serpent->wtOsc2 = noise2;
				Invalidate(FALSE);	return;
			}

			// oscillator 3
			else if(rFound == m_rectOsc3WaveformSine)
			{
				m_serpent->wtOsc3 = sine;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc3WaveformSaw)
			{
				m_serpent->wtOsc3 = saw;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc3WaveformSquare)
			{
				m_serpent->wtOsc3 = square;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc3WaveformTriangle)
			{
				m_serpent->wtOsc3 = triangle;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc3WaveformNoise1)
			{
				m_serpent->wtOsc3 = noise1;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectOsc3WaveformNoise2)
			{
				m_serpent->wtOsc3 = noise2;
				Invalidate(FALSE);	return;
			}

			// fm osc
			else if(rFound == m_rectFMWaveformSine)
			{
				m_serpent->wtFM = sine;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectFMWaveformSaw)
			{
				m_serpent->wtFM = saw;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectFMWaveformSquare)
			{
				m_serpent->wtFM = square;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectFMWaveformTriangle)
			{
				m_serpent->wtFM = triangle;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectFMWaveformNoise1)
			{
				m_serpent->wtFM = noise1;
				Invalidate(FALSE);	return;
			} else if(rFound == m_rectFMWaveformNoise2)
			{
				m_serpent->wtFM = noise2;
				Invalidate(FALSE);	return;
			}


			// display the envelope window
			CEnvelopeWindow * ew = new CEnvelopeWindow();
			RECT rSize;
			RECT rMySize;
			this->GetWindowRect(&rMySize);
			rSize.left = rMySize.right + 8;
			rSize.top = rMySize.top;

			rSize.bottom = rMySize.bottom;	// these two are resized anyways
			rSize.right = rMySize.right + 50;

			CString sTitle = "Serpent Envelope: ";

			CString sEnvelope;

			
			// determine which one was clicked
			if(rFound == m_rectNote1Note2)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envNote1ToNote2_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envNote1ToNote2_R);
				sEnvelope = "Note1 -> Note2";

			} else if(rFound == this->m_rectClipLevel)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envClip_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envClip_R);
				sEnvelope = "Clip Level";

			} 
			// Filter 1
			else if(rFound == this->m_rectFilter1BP)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter1BP_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter1BP_R);
				sEnvelope = "Filter 1 Bandpass Out";

			} else if(rFound == this->m_rectFilter1Cutoff)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter1Cut_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter1Cut_R);
				sEnvelope = "Filter 1 Cutoff";
			} else if(rFound == this->m_rectFilter1HP)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter1HP_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter1HP_R);
				sEnvelope = "Filter 1 Highpass Out";

			} else if(rFound == this->m_rectFilter1LP)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter1LP_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter1LP_R);
				sEnvelope = "Filter 1 Lowpass Out";
			} else if(rFound ==this->m_rectFilter1Res)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter1Res_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter1Res_R);
				sEnvelope = "Filter 1 Resonance";
			} 
			
			// Filter 2
			else if(rFound ==this->m_rectFilter2BP)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter2BP_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter2BP_R);
				sEnvelope = "Filter 2 Bandpass Out";

			} else if(rFound ==this->m_rectFilter2Cutoff)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter2Cut_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter2Cut_R);
				sEnvelope = "Filter 2 Cutoff";
			} else if(rFound ==this->m_rectFilter2HP)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter2HP_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter2HP_R);
				sEnvelope = "Filter 2 Highpass Out";

			} else if(rFound ==this->m_rectFilter2LP)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter2LP_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter2LP_R);
				sEnvelope = "Filter 2 Lowpass Out";
			} else if(rFound ==this->m_rectFilter2Res)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter2Res_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter2Res_R);
				sEnvelope = "Filter 2 Resonance";
			} 

			// Filter 3
			else if(rFound ==this->m_rectFilter3BP)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter3BP_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter3BP_R);
				sEnvelope = "Filter 3 Bandpass Out";

			} else if(rFound ==this->m_rectFilter3Cutoff)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter3Cut_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter3Cut_R);
				sEnvelope = "Filter 3 Cutoff";
			} else if(rFound ==this->m_rectFilter3HP)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter3HP_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter3HP_R);
				sEnvelope = "Filter 3 Highpass Out";

			} else if(rFound ==this->m_rectFilter3LP)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter3LP_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter3LP_R);
				sEnvelope = "Filter 3 Lowpass Out";
			} else if(rFound ==this->m_rectFilter3Res)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFilter3Res_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFilter3Res_R);
				sEnvelope = "Filter 3 Resonance";
			} 

			// FM
			else if(rFound ==this->m_rectFMOsc1)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFMOsc1_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFMOsc1_R);
				sEnvelope = "FM -> Oscillator 1";
			} else if(rFound ==this->m_rectFMOsc2)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFMOsc2_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFMOsc2_R);
				sEnvelope = "FM -> Oscillator 2";
			} else if(rFound ==this->m_rectFMOsc3)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFMOsc3_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFMOsc3_R);
				sEnvelope = "FM -> Oscillator 3";
			} else if(rFound ==this->m_rectFMPitch)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envFMPitch_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envFMPitch_R);
				sEnvelope = "FM Pitch";

				ew->m_fMaximumValue = 12.0f;
				ew->m_fMinimumValue = -12.0f;
				ew->m_iValueDivisions = (12 + 12);
			} 
			
			// Oscillators
			else if(rFound ==this->m_rectOsc1Amp)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envAmpOsc1_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envAmpOsc1_R);
				sEnvelope = "Oscillator 1 Amp";
			} else if(rFound ==this->m_rectOsc2Amp)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envAmpOsc2_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envAmpOsc2_R);
				sEnvelope = "Oscillator 2 Amp";
			} else if(rFound ==this->m_rectOsc3Amp)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envAmpOsc3_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envAmpOsc3_R);
				sEnvelope = "Oscillator 3 Amp";
			} else if(rFound ==this->m_rectOsc1Pitch)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envPitchOsc1_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envPitchOsc1_R);
				sEnvelope = "Oscillator 1 Pitch";

				ew->m_fMaximumValue = 12.0f;
				ew->m_fMinimumValue = -12.0f;
				ew->m_iValueDivisions = (12 + 12 );

			} else if(rFound ==this->m_rectOsc2Pitch)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envPitchOsc2_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envPitchOsc2_R);
				sEnvelope = "Oscillator 2 Pitch";

				ew->m_fMaximumValue = 12.0f;
				ew->m_fMinimumValue = -12.0f;
				ew->m_iValueDivisions = (12 + 12 );

			} else if(rFound ==this->m_rectOsc3Pitch)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envPitchOsc3_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envPitchOsc3_R);
				sEnvelope = "Oscillator 3 Pitch";

				ew->m_fMaximumValue = 12.0f;
				ew->m_fMinimumValue = -12.0f;
				ew->m_iValueDivisions = (12 + 12 );

			} 
			// Pitch multiplier
			else if(rFound ==this->m_rectOctaveShift)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envOctaveShift_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envOctaveShift_R);
				sEnvelope = "Octave Shift";
				
				// octaves
				ew->m_fMaximumValue = 2.0f;
				ew->m_fMinimumValue = -2.0f;
				ew->m_iValueDivisions = ( 4 + 4);
			}

			// Final Amp
			else if(rFound ==this->m_rectAmp)
			{
				ew->m_pEnvelopeLeft = &(this->m_serpent->envAmp_L);
				ew->m_pEnvelopeRight = &(this->m_serpent->envAmp_R);
				sEnvelope = "Final Amp";
			}
			
			ew->m_pEnvelope = ew->m_pEnvelopeLeft;

			ew->m_serpent = this->m_serpent;

			LPCTSTR szWndClass = AfxRegisterWndClass(CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ,
				0,
				0,
				0);

			
			if(! ew->CreateEx(
				0,
				szWndClass,
				sTitle + sEnvelope,
				WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU,
				rSize,this,NULL,NULL))
			{
				// broke!
				

			} else {
				// ew->hInstResource = g_hInstance;
				ew->ShowWindow(SW_SHOW);
			}

			return;
		}
	}


	// CWnd::OnLButtonDown(nFlags, point);
}
