// kibibu Serpent.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"

#include "kibibu Serpent.h"
#include "RoutingWindow.h"
#include "SavePresetDialog.h"


#include "../DSPLIB/dsplib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// set up intrinsic functions
#pragma intrinsic( memcpy, fabs, pow )

#pragma optimize("atwpg", on)


// global instance handle
HINSTANCE g_hInstance;

float * mi::ppfSaw[SAMPLE_SETS];
float * mi::ppfSquare[SAMPLE_SETS];
float * mi::ppfTriangle[SAMPLE_SETS];

float mi::pfSineSamples[WAVETABLE_SAMPLES] = {0.0f};
float mi::pfNoise[WAVETABLE_SAMPLES] = {0.0f};
float mi::pfINoise[WAVETABLE_SAMPLES] = {0.0f};

float mi::pfPitch[MAX_WORK_LENGTH] = {0.0f};

float mi::pfFMPitch[MAX_WORK_LENGTH] = {0.0f};
float mi::pfFMOut[MAX_WORK_LENGTH] = {0.0f};

float mi::pfFMOsc[MAX_WORK_LENGTH] = {0.0f};
float mi::pfPitchOsc[MAX_WORK_LENGTH] = {0.0f};
float mi::pfAmpOsc[MAX_WORK_LENGTH] = {0.0f};
float mi::pfOsc1Out[MAX_WORK_LENGTH] = {0.0f};
float mi::pfOsc2Out[MAX_WORK_LENGTH] = {0.0f};
float mi::pfOsc3Out[MAX_WORK_LENGTH] = {0.0f};

float mi::pfClip[MAX_WORK_LENGTH] = {0.0f};

float mi::pfFilterLP[MAX_WORK_LENGTH] = {0.0f};
float mi::pfFilterHP[MAX_WORK_LENGTH] = {0.0f};
float mi::pfFilterBP[MAX_WORK_LENGTH] = {0.0f};

float mi::pfOutput[MAX_WORK_LENGTH] = {0.0f};


int mi::iWaveInitialised = 0;

CMachineParameter const *pParameters[] = {
	&paraAmp,
	&paraNote,
	&paraNote2,
	&paraSustainLength,
	&paraLengthUnits,
	&paraSustainForceLoop,
	&paraSmooth,
	&paraCtrl1,
	&paraCtrl2,
	&paraCtrl3,
	&paraCtrl4
};


// Machine's info
CMachineInfo const MacInfo = {
	miMACHINETYPE,MI_VERSION,miMACHINEFLAGS,miMIN_TRACKS,miMAX_TRACKS,
	miNUMGLOBALPARAMETERS,miNUMTRACKPARAMETERS,pParameters,
	miNUMATTRIBUTES,NULL,
	miMACHINE_NAME
#ifdef _DEBUG
	" [DEBUG]"
#endif
	,miSHORT_NAME,miMACHINE_AUTHOR,miCOMMAND_STRING
};


// REPLACES DLL_EXPORTS
extern "C" { 
	__declspec(dllexport) CMachineInfo const * __cdecl GetInfo() 
	{ 
		
		return &MacInfo; 
	} 

	__declspec(dllexport) CMachineInterface * __cdecl CreateMachine() \
	{ 
		return new mi; 
	} 
}

// Yeah, this stuff is in the Overloader SDK, but I don't use Overloader
BOOL CALLBACK FindBuzzWindowProc (
  HWND hwnd,      // handle to parent window
  LPARAM lParam   // application-defined value
)
{
	TCHAR sTitle[255];

	HWND * phwnd = (HWND *)lParam;

	if(GetWindowText(hwnd,sTitle,255))
	{
		if(_tcsstr(sTitle, _T("- Buzz -")))
		{
			// found!
			*phwnd = hwnd;
			return FALSE;
		}

	}

	return TRUE;

}

// utility func
HWND FindBuzzWindow()
{
	HWND hwndBuzzWindow;

	EnumWindows((WNDENUMPROC)FindBuzzWindowProc,(LPARAM)&hwndBuzzWindow);

	return hwndBuzzWindow;
}

// Just pushes all the envelope members into an array
void mi::UpdateEnvelopeArrays()
{
	int i = 0;

	envLeftEnvelopes[i++] = &envNote1ToNote2_L;

	envLeftEnvelopes[i++] = &envOctaveShift_L;

	envLeftEnvelopes[i++] = &envFMPitch_L;
	envLeftEnvelopes[i++] = &envFMOsc1_L;
	envLeftEnvelopes[i++] = &envFMOsc2_L;
	envLeftEnvelopes[i++] = &envFMOsc3_L;

	envLeftEnvelopes[i++] = &envPitchOsc1_L;
	envLeftEnvelopes[i++] = &envAmpOsc1_L;

	envLeftEnvelopes[i++] = &envPitchOsc2_L;
	envLeftEnvelopes[i++] = &envAmpOsc2_L;

	envLeftEnvelopes[i++] = &envPitchOsc3_L;
	envLeftEnvelopes[i++] = &envAmpOsc3_L;

	envLeftEnvelopes[i++] = &envClip_L;

	envLeftEnvelopes[i++] = &envFilter1Cut_L;
	envLeftEnvelopes[i++] = &envFilter1Res_L;
	envLeftEnvelopes[i++] = &envFilter1LP_L;
	envLeftEnvelopes[i++] = &envFilter1HP_L;
	envLeftEnvelopes[i++] = &envFilter1BP_L;

	envLeftEnvelopes[i++] = &envFilter2Cut_L;
	envLeftEnvelopes[i++] = &envFilter2Res_L;
	envLeftEnvelopes[i++] = &envFilter2LP_L;
	envLeftEnvelopes[i++] = &envFilter2HP_L;
	envLeftEnvelopes[i++] = &envFilter2BP_L;

	envLeftEnvelopes[i++] = &envFilter3Cut_L;
	envLeftEnvelopes[i++] = &envFilter3Res_L;
	envLeftEnvelopes[i++] = &envFilter3LP_L;
	envLeftEnvelopes[i++] = &envFilter3HP_L;
	envLeftEnvelopes[i++] = &envFilter3BP_L;

	envLeftEnvelopes[i++] = &envAmp_L;

	i = 0;

		envRightEnvelopes[i++] = &envNote1ToNote2_R;

	envRightEnvelopes[i++] = &envOctaveShift_R;

	envRightEnvelopes[i++] = &envFMPitch_R;
	envRightEnvelopes[i++] = &envFMOsc1_R;
	envRightEnvelopes[i++] = &envFMOsc2_R;
	envRightEnvelopes[i++] = &envFMOsc3_R;

	envRightEnvelopes[i++] = &envPitchOsc1_R;
	envRightEnvelopes[i++] = &envAmpOsc1_R;

	envRightEnvelopes[i++] = &envPitchOsc2_R;
	envRightEnvelopes[i++] = &envAmpOsc2_R;

	envRightEnvelopes[i++] = &envPitchOsc3_R;
	envRightEnvelopes[i++] = &envAmpOsc3_R;

	envRightEnvelopes[i++] = &envClip_R;

	envRightEnvelopes[i++] = &envFilter1Cut_R;
	envRightEnvelopes[i++] = &envFilter1Res_R;
	envRightEnvelopes[i++] = &envFilter1LP_R;
	envRightEnvelopes[i++] = &envFilter1HP_R;
	envRightEnvelopes[i++] = &envFilter1BP_R;

	envRightEnvelopes[i++] = &envFilter2Cut_R;
	envRightEnvelopes[i++] = &envFilter2Res_R;
	envRightEnvelopes[i++] = &envFilter2LP_R;
	envRightEnvelopes[i++] = &envFilter2HP_R;
	envRightEnvelopes[i++] = &envFilter2BP_R;

	envRightEnvelopes[i++] = &envFilter3Cut_R;
	envRightEnvelopes[i++] = &envFilter3Res_R;
	envRightEnvelopes[i++] = &envFilter3LP_R;
	envRightEnvelopes[i++] = &envFilter3HP_R;
	envRightEnvelopes[i++] = &envFilter3BP_R;

	envRightEnvelopes[i++] = &envAmp_R;

	i = 0;
	int j = 0;

	for(i = 0; i < ENVELOPES_PER_CHANNEL; i++)
	{
		envAllEnvelopes[j++] = envLeftEnvelopes[i];
		envAllEnvelopes[j++] = envRightEnvelopes[i];
	}

}

// Reset all the envelopes to something musically meaningful
void mi::ResetEnvelopes()
{

	// Left
	envNote1ToNote2_L.ResetCurve(0.0f, 1.0f);	

	envOctaveShift_L.ResetFlat(0.0f);

	envFMPitch_L.ResetFlat(-7.0f);
	envFMOsc1_L.ResetCurve(0.1f, 0.0f);
	envFMOsc2_L.ResetCurve(0.0f, 0.1f);
	envFMOsc3_L.ResetFlat(0.1f);

	envPitchOsc1_L.ResetFlat(-12.0f);
	envAmpOsc1_L.ResetFlat(0.7f);

	envPitchOsc2_L.ResetFlat(7.0f);
	envAmpOsc2_L.Reset();

	envPitchOsc3_L.ResetFlat(0.05f);
	envAmpOsc3_L.ResetFlat(0.7f);

	envClip_L.ResetFlat(0.8f);

	envFilter1Cut_L.ResetCurve(1.0f, 0.6f);
	envFilter1Res_L.ResetFlat(0.5f);
	envFilter1LP_L.Reset();
	envFilter1HP_L.ResetCurve(0.0f, 0.5f);
	envFilter1BP_L.ResetFlat(0.3f);

	envFilter2Cut_L.ResetCurve(0.5f, 0.3f);
	envFilter2Res_L.ResetFlat(0.5f);
	envFilter2LP_L.ResetFlat(0.0f);
	envFilter2HP_L.ResetCurve(1.0f, 1.0f);
	envFilter2BP_L.ResetFlat(0.3f);

	envFilter3Cut_L.ResetCurve(0.9f,0.4f);
	envFilter3Res_L.ResetFlat(0.5f);
	envFilter3LP_L.ResetFlat(0.8f);
	envFilter3HP_L.ResetFlat(0.2f);
	envFilter3BP_L.Reset();

	envAmp_L.Reset();

	envAmp_L.env.p2.flags |= SEP_FLAGS_FIXED_VALUE;

	// Right
	envNote1ToNote2_R.ResetCurve(0.0f, 1.0f);	

	envOctaveShift_R.ResetFlat(0.0f);

	envFMPitch_R.ResetFlat(-7.0f);
	envFMOsc1_R.ResetCurve(0.1f, 0.0f);
	envFMOsc2_R.ResetCurve(0.0f, 0.1f);
	envFMOsc3_R.ResetFlat(0.15f);

	envPitchOsc1_R.ResetFlat(-12.0f);
	envAmpOsc1_R.ResetFlat(0.7f);

	envPitchOsc2_R.ResetFlat(7.0f);
	envAmpOsc2_R.Reset();

	envPitchOsc3_R.ResetFlat(0.03f);
	envAmpOsc3_R.ResetFlat(0.7f);

	envClip_R.ResetFlat(0.8f);

	envFilter1Cut_R.ResetCurve(0.9f, 0.5f);
	envFilter1Res_R.ResetFlat(0.5f);
	envFilter1LP_R.Reset();
	envFilter1HP_R.ResetCurve(0.0f, 0.5f);
	envFilter1BP_R.ResetFlat(0.3f);

	envFilter2Cut_R.ResetCurve(0.4f, 0.2f);
	envFilter2Res_R.ResetFlat(0.5f);
	envFilter2LP_R.ResetFlat(0.0f);
	envFilter2HP_R.ResetCurve(1.0f, 1.0f);
	envFilter2BP_R.ResetFlat(0.3f);

	envFilter3Cut_R.ResetCurve(0.9f,0.45f);
	envFilter3Res_R.ResetFlat(0.5f);
	envFilter3LP_R.ResetFlat(0.8f);
	envFilter3HP_R.ResetFlat(0.2f);
	envFilter3BP_R.Reset();

	// amp always finishes at 0
	envAmp_R.Reset();
	envAmp_R.env.p2.flags |= SEP_FLAGS_FIXED_VALUE;
}

// No longer used.
// Should be familiar if you've seen the Doof source
void mi::CalculateWavesOriginal()
{
	// don't regen waves
		iWaveInitialised = 1;

		// ok, want to generate SAMPLE_SETS number of sine waves
		// can do lookup based on phase increment
		// i.e.
		// if phaseincrement is less than 1 then use lowest (with richest harmonics)
		// if phaseincrement is less than 2, then dump richest harmonic
		// etc
		// up to phaseincrement less than SAMPLE_SETS

		float * pfWave = NULL;
		//	float * pfPrevSine;
		float oneoverharm = 0.0;

		// pfSine = new float[WAVETABLE_SAMPLES];

		int i, j, harmonic;
		// 	float fRand;

		// initialise the arrays
		
		for(i = 0; i < SAMPLE_SETS; i++ )
		{
			ppfSaw[i] = new float[WAVETABLE_SAMPLES];
			ppfSquare[i] = new float[WAVETABLE_SAMPLES];
			ppfTriangle[i] = new float[WAVETABLE_SAMPLES];

		}

		/*
		for(j = 0; j < WAVETABLE_SAMPLES; j++)
		{
			pfSineSamples[j] = 0.0;
		}
		*/

		// then calc the sine values
		// modified: removed FM, going to use saw
		serp_double dDeltaT = (serp_double)(2 * PI / WAVETABLE_SAMPLES);

		pfWave = ppfSaw[SAMPLE_SETS - 1];

		harmonic = 1;	// base harmonic
		oneoverharm = 1.0f / harmonic;
		oneoverharm *= 0.7f;

		// TODO: Make this use complex exponential sine, or at least reduce load time
		// somehow

		float fMaxFreq = 0.0f;
		float fFreq = 0.0f;

		// Calculate the first (highest) harmonic
		fMaxFreq = float((float(WAVETABLE_SAMPLES / OVERSAMPLING) * 2 * PI) / 2);
		fFreq = 0.0f;

		serp_double dDeltaByHarmonic;
		dDeltaByHarmonic = dDeltaT * harmonic;

		pfWave = ppfSaw[(SAMPLE_SETS - 1)];

		
		
		// this initialises the first saw harmonic.
		// and the first square harmonic
		// also initialises the only sine harmonic

		// uses complex exponential
		float fcos=1.0;
		float fsin=0.0;

		for(i = 0; i < WAVETABLE_SAMPLES; i++)
		{
			/*
			pfWave[i] = float(sin(i * dDeltaByHarmonic) );
			*/
			pfWave[i] = fsin;
			fsin += (float)dDeltaByHarmonic*fcos;
			fcos -= (float)dDeltaByHarmonic*fsin;

			ppfSquare[(SAMPLE_SETS - 1)][i] = pfWave[i];
			ppfTriangle[(SAMPLE_SETS - 1)][i] = pfWave[i];
			pfSineSamples[i] = pfWave[i];
			// pfINoise[i] = ((!(i % (WAVETABLE_SAMPLES >> 4)))?(pfNoise[i]>0.0f?1.0f:-1.0f):0.0f);
			

		}

#define NOISE (((rand() % 10000) - 5000) / 5000.0f)
#define INTNOISE ((rand() % 256))
#define BOOLNOISE ((rand() % 2))

		srand(1999);

		int intNoise = INTNOISE;
		for(i = 0; i < WAVETABLE_SAMPLES; i++ )
		{
			// mess with noise
			// straight up noise
			pfNoise[i] =  NOISE * NOISE;
			
			if(BOOLNOISE)
			{
				pfINoise[i] = 1.0f;
			} else {
				pfINoise[i] = -1.0f;
			}
			
			if((i % intNoise))
			{
				pfINoise[i] = (pfINoise[i - (i % intNoise)] / (i % intNoise));	
			} else {
				intNoise = INTNOISE;
			}


		}


		float * pfPrevWave;

		harmonic = 2;

		fFreq = 0.0f;

		int iInc;

		float fSquareAmp = 1.0f;
		float fTriangleAmp = 1.0f;

		for(j = (SAMPLE_SETS - 1); j > 0; j--)	// one based
		{
			// sample rate doesn't come into this atm

			// ok, samples in ppfSine[ SAMPLE_SETS - 1 ] are for anything over (samplerate/4) khz
			// those in SAMPLE_SETS - 2 are for anything over (samplerate / 8)
			// those in SAMPLE_SETS - 3 are for anything over (samplerate / 16)

			iInc = (SAMPLE_SETS - j);
			fMaxFreq = float((float(WAVETABLE_SAMPLES / OVERSAMPLING) * 2 * PI) / pow(2, j));

			float fMul = 0.0f;

			pfWave = ppfSaw[j - 1];
			pfPrevWave = ppfSaw[j];

			// copy the previous value into this one
			for(i = 0; i < WAVETABLE_SAMPLES; i++)
			{
				pfWave[i] = pfPrevWave[i];
			}

			// copy the previous value into this one
			for(i = 0; i < WAVETABLE_SAMPLES; i++)
			{
				ppfSquare[j-1][i] = ppfSquare[j][i];
			}

			// copy the previous value into this one
			for(i = 0; i < WAVETABLE_SAMPLES; i++)
			{
				ppfTriangle[j-1][i] = ppfTriangle[j][i];
			}

			float fSawAmp = 0.0f;
			
			while(fFreq < fMaxFreq)
			{

				fFreq = float(2 * PI * harmonic);

				// uses complex exponential
				fcos=1.0;
				fsin=0.0;

				serp_double dFSFreq = fFreq / WAVETABLE_SAMPLES;

				fSawAmp = 1.0f / harmonic;
				// fSquareAmp = 1.0f / harmonic;
				fTriangleAmp = 1.0f / (harmonic * harmonic);

				// oneoverharm = 1.0f / (harmonic);
				// if(oneoverharm < 0.00001f) break;


				// if(harmonic == 1) oneoverharm = 1.0f;
				if(harmonic % 2) fSawAmp *= 0.7f;	// more emphasis on even harmonics
				else fSawAmp *= 0.95f; 

				serp_double dDeltaByHarmonic = dDeltaT * harmonic;

				fcos=1.0;
				fsin=0.0;

				pfWave = ppfSaw[j - 1];

				// do saw wave
				for(i = 0; i < WAVETABLE_SAMPLES; i++)
				{
					// pfWave[i] += float(sin(i * dDeltaByHarmonic) ) * oneoverharm;
					pfWave[i] += fsin * fSawAmp;
					fsin += (float)dDeltaByHarmonic*fcos;
					fcos -= (float)dDeltaByHarmonic*fsin;
				}

				fcos=1.0;
				fsin=0.0;

				pfWave = ppfSquare[j - 1];

				// do square wave
				if((harmonic % 2) == 1) // 2 ^ x
				{
					// fSquareAmp *= 0.5f;
					fSquareAmp = 1.0f / ( harmonic);
					for(i = 0; i < WAVETABLE_SAMPLES; i++)
					{
						// pfWave[i] += float(sin(i * dDeltaByHarmonic) ) * oneoverharm;
						pfWave[i] += fsin * fSquareAmp;
						fsin += (float)dDeltaByHarmonic*fcos;
						fcos -= (float)dDeltaByHarmonic*fsin;
					}
				}

				pfWave = ppfTriangle[j - 1];

			//	float fSqrt = sqrt( serp_double(harmonic) );
			//	if( ( int(fSqrt) * int(fSqrt) ) == harmonic )
			//	{
					// do triangle
					for(i = 0; i < WAVETABLE_SAMPLES; i++)
					{
						// pfWave[i] += float(sin(i * dDeltaByHarmonic) ) * oneoverharm;
						pfWave[i] += fcos * fTriangleAmp;
						fsin += (float)dDeltaByHarmonic*fcos;
						fcos -= (float)dDeltaByHarmonic*fsin;
			//		}
				}

				harmonic++;
			}
		}

		pfWave = ppfSaw[0];
}

// Updated, quicker, version.
void mi::CalculateWaves()
{
	// don't regen waves
		iWaveInitialised = 1;

		// ok, want to generate SAMPLE_SETS number of sine waves
		// can do lookup based on phase increment
		// i.e.
		// if phaseincrement is less than 1 then use lowest (with richest harmonics)
		// if phaseincrement is less than 2, then dump richest harmonic
		// etc
		// up to phaseincrement less than SAMPLE_SETS

		float * pfWave = NULL;
		//	float * pfPrevSine;
		float oneoverharm = 0.0;

		// pfSine = new float[WAVETABLE_SAMPLES];

		int i, j, harmonic;
		// 	float fRand;

		// initialise the arrays		
		for(i = 0; i < SAMPLE_SETS; i++ )
		{
			ppfSaw[i] = new float[WAVETABLE_SAMPLES];
			ppfSquare[i] = new float[WAVETABLE_SAMPLES];
			ppfTriangle[i] = new float[WAVETABLE_SAMPLES];

		}

		// then calc the sine values
		// modified: removed FM, going to use saw
		serp_double dDeltaT = (serp_double)( 2 * PI / WAVETABLE_SAMPLES );

		pfWave = ppfSaw[SAMPLE_SETS - 1];

		harmonic = 1;	// base harmonic
		oneoverharm = 1.0f / harmonic;
		oneoverharm *= 0.7f;

		float fMaxFreq = 0.0f;
		float fFreq = 0.0f;

		// Calculate the first (highest) harmonic
		fMaxFreq = float((float(WAVETABLE_SAMPLES / OVERSAMPLING) * 2 * PI) / 2);
		fFreq = 0.0f;

		serp_double dDeltaByHarmonic;
		dDeltaByHarmonic = dDeltaT * harmonic;

		pfWave = ppfSaw[(SAMPLE_SETS - 1)];
		
		// this initialises the first saw harmonic.
		// and the first square harmonic
		// also initialises the only sine harmonic

		// uses complex exponential
		float fcos=1.0;
		float fsin=0.0;

		for(i = 0; i < WAVETABLE_SAMPLES; i++)
		{			
			pfWave[i] = fsin;
			fsin += (float)dDeltaByHarmonic*fcos;
			fcos -= (float)dDeltaByHarmonic*fsin;

			ppfSquare[(SAMPLE_SETS - 1)][i] = pfWave[i];
			ppfTriangle[(SAMPLE_SETS - 1)][i] = pfWave[i];
			pfSineSamples[i] = pfWave[i];
			// pfINoise[i] = ((!(i % (WAVETABLE_SAMPLES >> 4)))?(pfNoise[i]>0.0f?1.0f:-1.0f):0.0f);		

		}

#define NOISE (((rand() % 10000) - 5000) / 5000.0f)
#define INTNOISE ((rand() % 256))
#define BOOLNOISE ((rand() % 2))

		srand(1999);

		int intNoise = INTNOISE;
		for(i = 0; i < WAVETABLE_SAMPLES; i++ )
		{
			// mess with noise
			// straight up noise
			pfNoise[i] =  NOISE * NOISE;
			
			if(BOOLNOISE)
			{
				pfINoise[i] = 1.0f;
			} else {
				pfINoise[i] = -1.0f;
			}
			
			if((i % intNoise))
			{
				pfINoise[i] = (pfINoise[i - (i % intNoise)] / (i % intNoise));	
			} else {
				intNoise = INTNOISE;
			}

		}

		float * pfPrevWave;

		harmonic = 2;

		fFreq = 0.0f;

		int iInc;

		float fSquareAmp = 1.0f;
		float fTriangleAmp = 1.0f;

		for(j = (SAMPLE_SETS - 1); j > 0; j--)	// one based
		{
			// sample rate doesn't come into this atm

			// ok, samples in ppfSine[ SAMPLE_SETS - 1 ] are for anything over (samplerate/4) khz
			// those in SAMPLE_SETS - 2 are for anything over (samplerate / 8)
			// those in SAMPLE_SETS - 3 are for anything over (samplerate / 16)

			iInc = (SAMPLE_SETS - j);
			fMaxFreq = float((float(WAVETABLE_SAMPLES / OVERSAMPLING) * 2 * PI) / pow(2, j));

			float fMul = 0.0f;

			pfWave = ppfSaw[j - 1];
			pfPrevWave = ppfSaw[j];

			// copy the previous value into this one
			for(i = 0; i < WAVETABLE_SAMPLES; i++)
			{
				pfWave[i] = pfPrevWave[i];
			}

			// copy the previous value into this one
			for(i = 0; i < WAVETABLE_SAMPLES; i++)
			{
				ppfSquare[j-1][i] = ppfSquare[j][i];
			}

			// copy the previous value into this one
			for(i = 0; i < WAVETABLE_SAMPLES; i++)
			{
				ppfTriangle[j-1][i] = ppfTriangle[j][i];
			}

			float fSawAmp = 0.0f;
			
			while(fFreq < fMaxFreq)
			{

				fFreq = float(2 * PI * harmonic);

				// uses complex exponential
				fcos=1.0;
				fsin=0.0;

				serp_double dFSFreq = fFreq / WAVETABLE_SAMPLES;

				fSawAmp = 1.0f / harmonic;
				// fSquareAmp = 1.0f / harmonic;
				fTriangleAmp = 1.0f / (harmonic * harmonic);

				// oneoverharm = 1.0f / (harmonic);
				// if(oneoverharm < 0.00001f) break;


				// if(harmonic == 1) oneoverharm = 1.0f;
				if(harmonic % 2) fSawAmp *= 0.7f;	// more emphasis on even harmonics
				else fSawAmp *= 0.95f; 

				serp_double dDeltaByHarmonic = dDeltaT * harmonic;

				pfWave = ppfSaw[j - 1];

				// do saw wave
				for(i = 0; i < WAVETABLE_SAMPLES; i++)
				{
					pfWave[i] += pfSineSamples[(i * harmonic) & WAVETABLE_SIZE_MASK] * fSawAmp;
				}

				fcos=1.0;
				fsin=0.0;

				pfWave = ppfSquare[j - 1];

				// do square wave
				if((harmonic % 2) == 1) // 2 ^ x
				{
					// fSquareAmp *= 0.5f;
					fSquareAmp = 1.0f / ( harmonic);
					for(i = 0; i < WAVETABLE_SAMPLES; i++)
					{
						pfWave[i] += pfSineSamples[(i * harmonic) & WAVETABLE_SIZE_MASK] * fSquareAmp;
					}
				}

				pfWave = ppfTriangle[j - 1];

			
				float fMul;
				
				if((harmonic % 2) == 1)
				{
					if((harmonic % 4) == 1)
					{
						fMul = fTriangleAmp;
					} else {
						fMul = -fTriangleAmp;
					}
					// do triangle
					for(i = 0; i < WAVETABLE_SAMPLES; i++)
					{	
						pfWave[i] += pfSineSamples[(i * harmonic) & WAVETABLE_SIZE_MASK] * fMul;

					}
				}

				harmonic++;
			}
		}

		pfWave = ppfSaw[0];
}


// constructor
mi::mi() {
#if (miBETAWARNING + miFIXINERTIAONSONGLOAD)> 0
	firstTick=true;
#endif
#if miNUMGLOBALPARAMETERS>0
	GlobalVals = &gval;
#endif
#if (miNUMATTRIBUTES + miBETAWARNINGATTRIBUTE )>0
	AttrVals = (int *)&aval;
#else
	AttrVals = NULL;
#endif
#if (miMAX_TRACKS>0 && miNUMTRACKPARAMETERS>0)
	TrackVals = tval;
	miNumberOfTracks=0;
#else 
	TrackVals = NULL;
#endif

	// set up the envelopes to defaults
	this->ResetEnvelopes();

	UpdateEnvelopeArrays();

	bLeft = true;
	
	wtOsc1 = saw;
	wtOsc2 = square;
	wtOsc3 = triangle;
	wtFM = sine;

	if(! iWaveInitialised )
	{
		CalculateWaves();
		
	}



}




// destructor
mi::~mi() {
	// free all allocated buffers here
}

void mi::ReadPoint(CMachineDataInput * const pi, CSerpentEnvelopePoint * pPoint )
{
	double dt;
	pi->Read(dt);
	pPoint->t = (serp_double)dt;
	pi->Read(pPoint->v);
	pi->Read(pPoint->flags);
}

void mi::SerpentReadPoint(CSerpentDataInput * const pi, CSerpentEnvelopePoint * pPoint )
{
	double dt;
	pi->Read(dt);
	pPoint->t = (serp_double)dt;
	pi->Read(pPoint->v);
	pi->Read(pPoint->flags);
}

void mi::WritePoint(CMachineDataOutput * const po, CSerpentEnvelopePoint * const pPoint )
{
	// ALWAYS write and read time as a double, THEN convert
	double dt;
	dt = (double)pPoint->t;
	po->Write(dt);
	po->Write(pPoint->v);
	po->Write(pPoint->flags);
}

void mi::SerpentWritePoint(CSerpentDataOutput * const po, CSerpentEnvelopePoint * const pPoint )
{
	double dt;
	dt = (double)pPoint->t;
	po->Write(dt);
	po->Write(pPoint->v);
	po->Write(pPoint->flags);
}

void mi::WriteEnvelope(CMachineDataOutput * const po,  CSerpentEnvelope * const pEnv )
{
	int iEnvelopeSegments = pEnv->SpanCount();
	po->Write(iEnvelopeSegments);

	CSerpentEnvelope * pCurrentEnvelope = pEnv;

	po->Write(pEnv->bLinked);

	while(pCurrentEnvelope)
	{
		WritePoint(po, & pCurrentEnvelope->env.p1);
		WritePoint(po, & pCurrentEnvelope->env.c1);
		WritePoint(po, & pCurrentEnvelope->env.c2);
		WritePoint(po, & pCurrentEnvelope->env.p2);

		pCurrentEnvelope = pCurrentEnvelope->pNextEnvelope;
	}

}

void mi::SerpentWriteEnvelope(CSerpentDataOutput * const po,  CSerpentEnvelope * const pEnv )
{
	int iEnvelopeSegments = pEnv->SpanCount();
	po->Write(iEnvelopeSegments);

	CSerpentEnvelope * pCurrentEnvelope = pEnv;

	po->Write(pEnv->bLinked);

	while(pCurrentEnvelope)
	{
		
		SerpentWritePoint(po, & pCurrentEnvelope->env.p1);
		SerpentWritePoint(po, & pCurrentEnvelope->env.c1);
		SerpentWritePoint(po, & pCurrentEnvelope->env.c2);
		SerpentWritePoint(po, & pCurrentEnvelope->env.p2);

		pCurrentEnvelope = pCurrentEnvelope->pNextEnvelope;
	}

}



void mi::ReadEnvelope(CMachineDataInput * const pi, CSerpentEnvelope * pEnv)
{
	int iEnvelopeSegments;
	pi->Read(iEnvelopeSegments);

	pEnv->Reset();

	CSerpentEnvelope * pCurrentEnvelope = pEnv;
	CSerpentEnvelope * pNewEnvelope;

	pi->Read(pEnv->bLinked);	

	int i = 0;
	while(i < iEnvelopeSegments)
	{

		ReadPoint(pi, & pCurrentEnvelope->env.p1);
		ReadPoint(pi, & pCurrentEnvelope->env.c1);
		ReadPoint(pi, & pCurrentEnvelope->env.c2);
		ReadPoint(pi, & pCurrentEnvelope->env.p2);

		i++;

		if(i < iEnvelopeSegments)
		{
			pNewEnvelope = new CSerpentEnvelope(false);
			pNewEnvelope->Reset();

			pCurrentEnvelope->pNextEnvelope = pNewEnvelope;
			pNewEnvelope->pPrevEnvelope = pCurrentEnvelope;
			
			pCurrentEnvelope = pNewEnvelope;

		}

	}

	pEnv->UpdateEnvelopeDetails();

}


void mi::SerpentReadEnvelope(CSerpentDataInput * const pi, CSerpentEnvelope * pEnv)
{
	int iEnvelopeSegments;
	pi->Read(iEnvelopeSegments);

	pEnv->Reset();
	
	CSerpentEnvelope * pCurrentEnvelope = pEnv;
	CSerpentEnvelope * pNewEnvelope;

	pi->Read(pEnv->bLinked);

	int i = 0;
	while(i < iEnvelopeSegments)	{

		SerpentReadPoint(pi, & pCurrentEnvelope->env.p1);
		SerpentReadPoint(pi, & pCurrentEnvelope->env.c1);
		SerpentReadPoint(pi, & pCurrentEnvelope->env.c2);
		SerpentReadPoint(pi, & pCurrentEnvelope->env.p2);

		i++;

		if(i < iEnvelopeSegments)
		{
			
			pNewEnvelope = new CSerpentEnvelope(false);
			pNewEnvelope->Reset();

			pCurrentEnvelope->pNextEnvelope = pNewEnvelope;
			pNewEnvelope->pPrevEnvelope = pCurrentEnvelope;
			
			pCurrentEnvelope = pNewEnvelope;

		}

	}

	pEnv->UpdateEnvelopeDetails();

}


void mi::MDKSave(CMachineDataOutput * const po)
{

	// write the magic number
	byte byMagic = SERPENT_MAGIC_1;
	po->Write(byMagic);
	byMagic = SERPENT_MAGIC_2;
	po->Write(byMagic);

	byte byFileVersion = SERPENT_FILE_VERSION;
	po->Write(byFileVersion);

	// need to read waveform type
	byte wt;
	wt = (byte)wtFM; po->Write(wt);
	wt = (byte)wtOsc1; po->Write(wt);
	wt = (byte)wtOsc2; po->Write(wt);
	wt = (byte)wtOsc3; po->Write(wt);

	int i;
	for(i = 0; i < ENVELOPES_PER_CHANNEL * 2; i++)
	{
		WriteEnvelope(po, envAllEnvelopes[i]);
	}
}

void mi::SerpentSave(CSerpentDataOutput * const po)
{
	// write the magic number
	byte byMagic = SERPENT_MAGIC_1;
	po->Write(byMagic);
	byMagic = SERPENT_MAGIC_2;
	po->Write(byMagic);

	byte byFileVersion = SERPENT_FILE_VERSION;
	po->Write(byFileVersion);

	// need to read waveform type
	byte wt;
	wt = (byte)wtFM; po->Write(wt);
	wt = (byte)wtOsc1; po->Write(wt);
	wt = (byte)wtOsc2; po->Write(wt);
	wt = (byte)wtOsc3; po->Write(wt);

	int i;
	for(i = 0; i < ENVELOPES_PER_CHANNEL * 2; i++)
	{
		SerpentWriteEnvelope(po, envAllEnvelopes[i]);
	}


}

void mi::SerpentLoad(CSerpentDataInput * const pi)
{
	
	this->pThisMachine = this->pCB->GetThisMachine();
	// pCB->SetnumOutputChannels(pThisMachine,2);

	// pi will be null if not loading from a file
	if(pi == NULL) return;

	// ok, to now to read in the envelopes
	// first, should be magic
	byte byMagic1, byMagic2;
	pi->Read(byMagic1);
	pi->Read(byMagic2);

	if(byMagic1 != SERPENT_MAGIC_1) return;
	if(byMagic2 != SERPENT_MAGIC_2) return;

	byte byFileVersion;
	pi->Read(byFileVersion);
	if(byFileVersion > SERPENT_FILE_VERSION) return;

	// need to read waveform type
	byte wt;
	pi->Read(wt); wtFM = (WaveType)wt;
	pi->Read(wt); wtOsc1 = (WaveType)wt;
	pi->Read(wt); wtOsc2 = (WaveType)wt;
	pi->Read(wt); wtOsc3 = (WaveType)wt;

	int i;
	for(i = 0; i < ENVELOPES_PER_CHANNEL * 2; i++)
	{
		SerpentReadEnvelope(pi, envAllEnvelopes[i]);
	}

}


// INIT
void mi::MDKInit(CMachineDataInput * const pi)
{
	
	this->pThisMachine = this->pCB->GetThisMachine();

#ifdef SERPENT_STEREO
	pCB->SetnumOutputChannels(pThisMachine,2);
#endif

	// pi will be null if not loading from a file
	if(pi == NULL) return;

	// ok, to now to read in the envelopes
	// first, should be magic
	byte byMagic1, byMagic2;
	pi->Read(byMagic1);
	pi->Read(byMagic2);

	if(byMagic1 != SERPENT_MAGIC_1) return;
	if(byMagic2 != SERPENT_MAGIC_2) return;

	byte byFileVersion;
	pi->Read(byFileVersion);
	if(byFileVersion > SERPENT_FILE_VERSION) return;

	// need to read waveform type
	byte wt;
	pi->Read(wt); wtFM = (WaveType)wt;
	pi->Read(wt); wtOsc1 = (WaveType)wt;
	pi->Read(wt); wtOsc2 = (WaveType)wt;
	pi->Read(wt); wtOsc3 = (WaveType)wt;

	int i;
	for(i = 0; i < ENVELOPES_PER_CHANNEL * 2; i++)
	{
		ReadEnvelope(pi, envAllEnvelopes[i]);
	}

}

void CSerpentLinearEnvelope::PopulateFromSerpentEnvelope(CSerpentEnvelope * pEnv)
{
	int i = 0;
	serp_double dTime = (serp_double)0.0;
	tTotal = pEnv->GetLastTime();
	tInterval = (serp_double)(tTotal * ONE_OVER_LINEAR_ENVELOPE_SEGMENTS);

	CSerpentEnvelope * pFoundEnv;

	for(i = 0; i < LINEAR_ENVELOPE_SEGMENTS; i++)
	{
		dTime = (serp_double)((i * tTotal) * ONE_OVER_LINEAR_ENVELOPE_SEGMENTS);
		fPoints[i] = pEnv->GetValueAtTimeSlow(dTime, &pFoundEnv);
		dTime += tInterval;
	}
}

float CSerpentLinearEnvelope::GetValueAtTime(serp_double t)
{
	// get the ratio t / (tTotal)
	serp_double tRatio = t / tTotal;
	int iIndex = (int)(tRatio * LINEAR_ENVELOPE_SEGMENTS);
	if(iIndex >= (LINEAR_ENVELOPE_SEGMENTS - 1)) return fPoints[LINEAR_ENVELOPE_SEGMENTS - 1];

	// got a point, guaranteed not to be the last one
	// so do a lerp
	serp_double tTime1 = iIndex * tInterval;
	serp_double tTime2 = (tTime1 + tInterval);

	float ftRatio = (float) ((t - tTime1) / tInterval);
	float ftOneMinusRatio = 1.0f - ftRatio;

	return (fPoints[iIndex] * ftOneMinusRatio) + (fPoints[iIndex + 1] * ftRatio);

}

// SetNumTracks
void mi::SetNumTracks(int const n) {

	// if this is a new track, ie. n > miNumberOfTracks
	if(n > int(miNumberOfTracks))
	{

		CTrack * myTrack = myTracks + n;

		myTrack->ResetTrack();
	}
		
	miNumberOfTracks=n;

}

// machine input has changed mono<->stereo
void mi::OutputModeChanged(bool stereo) {
	
}

void mi::Command(int const i)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState( ));

	// check i to see which command
	switch(i)
	{
	case 0:
		CRoutingWindow * rw = new CRoutingWindow();
		RECT rSize;
		rSize.left = 50;
		rSize.top = 50;
		rSize.bottom = 250;
		rSize.right = 250;

		rw->m_serpent  = this;

		LPCTSTR szWndClass = AfxRegisterWndClass(CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW ,
				0,
				0,
				0);

		if(! rw->CreateEx(
			0,
			szWndClass,
			"Serpent Routing",
			WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU,
			rSize,CWnd::FromHandle(FindBuzzWindow()),NULL,NULL))
		{
			// broke!
			rw->hInstResource = g_hInstance;

		} else {
			rw->hInstResource = g_hInstance;
			rw->ShowWindow(SW_SHOW);
		}
		break;
	}
}

#define MAX_DESCRIPTION 256
char const *mi::DescribeValue(int const param, int const value)
{
	static char szDescription[MAX_DESCRIPTION];
	
	switch(param)
	{
	case 0:	// global amp
		_snprintf(szDescription,MAX_DESCRIPTION,"%.1f%%",(float)(value / AMP_MAX));
		return szDescription;
		break;

	case 3: // sustain length
		if(LENGTH_INFINITE == value)
		{
			return "Infinite";
		} else {
			_snprintf(szDescription, MAX_DESCRIPTION, "%d", value);
			return szDescription;
		}
		break;

	case 4:
		switch(value)
		{
		case UNIT_TICKS:
			return "Ticks";
			break;
		case UNIT_TICKS_OVER_128:
			return "1/128 Ticks";
			break;
		case UNIT_MS:
			return "MS";
			break;
		case UNIT_SAMPLES:
			return "Samples";
			break;
		}
		break;

	case 5:
		if(value) return "Yes";
		return "No";
		break;

	case 6:
		if(value) return "Smoothed";
		return "Unsmoothed";
		break;

	case 7:
	case 8:
	case 9:
	case 10:
		_snprintf(szDescription, MAX_DESCRIPTION, "%d", value);
		return szDescription;
		break;

	default:
		_snprintf(szDescription, MAX_DESCRIPTION, "%d", value);
		return szDescription;
		break;
	}

	return "Huh?";
}

void mi::MidiNote(int const channel, int const value, int const velocity)
{
	// TODO: Handle MIDI note
}

void mi::Stop()
{
	unsigned int i;
	for( i = 0; i < this->miNumberOfTracks; i++ )
	{
		myTracks[i].bSustaining = false;
	}
}

#define ONE_OVER_12 (0.0833333333333f)
#define BASE_FREQ (16.3516f)
#define BUZZNOTE_TO_KEYNUM(x) (((x >> 4) * 12) +( (x & 0x0f) ) - 13)
#define KEYNUM_TO_FREQ(x) (float(BASE_FREQ * pow(2.0f, x * ONE_OVER_12) ) )
#define BUZZNOTE_TO_FREQ(x) (KEYNUM_TO_FREQ(BUZZNOTE_TO_KEYNUM(x) ) )

int buzzNoteToKeyNum(int x)
{
	return ((x >> 4) * 12) + ( ( x & 0x0f) ) - 13;
}

float keyNumToFreq(int x)
{
	return float(BASE_FREQ * pow(2.0f, x * ONE_OVER_12) );
}

float buzzNoteToFreq(int x)
{
	return keyNumToFreq(buzzNoteToKeyNum(x));
}

void mi::Tick()
{
	bLeft = true;

	for (unsigned int c = 0; c < miNumberOfTracks; c++) {
		tvals *tv=tval+c;
		CTrack *myTrack=myTracks+c;


		if(tv->t_Note2 != paraNote.NoValue)
		{
			if(tv->t_Note2 == NOTE_OFF)
			{
				myTrack->bUseNote2 = false;
			} else {
				myTrack->fNoteFreq = myTrack->fNote2Freq;
				
				myTrack->bUseNote2 = true;
				
				myTrack->fNote2Freq = BUZZNOTE_TO_FREQ(tv->t_Note2);
			}

			// reset note1 - note2 
			myTrack->dTimeNote1ToNote2_L = myTrack->dTimeNote1ToNote2_R = 0.0;
		}

		// new note!
		// reset all envelopes to 0.0
		if(tv->t_Note != paraNote.NoValue)
		{	
			if(tv->t_Note == NOTE_OFF)
			{
				myTrack->bSustaining = false;
			} else {
				byte byNote = tv->t_Note;

				myTrack->bSustaining = true;
				myTrack->bPlaying_L = true;
				myTrack->bPlaying_R = true;
				myTrack->fNoteFreq = BUZZNOTE_TO_FREQ(byNote);

				// new note, reset times
				myTrack->ResetTimes();
			}
		}

		if(tv->t_Smooth != paraSmooth.NoValue)
		{
			if(tv->t_Smooth == paraSmooth.MinValue)
			{
				// smooth off
				myTrack->bSmooth = false;
				myTrack->bSmoothingNow_L = false;
				myTrack->bSmoothingNow_R = false;
			} else {
				myTrack->bSmooth = true;
			}
		}

		if(tv->t_ForceSustainLoop != paraSustainForceLoop.NoValue)
		{
			if(tv->t_ForceSustainLoop == SWITCH_ON)
			{
				myTrack->bForceLoop = true;
			} else {
				myTrack->bForceLoop = false;
			}
		}

		if(tv->t_LengthUnits != paraLengthUnits.NoValue)
		{
			myTrack->iLengthUnits = tv->t_LengthUnits;
		}

		if(tv->t_SustainLength != paraSustainLength.NoValue)
		{
			myTrack->dLengthInUnits = tv->t_SustainLength;

			serp_double dSecondsPerTick = (serp_double)(1.0 / this->pMasterInfo->TicksPerSec);

			if(tv->t_SustainLength == paraSustainLength.MaxValue)
			{
				myTrack->bInfiniteSustain = true;
			} else {

				myTrack->bInfiniteSustain = false;

				switch(myTrack->iLengthUnits)
				{
				case UNIT_TICKS:
					myTrack->dSustainLength = dSecondsPerTick * myTrack->dLengthInUnits;
					break;
				case UNIT_TICKS_OVER_128:
					myTrack->dSustainLength = (dSecondsPerTick * myTrack->dLengthInUnits) / 128.0;
					break;
				case UNIT_MS:
					myTrack->dSustainLength = myTrack->dLengthInUnits * 1000.0;
					break;
				case UNIT_SAMPLES:
					myTrack->dSustainLength = myTrack->dLengthInUnits * (pMasterInfo->SamplesPerSec);
					break;
				}
			}
		}

	}
}

#define DSP_Zero(x,y) {int c=y; float *p = x; while(c--){*(p++) = 0.0f;}}

bool mi::MDKWorkStereo(float *psamples, int numsamples, int const mode)
{
	if (mode==WM_NOIO) {
		// machine is not connected to anything
		return false;
	} else if (mode==WM_WRITE) 
	{
		float * pAux = this->pCB->GetAuxBuffer();

		float * pAuxOriginal = pAux;

		float * pOutput = psamples;

		int i;		

		memset(pAux,0,numsamples * sizeof(float));		

		bLeft = true;

		bool bGotLeft = MDKWork(pAux, numsamples, mode);
		
			for(i = 0; i < numsamples << 1; i += 2)
			{
				psamples[i] = *(pAux++);
			}

			pAux = pAuxOriginal;
		

		bLeft = false;

		bool bGotRight = MDKWork(pAux, numsamples, mode);

		
			for( i = 1; i < numsamples << 1; i += 2)
			{
				psamples[i] = *(pAux++);
			}
		

		bLeft = true;

		return bGotLeft || bGotRight;

	}
	return false;
}

void mi::CalcNote1ToNote2(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	float fStart;
	float fEnd;

	float fInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);
	    
	if(bLeft)
	{
		if(pTrack->bUseNote2)
		{
			// grab start time
			dStartTime = pTrack->dTimeNote1ToNote2_L;

			// GetValues
			GetValues(dStartTime, &(pTrack->dTimeNote1ToNote2_L),&fStart,&fEnd,dLength,
				&envNote1ToNote2_L, pTrack);
		} else {
			// use first point of envelope
			fStart = fEnd = this->envNote1ToNote2_L.env.p1.v;
		}

		if(pTrack->bSmoothingNow_L)
			fStart = pTrack->fValueNote1ToNote2_L;			

		pTrack->fValueNote1ToNote2_L = fEnd;

	} else { // right

		if(pTrack->bUseNote2)
		{
			// grab start time
			dStartTime = pTrack->dTimeNote1ToNote2_R;

			CSerpentEnvelope * pEnv = (envNote1ToNote2_L.bLinked?&envNote1ToNote2_L:&envNote1ToNote2_R);

			// GetValues
			GetValues(dStartTime, &(pTrack->dTimeNote1ToNote2_R),&fStart,&fEnd,dLength,
				pEnv, pTrack);
		} else {
			// use first point of envelope
			fStart = fEnd = this->envNote1ToNote2_R.env.p1.v;
		}

		if(pTrack->bSmoothingNow_R)
			fStart = pTrack->fValueNote1ToNote2_R;			

		pTrack->fValueNote1ToNote2_R = fEnd;
	}

	//NOTE1->NOTE2 SPECIFIC BIT
	// fStart ranges from 0-1
	// which map the range pTrack->fNoteFreq - pTrack->fNote2Freq

	float fOneMinusVal;

	fOneMinusVal = 1.0f - fStart;
	fStart = float( (pTrack->fNoteFreq * fOneMinusVal) + (pTrack->fNote2Freq * fStart) );

	fOneMinusVal = 1.0f - fEnd;
	fEnd = float( (pTrack->fNoteFreq * fOneMinusVal) + (pTrack->fNote2Freq * fEnd) );

	// END SPECIFIC

	// figure out a lerp
	fInc = CALC_INCREMENT(fStart,fEnd,numsamples);
	float fBase = fStart;

	int i = 0;

	// calculate the value
	while(numsamples--) {
		this->pfPitch[i++] = fBase;
		fBase += fInc;
	}

}

void mi::GetValues(serp_double dStartTime, serp_double * pdEndTime, float * pfStart, float * pfEnd, serp_double dLength, CSerpentEnvelope * pEnv, CTrack * pTrack)
{
		// wrap, if necessary
		if(pTrack->bSustaining)
		{
			*pdEndTime = pEnv->SustainWrap(dStartTime + dLength);
		} else {
			*pdEndTime = dStartTime + dLength;
		}

		CSerpentEnvelope * pFoundEnvelope;

		// get start value
		*pfStart = pEnv->GetValueAtTime(dStartTime,&pFoundEnvelope);

		// get end value
		*pfEnd = pEnv->GetValueAtTime(*pdEndTime,&pFoundEnvelope);

}

void mi::CalcOctaveShift(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	float fStart;
	float fEnd;

	float fInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);
	   
	if(bLeft)
	{
		// grab start time
		dStartTime = pTrack->dTimeOctaveShift_L;

		// GetValues
		GetValues(dStartTime, &(pTrack->dTimeOctaveShift_L),&fStart,&fEnd,dLength,
			&envOctaveShift_L, pTrack);

		if(pTrack->bSmoothingNow_L)
			fStart = pTrack->fValueOctaveShift_L;			

		pTrack->fValueOctaveShift_L = fEnd;

	} else { // right

		// grab start time
		dStartTime = pTrack->dTimeOctaveShift_R;

		CSerpentEnvelope * pEnv = (envOctaveShift_L.bLinked?&envOctaveShift_L:&envOctaveShift_R);

		// GetValues
		GetValues(dStartTime, &(pTrack->dTimeOctaveShift_R),&fStart,&fEnd,dLength,
			pEnv, pTrack);

		if(pTrack->bSmoothingNow_R)
			fStart = pTrack->fValueOctaveShift_R;			

		pTrack->fValueOctaveShift_R = fEnd;
	}

	// OCTAVE SHIFT SPECIFIC BIT
	// values are in octaves
	// need to convert to enable multiplication

	// -2 = multiply by 1/4
	// -1 = multiply by 1/2
	//  0 = multiply by 1
	// +1 = multiply by 2
	// +2 = multiply by 4

	// 2 ^ (x)
	

	fStart = (float)pow(2,fStart);
	fEnd = (float)pow(2,fEnd);

	// END SPECIFIC

	// figure out a lerp
	fInc = CALC_INCREMENT(fStart,fEnd,numsamples);
	float fBase = fStart;

	int i = 0;

	// calculate the value
	while(numsamples--) {
		this->pfPitch[i++] *= fBase;
		fBase += fInc;
	}

}


void mi::CalcFMPitch(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	

}


void mi::CalcFMOut(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	// calculates the FM oscillator

	float fStart;
	float fEnd;

	float fInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);
	   
	if(bLeft)
	{
		// grab start time
		dStartTime = pTrack->dTimeFMPitch_L;

		// GetValues
		GetValues(dStartTime, &(pTrack->dTimeFMPitch_L),&fStart,&fEnd,dLength,
			&envFMPitch_L, pTrack);

		if(pTrack->bSmoothingNow_L)
			fStart = pTrack->fValueFMPitch_L;	

		pTrack->fValueFMPitch_L = fEnd;

	} else { // right

		// grab start time
		dStartTime = pTrack->dTimeFMPitch_R;

		CSerpentEnvelope * pEnv = (envFMPitch_L.bLinked?&envFMPitch_L:&envFMPitch_R);

		// GetValues
		GetValues(dStartTime, &(pTrack->dTimeFMPitch_R),&fStart,&fEnd,dLength,
			pEnv, pTrack);

		if(pTrack->bSmoothingNow_R)
			fStart = pTrack->fValueFMPitch_R;	

		pTrack->fValueFMPitch_R = fEnd;
	}

	// FM PITCH SPECIFIC BIT
	// values are in octaves
	// need to convert to enable multiplication

	// -24 = multiply by 1/4
	// -12 = multiply by 1/2
	//  0 = multiply by 1
	// +12 = multiply by 2
	// +24 = multiply by 4

	// 2 ^ (x/12)
	

	fStart = (float)pow(2,fStart/12);
	fEnd = (float)pow(2,fEnd/12);

	// END SPECIFIC

	// figure out a lerp
	fInc = CALC_INCREMENT(fStart,fEnd,numsamples);
	float fBase = fStart;

	int i = 0;

	float fPitch;


	// pitch is stored in pfFMPitch
	float * pWaveTable;
	float * pWaveTable2;

	COscillator * pOsc;

	if(bLeft) pOsc = &pTrack->oscFM_L; else pOsc = &pTrack->oscFM_R;

	WaveLevels(this->wtFM,pOsc->GetPhaseInc(),&pWaveTable, &pWaveTable2);

	// now we have the wave levels

	int iSamplesPerSecond = this->pMasterInfo->SamplesPerSec;

	while(numsamples--)
	{
		fPitch = this->pfPitch[i] * fBase;

		// only evaluate phase every 16 samples for the FM oscillator
		if(!(i & 0xF))
		{
			pOsc->CalculatePhase(fPitch, iSamplesPerSecond);
			WaveLevels(this->wtFM,pOsc->GetPhaseInc(),&pWaveTable, &pWaveTable2);
		}

		pfFMOut[i++] = *(pWaveTable + pOsc->GetPhaseAndIncrement());

		fBase += fInc;
		i++;
	}
}

// returns true if samples were generated
bool mi::CalcOsc1(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	float fPitchStart;
	float fPitchEnd;

	float fFMStart;
	float fFMEnd;

	float fAmpStart;
	float fAmpEnd;

	float fPitchInc;
	float fFMInc;
	float fAmpInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);

	if(bLeft)
	{
		// grab pitch info
		dStartTime = pTrack->dTimePitchOsc1_L;
		GetValues(dStartTime, &(pTrack->dTimePitchOsc1_L),&fPitchStart,&fPitchEnd,dLength,
			&envPitchOsc1_L, pTrack);

		// then FM
		dStartTime = pTrack->dTimeFMOsc1_L;
		GetValues(dStartTime, &(pTrack->dTimeFMOsc1_L),&fFMStart,&fFMEnd,dLength,
			&envFMOsc1_L, pTrack);

		// then Amp
		dStartTime = pTrack->dTimeAmpOsc1_L;
		GetValues(dStartTime, &(pTrack->dTimeAmpOsc1_L),&fAmpStart,&fAmpEnd,dLength,
			&envAmpOsc1_L, pTrack);


	} else { // right

		// grab pitch info
		dStartTime = pTrack->dTimePitchOsc1_R;
		CSerpentEnvelope * pEnv = (envPitchOsc1_L.bLinked?&envPitchOsc1_L:&envPitchOsc1_R);
		GetValues(dStartTime, &(pTrack->dTimePitchOsc1_R),&fPitchStart,&fPitchEnd,dLength,
			pEnv, pTrack);

		// then FM
		dStartTime = pTrack->dTimeFMOsc1_R;
		pEnv = (envFMOsc1_L.bLinked?&envFMOsc1_L:&envFMOsc1_R);
		GetValues(dStartTime, &(pTrack->dTimeFMOsc1_R),&fFMStart,&fFMEnd,dLength,
			pEnv, pTrack);

		// then Amp
		dStartTime = pTrack->dTimeAmpOsc1_R;
		pEnv = (envAmpOsc1_L.bLinked?&envAmpOsc1_L:&envAmpOsc1_R);
		GetValues(dStartTime, &(pTrack->dTimeAmpOsc1_R),&fAmpStart,&fAmpEnd,dLength,
			pEnv, pTrack);
	}

	// OSC PITCH SPECIFIC BIT
	// values are in semitones
	// need to convert to enable multiplication

	// -24 = multiply by 1/4
	// -12 = multiply by 1/2
	//  0 = multiply by 1
	// +12 = multiply by 2
	// +24 = multiply by 4

	// 2 ^ (x/12)


	fPitchStart = (float)pow(2,fPitchStart/12);
	fPitchEnd = (float)pow(2,fPitchEnd/12);

	// END PITCH SPECIFIC

	// OSC FM SPECIFIC BIT
	// nothing special needs to be done here
	// FM amplitude is 0-1
	// representing no modulation
	// up to 100% modulation
	// 
	// lets put 100% modulation as the oscillator pitch
	// END FM SPECIFIC BIT

	// OSC AMP SPECIFIC BIT
	// nothing
	// END OSC AMP SPECIFIC BIT

	// figure out a lerp
	fPitchInc = CALC_INCREMENT(fPitchStart,fPitchEnd,numsamples);
	float fPitchBase = fPitchStart;

	fFMInc = CALC_INCREMENT(fFMStart, fFMEnd, numsamples);
	float fFMBase = fFMStart;

	fAmpInc = CALC_INCREMENT(fAmpStart, fAmpEnd, numsamples);
	float fAmpBase = fAmpStart;

	int i = 0;

	int iSamplesPerSecond = this->pMasterInfo->SamplesPerSec;

	float fPitch;

	float * pWaveTable;
	float * pWaveTable2;

	bool bQuiet;
	bQuiet = ((fAmpStart * fAmpStart) < LOW_VOLUME);
	bQuiet &= ((fAmpEnd * fAmpEnd) < LOW_VOLUME);



	if(bQuiet)
	{
		return false;
	}
	
	COscillator * pOsc;
	if(bLeft) 
	{
		pOsc = &pTrack->osc1_L;
	} else {
		pOsc = &pTrack->osc1_R;
	}
	// calculate the value
	while(numsamples--) {
		fPitch = pfPitch[i] * fPitchBase;
		pOsc->CalculatePhase( fPitch + (fFMBase * fPitch * this->pfFMOut[i]), iSamplesPerSecond);

		// update wavelevels every 16 samples
		if(! (i & 0xF))
		{
			WaveLevels(this->wtOsc1,pOsc->GetPhaseInc(),&pWaveTable, &pWaveTable2);
		}

		*(psamples++) = pWaveTable[pOsc->GetPhaseAndIncrement()] * fAmpBase;

		fPitchBase += fPitchInc;
		fAmpBase += fAmpInc;
		fFMBase += fFMInc;
		i++;
	}

	return true;

}



// OSC 2

// returns true if samples were generated
bool mi::CalcOsc2(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	float fPitchStart;
	float fPitchEnd;

	float fFMStart;
	float fFMEnd;

	float fAmpStart;
	float fAmpEnd;

	float fPitchInc;
	float fFMInc;
	float fAmpInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);

	if(bLeft)
	{
		// grab pitch info
		dStartTime = pTrack->dTimePitchOsc2_L;
		GetValues(dStartTime, &(pTrack->dTimePitchOsc2_L),&fPitchStart,&fPitchEnd,dLength,
			&envPitchOsc2_L, pTrack);

		// then FM
		dStartTime = pTrack->dTimeFMOsc2_L;
		GetValues(dStartTime, &(pTrack->dTimeFMOsc2_L),&fFMStart,&fFMEnd,dLength,
			&envFMOsc2_L, pTrack);

		// then Amp
		dStartTime = pTrack->dTimeAmpOsc2_L;
		GetValues(dStartTime, &(pTrack->dTimeAmpOsc2_L),&fAmpStart,&fAmpEnd,dLength,
			&envAmpOsc2_L, pTrack);


	} else { // right

		// grab pitch info
		dStartTime = pTrack->dTimePitchOsc2_R;
		CSerpentEnvelope * pEnv = (envPitchOsc2_L.bLinked?&envPitchOsc2_L:&envPitchOsc2_R);
		GetValues(dStartTime, &(pTrack->dTimePitchOsc2_R),&fPitchStart,&fPitchEnd,dLength,
			pEnv, pTrack);

		// then FM
		dStartTime = pTrack->dTimeFMOsc2_R;
		pEnv = (envFMOsc2_L.bLinked?&envFMOsc2_L:&envFMOsc2_R);
		GetValues(dStartTime, &(pTrack->dTimeFMOsc2_R),&fFMStart,&fFMEnd,dLength,
			pEnv, pTrack);

		// then Amp
		dStartTime = pTrack->dTimeAmpOsc2_R;
		pEnv = (envAmpOsc2_L.bLinked?&envAmpOsc2_L:&envAmpOsc2_R);
		GetValues(dStartTime, &(pTrack->dTimeAmpOsc2_R),&fAmpStart,&fAmpEnd,dLength,
			pEnv, pTrack);
	}

	// OSC PITCH SPECIFIC BIT
	// values are in octaves
	// need to convert to enable multiplication

	// -24 = multiply by 1/4
	// -12 = multiply by 1/2
	//  0 = multiply by 1
	// +12 = multiply by 2
	// +24 = multiply by 4

	// 2 ^ (x/12)


	fPitchStart = (float)pow(2,fPitchStart/12);
	fPitchEnd = (float)pow(2,fPitchEnd/12);

	// END PITCH SPECIFIC

	// OSC FM SPECIFIC BIT
	// nothing special needs to be done here
	// FM amplitude is 0-1
	// representing no modulation
	// up to 100% modulation
	// 
	// lets put 100% modulation as the oscillator pitch
	// END FM SPECIFIC BIT

	// OSC AMP SPECIFIC BIT
	// nothing
	// END OSC AMP SPECIFIC BIT

	// figure out a lerp
	fPitchInc = CALC_INCREMENT(fPitchStart,fPitchEnd,numsamples);
	float fPitchBase = fPitchStart;

	fFMInc = CALC_INCREMENT(fFMStart, fFMEnd, numsamples);
	float fFMBase = fFMStart;

	fAmpInc = CALC_INCREMENT(fAmpStart, fAmpEnd, numsamples);
	float fAmpBase = fAmpStart;

	int i = 0;

	int iSamplesPerSecond = this->pMasterInfo->SamplesPerSec;

	float fPitch;

	float * pWaveTable;
	float * pWaveTable2;

	bool bQuiet;
	bQuiet = ((fAmpStart * fAmpStart) < LOW_VOLUME);
	bQuiet &= ((fAmpEnd * fAmpEnd) < LOW_VOLUME);

	if(bQuiet)
	{
		return false;
	} 


	COscillator * pOsc;
	if(bLeft) 
	{
		pOsc = &pTrack->osc2_L;
	} else {
		pOsc = &pTrack->osc2_R;
	}
	// calculate the value
	while(numsamples--) {
		fPitch = pfPitch[i] * fPitchBase;
		pOsc->CalculatePhase( fPitch + (fFMBase * fPitch * this->pfFMOut[i]), iSamplesPerSecond);

		// update wavelevels every 16 samples
		if(! (i & 0xF))
		{
			WaveLevels(this->wtOsc2,pOsc->GetPhaseInc(),&pWaveTable, &pWaveTable2);
		}

		*(psamples++) = pWaveTable[pOsc->GetPhaseAndIncrement()] * fAmpBase;

		fPitchBase += fPitchInc;
		fAmpBase += fAmpInc;
		fFMBase += fFMInc;
		i++;
	}

	return true;

}


// OSC3

// returns true if samples were generated
bool mi::CalcOsc3(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	float fPitchStart;
	float fPitchEnd;

	float fFMStart;
	float fFMEnd;

	float fAmpStart;
	float fAmpEnd;

	float fPitchInc;
	float fFMInc;
	float fAmpInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);

	if(bLeft)
	{
		// grab pitch info
		dStartTime = pTrack->dTimePitchOsc3_L;
		GetValues(dStartTime, &(pTrack->dTimePitchOsc3_L),&fPitchStart,&fPitchEnd,dLength,
			&envPitchOsc3_L, pTrack);

		// then FM
		dStartTime = pTrack->dTimeFMOsc3_L;
		GetValues(dStartTime, &(pTrack->dTimeFMOsc3_L),&fFMStart,&fFMEnd,dLength,
			&envFMOsc3_L, pTrack);

		// then Amp
		dStartTime = pTrack->dTimeAmpOsc3_L;
		GetValues(dStartTime, &(pTrack->dTimeAmpOsc3_L),&fAmpStart,&fAmpEnd,dLength,
			&envAmpOsc3_L, pTrack);


	} else { // right

		// grab pitch info
		dStartTime = pTrack->dTimePitchOsc3_R;
		CSerpentEnvelope * pEnv = (envPitchOsc3_L.bLinked?&envPitchOsc3_L:&envPitchOsc3_R);
		GetValues(dStartTime, &(pTrack->dTimePitchOsc3_R),&fPitchStart,&fPitchEnd,dLength,
			pEnv, pTrack);

		// then FM
		dStartTime = pTrack->dTimeFMOsc3_R;
		pEnv = (envFMOsc3_L.bLinked?&envFMOsc3_L:&envFMOsc3_R);
		GetValues(dStartTime, &(pTrack->dTimeFMOsc3_R),&fFMStart,&fFMEnd,dLength,
			pEnv, pTrack);

		// then Amp
		dStartTime = pTrack->dTimeAmpOsc3_R;
		pEnv = (envAmpOsc3_L.bLinked?&envAmpOsc3_L:&envAmpOsc3_R);
		GetValues(dStartTime, &(pTrack->dTimeAmpOsc3_R),&fAmpStart,&fAmpEnd,dLength,
			pEnv, pTrack);
	}

	// OSC PITCH SPECIFIC BIT
	// values are in octaves
	// need to convert to enable multiplication

	// -24 = multiply by 1/4
	// -12 = multiply by 1/2
	//  0 = multiply by 1
	// +12 = multiply by 2
	// +24 = multiply by 4

	// 2 ^ (x/12)


	fPitchStart = (float)pow(2,fPitchStart/12);
	fPitchEnd = (float)pow(2,fPitchEnd/12);

	// END PITCH SPECIFIC

	// OSC FM SPECIFIC BIT
	// nothing special needs to be done here
	// FM amplitude is 0-1
	// representing no modulation
	// up to 100% modulation
	// 
	// lets put 100% modulation as the oscillator pitch
	// END FM SPECIFIC BIT

	// OSC AMP SPECIFIC BIT
	// nothing
	// END OSC AMP SPECIFIC BIT

	// figure out a lerp
	fPitchInc = CALC_INCREMENT(fPitchStart,fPitchEnd,numsamples);
	float fPitchBase = fPitchStart;

	fFMInc = CALC_INCREMENT(fFMStart, fFMEnd, numsamples);
	float fFMBase = fFMStart;

	fAmpInc = CALC_INCREMENT(fAmpStart, fAmpEnd, numsamples);
	float fAmpBase = fAmpStart;

	int i = 0;

	int iSamplesPerSecond = this->pMasterInfo->SamplesPerSec;

	float fPitch;

	float * pWaveTable;
	float * pWaveTable2;

	bool bQuiet;
	bQuiet = ((fAmpStart * fAmpStart) < LOW_VOLUME);
	bQuiet &= ((fAmpEnd * fAmpEnd) < LOW_VOLUME);

	if(bQuiet)
	{
		return false;

	} 
	COscillator * pOsc;
	if(bLeft) 
	{
		pOsc = &pTrack->osc3_L;
	} else {
		pOsc = &pTrack->osc3_R;
	}
	// calculate the value
	while(numsamples--) {
		fPitch = pfPitch[i] * fPitchBase;
		pOsc->CalculatePhase( fPitch + (fFMBase * fPitch * this->pfFMOut[i]), iSamplesPerSecond);

		// update wavelevels every 16 samples
		if(! (i & 0xF))
		{
			WaveLevels(this->wtOsc3,pOsc->GetPhaseInc(),&pWaveTable, &pWaveTable2);
		}

		*(psamples++) = pWaveTable[pOsc->GetPhaseAndIncrement()] * fAmpBase;

		fPitchBase += fPitchInc;
		fAmpBase += fAmpInc;
		fFMBase += fFMInc;
		i++;
	}

	return true;


}


void mi::CalcClip(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	float fStart;
	float fEnd;

	float fInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);
	   
	if(bLeft)
	{
		// grab start time
		dStartTime = pTrack->dTimeClip_L;

		// GetValues
		GetValues(dStartTime, &(pTrack->dTimeClip_L),&fStart,&fEnd,dLength,
			&envClip_L, pTrack);

		if(pTrack->bSmoothingNow_L)
			fStart = pTrack->fValueClip_L;	

		pTrack->fValueClip_L = fEnd;

	} else { // right

		// grab start time
		dStartTime = pTrack->dTimeClip_R;

		CSerpentEnvelope * pEnv = (envClip_L.bLinked?&envClip_L:&envClip_R);

		// GetValues
		GetValues(dStartTime, &(pTrack->dTimeClip_R),&fStart,&fEnd,dLength,
			pEnv, pTrack);

		if(pTrack->bSmoothingNow_R)
			fStart = pTrack->fValueClip_R;	

		pTrack->fValueClip_R = fEnd;
	}

	// CLIP SPECIFIC BIT
	
	// nothing
	
	// END SPECIFIC

	// figure out a lerp
	fInc = CALC_INCREMENT(fStart,fEnd,numsamples);
	float fBase = fStart;

	int i = 0;

	float fabsClip;
	float fSign;
	
	// do the clip
	while(numsamples--) {
		fabsClip = fabsf(pfClip[i]);
		if(fabsClip > 0.0f)
		{
			fSign = pfClip[i] / fabsClip;
		} else {
			fSign = 0.0f;
		}

		if( fabsClip > fBase )
		{
			pfClip[i] = fBase * fSign;
		}

		i++;

		fBase += fInc;
	}

}


bool mi::IsFinished(CTrack * pTrack, bool bLeft)
{
	if(bLeft)
	{
		if(pTrack->dTimeAmp_L > envAmp_L.GetLastTime())
		{
			return true;
		}

	} else { // right

		CSerpentEnvelope * pEnv = (envAmp_L.bLinked?&envAmp_L:&envAmp_R);
		if(pTrack->dTimeAmp_R > pEnv->GetLastTime())
		{
			return true;
		}		
	}

	return false;

}

#define MAX_AMP 32000

// returns false if the track is finished playing
bool mi::CalcAmp(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	float fStart;
	float fEnd;

	float fInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);

	if(bLeft)
	{
		// grab start time
		dStartTime = pTrack->dTimeAmp_L;
		
			// GetValues
		GetValues(dStartTime, &(pTrack->dTimeAmp_L),&fStart,&fEnd,dLength,
			&envAmp_L, pTrack);

		if(pTrack->bSmoothingNow_L)
			fStart = pTrack->fValueAmp_L;	

		pTrack->fValueAmp_L = fEnd;

	} else { // right

		// grab start time
		dStartTime = pTrack->dTimeAmp_R;

		CSerpentEnvelope * pEnv = (envAmp_L.bLinked?&envAmp_L:&envAmp_R);

		// GetValues
		GetValues(dStartTime, &(pTrack->dTimeAmp_R),&fStart,&fEnd,dLength,
			pEnv, pTrack);

		if(pTrack->bSmoothingNow_R)
			fStart = pTrack->fValueAmp_R;	

		pTrack->fValueAmp_R = fEnd;

	}

	// AMP SPECIFIC BIT
	
	// Final amp goes up to MAX_AMP
	fStart *= MAX_AMP;
	fEnd *= MAX_AMP;
	
	// END SPECIFIC

	// figure out a lerp
	fInc = CALC_INCREMENT(fStart,fEnd,numsamples);
	float fBase = fStart;

	int i = 0;

	// do the clip
	while(numsamples--) {
		pfOutput[i++] *= fBase;
		fBase += fInc;
	}

	return true;

}



#define MAX_RES (0.98f)

#define MIN(x,y) ((x)>(y)?(y):(x))

// This is a really, really, really stupid way to do this
// TODO: Generalise the filters! Jeez.
void mi::CalcFilter1(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	float fCutoffStart;
	float fCutoffEnd;

	float fResStart;
	float fResEnd;

	float fLPStart;
	float fLPEnd;

	float fHPStart;
	float fHPEnd;

	float fBPStart;
	float fBPEnd;

	float fCutoffInc;
	float fResInc;
	float fLPInc;
	float fHPInc;
	float fBPInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);
	 
	if(bLeft)
	{
		// grab Cutoff info
		dStartTime = pTrack->dTimeFilter1Cut_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter1Cut_L),&fCutoffStart,&fCutoffEnd,dLength,
			&envFilter1Cut_L, pTrack);

		// then Res
		dStartTime = pTrack->dTimeFilter1Res_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter1Res_L),&fResStart,&fResEnd,dLength,
			&envFilter1Res_L, pTrack);

		// then LP
		dStartTime = pTrack->dTimeFilter1LP_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter1LP_L),&fLPStart,&fLPEnd,dLength,
			&envFilter1LP_L, pTrack);

		// then HP
		dStartTime = pTrack->dTimeFilter1HP_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter1HP_L),&fHPStart,&fHPEnd,dLength,
			&envFilter1HP_L, pTrack);

		// then BP
		dStartTime = pTrack->dTimeFilter1BP_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter1BP_L),&fBPStart,&fBPEnd,dLength,
			&envFilter1BP_L, pTrack);

		if(pTrack->bSmoothingNow_L)
		{
			fCutoffStart = pTrack->fValueFilter1Cut_L;	
			fResStart = pTrack->fValueFilter1Res_L;	
			fLPStart = pTrack->fValueFilter1LP_L;	
			fHPStart = pTrack->fValueFilter1HP_L;	
			fBPStart = pTrack->fValueFilter1BP_L;	
		}

		pTrack->fValueFilter1Cut_L = fCutoffEnd;
		pTrack->fValueFilter1Res_L = fResEnd;
		pTrack->fValueFilter1LP_L = fLPEnd;
		pTrack->fValueFilter1HP_L = fHPEnd;
		pTrack->fValueFilter1BP_L = fBPEnd;

	} else { // right

		// check linkage

		CSerpentEnvelope * pEnv;

		// grab Cutoff info
		dStartTime = pTrack->dTimeFilter1Cut_R;
		pEnv = (envFilter1Cut_L.bLinked?&envFilter1Cut_L:&envFilter1Cut_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter1Cut_R),&fCutoffStart,&fCutoffEnd,dLength,
			pEnv, pTrack);

		// then Res
		dStartTime = pTrack->dTimeFilter1Res_R;
		pEnv = (envFilter1Res_L.bLinked?&envFilter1Res_L:&envFilter1Res_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter1Res_R),&fResStart,&fResEnd,dLength,
			pEnv, pTrack);

		// then LP
		dStartTime = pTrack->dTimeFilter1LP_R;
		pEnv = (envFilter1LP_L.bLinked?&envFilter1LP_L:&envFilter1LP_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter1LP_R),&fLPStart,&fLPEnd,dLength,
			pEnv, pTrack);

		// then HP
		dStartTime = pTrack->dTimeFilter1HP_R;
		pEnv = (envFilter1HP_L.bLinked?&envFilter1HP_L:&envFilter1HP_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter1HP_R),&fHPStart,&fHPEnd,dLength,
			pEnv, pTrack);

		// then BP
		dStartTime = pTrack->dTimeFilter1BP_R;
		pEnv = (envFilter1BP_L.bLinked?&envFilter1BP_L:&envFilter1BP_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter1BP_R),&fBPStart,&fBPEnd,dLength,
			pEnv, pTrack);

		if(pTrack->bSmoothingNow_R)
		{
			fCutoffStart = pTrack->fValueFilter1Cut_R;	
			fResStart = pTrack->fValueFilter1Res_R;	
			fLPStart = pTrack->fValueFilter1LP_R;	
			fHPStart = pTrack->fValueFilter1HP_R;	
			fBPStart = pTrack->fValueFilter1BP_R;	
		}

		pTrack->fValueFilter1Cut_R = fCutoffEnd;
		pTrack->fValueFilter1Res_R = fResEnd;
		pTrack->fValueFilter1LP_R = fLPEnd;
		pTrack->fValueFilter1HP_R = fHPEnd;
		pTrack->fValueFilter1BP_R = fBPEnd;
	}

	// CUTOFF SPECIFIC BIT
	// cutoff is relative to pitch (at octave shift point)
	// base is pitch
	// max is MAX_FILTER_CUTOFF
	float fBaseCutoff = this->pfPitch[0];
	float fCutoffRange = MAX_FILTER_CUTOFF - fBaseCutoff;
	if(fCutoffRange < 0.0f) fCutoffRange = 0.0f;

	fCutoffStart = fBaseCutoff + (fCutoffRange * fCutoffStart);	

	fBaseCutoff = this->pfPitch[numsamples - 1];
	fCutoffRange = MAX_FILTER_CUTOFF - fBaseCutoff;
	if(fCutoffRange < 0.0f) fCutoffRange = 0.0f;

	fCutoffEnd = fBaseCutoff + (fCutoffRange * fCutoffEnd);	

	// prevent cutoff from going too low
	if(fCutoffStart < 20.0f) fCutoffStart = 20.0f;
	if(fCutoffEnd < 20.0f) fCutoffEnd = 20.0f;


	// END CUTOFF SPECIFIC

	// RES SPECIFIC BIT
	// nothing special needs to be done here
	// just ensure res doesn't get too high
	// 
	if(fResStart > MAX_RES) fResStart = MAX_RES;
	if(fResEnd > MAX_RES) fResEnd = MAX_RES;
	// END RES SPECIFIC BIT

	// AMP SPECIFIC BITS
	// nothing, except to half the items to deal with the
	// serp_double sampled filters
	fLPStart *= 0.5f;
	fLPEnd *= 0.5f;
	fHPStart *= 0.5f;
	fHPEnd *= 0.5f;
	fBPStart *= 0.5f;
	fBPEnd *= 0.5f;
	// OSC AMP SPECIFIC BITS

	// figure out a lerp
	fCutoffInc = CALC_INCREMENT(fCutoffStart,fCutoffEnd,numsamples);
	float fCutoffBase = fCutoffStart;

	fResInc = CALC_INCREMENT(fResStart, fResEnd, numsamples);
	float fResBase = fResStart;

	fLPInc = CALC_INCREMENT(fLPStart, fLPEnd, numsamples);
	float fLPBase = fLPStart;

	fHPInc = CALC_INCREMENT(fHPStart, fHPEnd, numsamples);
	float fHPBase = fHPStart;

	fBPInc = CALC_INCREMENT(fBPStart, fBPEnd, numsamples);
	float fBPBase = fBPStart;

	int i = 0;

	int iSamplesPerSecond = this->pMasterInfo->SamplesPerSec;

	int iTotalSamples = numsamples;

	float fFiltCutoff;
	float fFiltRes;
	float fFiltDamp;
	float fFiltNotch;
	float fFiltLow;
	float fFiltHigh;
	float fFiltBand;

	if(bLeft)
	{
		fFiltCutoff = (pTrack->fFilt1Cutoff_L);
		fFiltRes = (pTrack->fFilt1Res_L);
		fFiltDamp = (pTrack->fFilt1Damp_L);
		fFiltNotch = (pTrack->fFilt1Notch_L);
		fFiltLow = (pTrack->fFilt1Low_L);
		fFiltHigh = (pTrack->fFilt1High_L);
		fFiltBand = (pTrack->fFilt1Band_L);
	} else {
		fFiltCutoff = (pTrack->fFilt1Cutoff_R);
		fFiltRes = (pTrack->fFilt1Res_R);
		fFiltDamp = (pTrack->fFilt1Damp_R);
		fFiltNotch = (pTrack->fFilt1Notch_R);
		fFiltLow = (pTrack->fFilt1Low_R);
		fFiltHigh = (pTrack->fFilt1High_R);
		fFiltBand = (pTrack->fFilt1Band_R);
	}


	// calculate the value
	while(numsamples--) {

		// update every 16 samples
		if(!(i & 0xF))
		{
			float fs = float(this->pMasterInfo->SamplesPerSec);
			float fMaxFilt = float(this->pMasterInfo->SamplesPerSec / 2);
			// set the filter up too
			fFiltCutoff = fCutoffBase;

			fFiltRes = fResBase;

			fFiltCutoff = (float)MIN(0.9, 2.0*sin(PI*(fFiltCutoff)/(fs*2)));  // the fs*2 is because it's serp_double sampled
			fFiltDamp = (float)MIN(2.0*(1.0 - pow((fFiltRes), 0.5)), MIN(2.0, 2.0/(fFiltCutoff) - (fFiltCutoff)*0.5));
		}

		// do the filter thing
		float in = this->pfClip[i];

		fFiltNotch = in - fFiltDamp * fFiltBand;
		fFiltLow = fFiltLow + fFiltCutoff * fFiltBand;
		fFiltHigh = fFiltNotch - fFiltLow;
		fFiltBand = fFiltCutoff * fFiltHigh + fFiltBand;// - (tv->fFiltBand * tv->fFiltBand * tv->fFiltBand * 0.05);
		
		this->pfFilterLP[i] = fFiltLow;
		this->pfFilterHP[i] = fFiltHigh;
		this->pfFilterBP[i] = fFiltBand;

		fFiltNotch = in - fFiltDamp * fFiltBand;
		fFiltLow = fFiltLow + fFiltCutoff * fFiltBand;
		fFiltHigh = fFiltNotch - fFiltLow;
		fFiltBand = fFiltCutoff * fFiltHigh + fFiltBand;
			
		this->pfFilterLP[i] += fFiltLow;
		this->pfFilterHP[i] += fFiltHigh;
		this->pfFilterBP[i] += fFiltBand;

		// then multiply by the amp
		pfFilterLP[i] *= fLPBase;
		pfFilterHP[i] *= fHPBase;
		pfFilterBP[i] *= fBPBase;

		fCutoffBase += fCutoffInc;
		fResBase += fResInc;
		fLPBase += fLPInc;
		fHPBase += fHPInc;
		fBPBase += fBPInc;

		i++;
	}

	if(bLeft)
	{
		pTrack->fFilt1Cutoff_L = fFiltCutoff;
		pTrack->fFilt1Res_L = fFiltRes;
		pTrack->fFilt1Damp_L = fFiltDamp;
		pTrack->fFilt1Notch_L = fFiltNotch;
		pTrack->fFilt1Low_L = fFiltLow;
		pTrack->fFilt1High_L = fFiltHigh;
		pTrack->fFilt1Band_L = fFiltBand;
	} else {
		pTrack->fFilt1Cutoff_R = fFiltCutoff;
		pTrack->fFilt1Res_R = fFiltRes;
		pTrack->fFilt1Damp_R = fFiltDamp;
		pTrack->fFilt1Notch_R = fFiltNotch;
		pTrack->fFilt1Low_R = fFiltLow;
		pTrack->fFilt1High_R = fFiltHigh;
		pTrack->fFilt1Band_R = fFiltBand;
	}
}


void mi::CalcFilter2(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	float fCutoffStart;
	float fCutoffEnd;

	float fResStart;
	float fResEnd;

	float fLPStart;
	float fLPEnd;

	float fHPStart;
	float fHPEnd;

	float fBPStart;
	float fBPEnd;

	float fCutoffInc;
	float fResInc;
	float fLPInc;
	float fHPInc;
	float fBPInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);
	 
	if(bLeft)
	{
		// grab Cutoff info
		dStartTime = pTrack->dTimeFilter2Cut_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter2Cut_L),&fCutoffStart,&fCutoffEnd,dLength,
			&envFilter2Cut_L, pTrack);

		// then Res
		dStartTime = pTrack->dTimeFilter2Res_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter2Res_L),&fResStart,&fResEnd,dLength,
			&envFilter2Res_L, pTrack);

		// then LP
		dStartTime = pTrack->dTimeFilter2LP_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter2LP_L),&fLPStart,&fLPEnd,dLength,
			&envFilter2LP_L, pTrack);

		// then HP
		dStartTime = pTrack->dTimeFilter2HP_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter2HP_L),&fHPStart,&fHPEnd,dLength,
			&envFilter2HP_L, pTrack);

		// then BP
		dStartTime = pTrack->dTimeFilter2BP_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter2BP_L),&fBPStart,&fBPEnd,dLength,
			&envFilter2BP_L, pTrack);

		if(pTrack->bSmoothingNow_L)
		{
			fCutoffStart = pTrack->fValueFilter2Cut_L;	
			fResStart = pTrack->fValueFilter2Res_L;	
			fLPStart = pTrack->fValueFilter2LP_L;	
			fHPStart = pTrack->fValueFilter2HP_L;	
			fBPStart = pTrack->fValueFilter2BP_L;	
		}

		pTrack->fValueFilter2Cut_L = fCutoffEnd;
		pTrack->fValueFilter2Res_L = fResEnd;
		pTrack->fValueFilter2LP_L = fLPEnd;
		pTrack->fValueFilter2HP_L = fHPEnd;
		pTrack->fValueFilter2BP_L = fBPEnd;


	} else  { // right

		// check linkage

		CSerpentEnvelope * pEnv;

		// grab Cutoff info
		dStartTime = pTrack->dTimeFilter2Cut_R;
		pEnv = (envFilter2Cut_L.bLinked?&envFilter2Cut_L:&envFilter2Cut_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter2Cut_R),&fCutoffStart,&fCutoffEnd,dLength,
			pEnv, pTrack);

		// then Res
		dStartTime = pTrack->dTimeFilter2Res_R;
		pEnv = (envFilter2Res_L.bLinked?&envFilter2Res_L:&envFilter2Res_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter2Res_R),&fResStart,&fResEnd,dLength,
			pEnv, pTrack);

		// then LP
		dStartTime = pTrack->dTimeFilter2LP_R;
		pEnv = (envFilter2LP_L.bLinked?&envFilter2LP_L:&envFilter2LP_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter2LP_R),&fLPStart,&fLPEnd,dLength,
			pEnv, pTrack);

		// then HP
		dStartTime = pTrack->dTimeFilter2HP_R;
		pEnv = (envFilter2HP_L.bLinked?&envFilter2HP_L:&envFilter2HP_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter2HP_R),&fHPStart,&fHPEnd,dLength,
			pEnv, pTrack);

		// then BP
		dStartTime = pTrack->dTimeFilter2BP_R;
		pEnv = (envFilter2BP_L.bLinked?&envFilter2BP_L:&envFilter2BP_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter2BP_R),&fBPStart,&fBPEnd,dLength,
			pEnv, pTrack);

		if(pTrack->bSmoothingNow_R)
		{
			fCutoffStart = pTrack->fValueFilter2Cut_R;	
			fResStart = pTrack->fValueFilter2Res_R;	
			fLPStart = pTrack->fValueFilter2LP_R;	
			fHPStart = pTrack->fValueFilter2HP_R;	
			fBPStart = pTrack->fValueFilter2BP_R;	
		}

		pTrack->fValueFilter2Cut_R = fCutoffEnd;
		pTrack->fValueFilter2Res_R = fResEnd;
		pTrack->fValueFilter2LP_R = fLPEnd;
		pTrack->fValueFilter2HP_R = fHPEnd;
		pTrack->fValueFilter2BP_R = fBPEnd;
	}

	// CUTOFF SPECIFIC BIT
	// cutoff is relative to pitch (at octave shift point)
	// base is pitch
	// max is MAX_FILTER_CUTOFF
	float fBaseCutoff = this->pfPitch[0];
	float fCutoffRange = MAX_FILTER_CUTOFF - fBaseCutoff;
	if(fCutoffRange < 0.0f) fCutoffRange = 0.0f;

	fCutoffStart = fBaseCutoff + (fCutoffRange * fCutoffStart);	

	fBaseCutoff = this->pfPitch[numsamples - 1];
	fCutoffRange = MAX_FILTER_CUTOFF - fBaseCutoff;
	if(fCutoffRange < 0.0f) fCutoffRange = 0.0f;

	fCutoffEnd = fBaseCutoff + (fCutoffRange * fCutoffEnd);	

	// prevent cutoff from going too low
	if(fCutoffStart < 20.0f) fCutoffStart = 20.0f;
	if(fCutoffEnd < 20.0f) fCutoffEnd = 20.0f;


	// END CUTOFF SPECIFIC

	// RES SPECIFIC BIT
	// nothing special needs to be done here
	// just ensure res doesn't get too high
	// 
	if(fResStart > MAX_RES) fResStart = MAX_RES;
	if(fResEnd > MAX_RES) fResEnd = MAX_RES;
	// END RES SPECIFIC BIT

	// AMP SPECIFIC BITS
	// nothing, except to half the items to deal with the
	// serp_double sampled filters
	fLPStart *= 0.5f;
	fLPEnd *= 0.5f;
	fHPStart *= 0.5f;
	fHPEnd *= 0.5f;
	fBPStart *= 0.5f;
	fBPEnd *= 0.5f;
	// OSC AMP SPECIFIC BITS

	// figure out a lerp
	fCutoffInc = CALC_INCREMENT(fCutoffStart,fCutoffEnd,numsamples);
	float fCutoffBase = fCutoffStart;

	fResInc = CALC_INCREMENT(fResStart, fResEnd, numsamples);
	float fResBase = fResStart;

	fLPInc = CALC_INCREMENT(fLPStart, fLPEnd, numsamples);
	float fLPBase = fLPStart;

	fHPInc = CALC_INCREMENT(fHPStart, fHPEnd, numsamples);
	float fHPBase = fHPStart;

	fBPInc = CALC_INCREMENT(fBPStart, fBPEnd, numsamples);
	float fBPBase = fBPStart;

	int i = 0;

	int iSamplesPerSecond = this->pMasterInfo->SamplesPerSec;

	float fFiltCutoff;
	float fFiltRes;
	float fFiltDamp;
	float fFiltNotch;
	float fFiltLow;
	float fFiltHigh;
	float fFiltBand;

	if(bLeft)
	{
		fFiltCutoff = (pTrack->fFilt2Cutoff_L);
		fFiltRes = (pTrack->fFilt2Res_L);
		fFiltDamp = (pTrack->fFilt2Damp_L);
		fFiltNotch = (pTrack->fFilt2Notch_L);
		fFiltLow = (pTrack->fFilt2Low_L);
		fFiltHigh = (pTrack->fFilt2High_L);
		fFiltBand = (pTrack->fFilt2Band_L);
	} else {
		fFiltCutoff = (pTrack->fFilt2Cutoff_R);
		fFiltRes = (pTrack->fFilt2Res_R);
		fFiltDamp = (pTrack->fFilt2Damp_R);
		fFiltNotch = (pTrack->fFilt2Notch_R);
		fFiltLow = (pTrack->fFilt2Low_R);
		fFiltHigh = (pTrack->fFilt2High_R);
		fFiltBand = (pTrack->fFilt2Band_R);
	}


	// calculate the value
	while(numsamples--) {

		// update every 16 samples
		if(!(i & 0xF))
		{
			float fs = float(this->pMasterInfo->SamplesPerSec);
			float fMaxFilt = float(this->pMasterInfo->SamplesPerSec / 2);
			// set the filter up too
			fFiltCutoff = fCutoffBase;

			fFiltRes = fResBase;

			fFiltCutoff = (float)MIN(0.9, 2.0*sin(PI*(fFiltCutoff)/(fs*2)));  // the fs*2 is because it's serp_double sampled
			fFiltDamp = (float)MIN(2.0*(1.0 - pow((fFiltRes), 0.5)), MIN(2.0, 2.0/(fFiltCutoff) - (fFiltCutoff)*0.5));
		}

		// do the filter thing
		float in = this->pfClip[i];

		fFiltNotch = in - fFiltDamp * fFiltBand;
		fFiltLow = fFiltLow + fFiltCutoff * fFiltBand;
		fFiltHigh = fFiltNotch - fFiltLow;
		fFiltBand = fFiltCutoff * fFiltHigh + fFiltBand;// - (tv->fFiltBand * tv->fFiltBand * tv->fFiltBand * 0.05);
		
		this->pfFilterLP[i] = fFiltLow;
		this->pfFilterHP[i] = fFiltHigh;
		this->pfFilterBP[i] = fFiltBand;

		fFiltNotch = in - fFiltDamp * fFiltBand;
		fFiltLow = fFiltLow + fFiltCutoff * fFiltBand;
		fFiltHigh = fFiltNotch - fFiltLow;
		fFiltBand = fFiltCutoff * fFiltHigh + fFiltBand;
			
		this->pfFilterLP[i] += fFiltLow;
		this->pfFilterHP[i] += fFiltHigh;
		this->pfFilterBP[i] += fFiltBand;

		// then multiply by the amp
		pfFilterLP[i] *= fLPBase;
		pfFilterHP[i] *= fHPBase;
		pfFilterBP[i] *= fBPBase;

		fCutoffBase += fCutoffInc;
		fResBase += fResInc;
		fLPBase += fLPInc;
		fHPBase += fHPInc;
		fBPBase += fBPInc;

		i++;
	}

	if(bLeft)
	{
		pTrack->fFilt2Cutoff_L = fFiltCutoff;
		pTrack->fFilt2Res_L = fFiltRes;
		pTrack->fFilt2Damp_L = fFiltDamp;
		pTrack->fFilt2Notch_L = fFiltNotch;
		pTrack->fFilt2Low_L = fFiltLow;
		pTrack->fFilt2High_L = fFiltHigh;
		pTrack->fFilt2Band_L = fFiltBand;
	} else {
		pTrack->fFilt2Cutoff_R = fFiltCutoff;
		pTrack->fFilt2Res_R = fFiltRes;
		pTrack->fFilt2Damp_R = fFiltDamp;
		pTrack->fFilt2Notch_R = fFiltNotch;
		pTrack->fFilt2Low_R = fFiltLow;
		pTrack->fFilt2High_R = fFiltHigh;
		pTrack->fFilt2Band_R = fFiltBand;
	}

}

void mi::CalcFilter3(float * psamples, CTrack * pTrack, int numsamples, bool bLeft)
{
	float fCutoffStart;
	float fCutoffEnd;

	float fResStart;
	float fResEnd;

	float fLPStart;
	float fLPEnd;

	float fHPStart;
	float fHPEnd;

	float fBPStart;
	float fBPEnd;

	float fCutoffInc;
	float fResInc;
	float fLPInc;
	float fHPInc;
	float fBPInc;

	serp_double dStartTime;
	serp_double dLength = ((serp_double)numsamples / (serp_double)this->pMasterInfo->SamplesPerSec);
	 
	if(bLeft)
	{
		// grab Cutoff info
		dStartTime = pTrack->dTimeFilter3Cut_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter3Cut_L),&fCutoffStart,&fCutoffEnd,dLength,
			&envFilter3Cut_L, pTrack);

		// then Res
		dStartTime = pTrack->dTimeFilter3Res_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter3Res_L),&fResStart,&fResEnd,dLength,
			&envFilter3Res_L, pTrack);

		// then LP
		dStartTime = pTrack->dTimeFilter3LP_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter3LP_L),&fLPStart,&fLPEnd,dLength,
			&envFilter3LP_L, pTrack);

		// then HP
		dStartTime = pTrack->dTimeFilter3HP_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter3HP_L),&fHPStart,&fHPEnd,dLength,
			&envFilter3HP_L, pTrack);

		// then BP
		dStartTime = pTrack->dTimeFilter3BP_L;
		GetValues(dStartTime, &(pTrack->dTimeFilter3BP_L),&fBPStart,&fBPEnd,dLength,
			&envFilter3BP_L, pTrack);

		if(pTrack->bSmoothingNow_L)
		{
			fCutoffStart = pTrack->fValueFilter3Cut_L;	
			fResStart = pTrack->fValueFilter3Res_L;	
			fLPStart = pTrack->fValueFilter3LP_L;	
			fHPStart = pTrack->fValueFilter3HP_L;	
			fBPStart = pTrack->fValueFilter3BP_L;	
		}

		pTrack->fValueFilter3Cut_L = fCutoffEnd;
		pTrack->fValueFilter3Res_L = fResEnd;
		pTrack->fValueFilter3LP_L = fLPEnd;
		pTrack->fValueFilter3HP_L = fHPEnd;
		pTrack->fValueFilter3BP_L = fBPEnd;


	} else  { // right

		// check linkage

		CSerpentEnvelope * pEnv;

		// grab Cutoff info
		dStartTime = pTrack->dTimeFilter3Cut_R;
		pEnv = (envFilter3Cut_L.bLinked?&envFilter3Cut_L:&envFilter3Cut_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter3Cut_R),&fCutoffStart,&fCutoffEnd,dLength,
			pEnv, pTrack);

		// then Res
		dStartTime = pTrack->dTimeFilter3Res_R;
		pEnv = (envFilter3Res_L.bLinked?&envFilter3Res_L:&envFilter3Res_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter3Res_R),&fResStart,&fResEnd,dLength,
			pEnv, pTrack);

		// then LP
		dStartTime = pTrack->dTimeFilter3LP_R;
		pEnv = (envFilter3LP_L.bLinked?&envFilter3LP_L:&envFilter3LP_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter3LP_R),&fLPStart,&fLPEnd,dLength,
			pEnv, pTrack);

		// then HP
		dStartTime = pTrack->dTimeFilter3HP_R;
		pEnv = (envFilter3HP_L.bLinked?&envFilter3HP_L:&envFilter3HP_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter3HP_R),&fHPStart,&fHPEnd,dLength,
			pEnv, pTrack);

		// then BP
		dStartTime = pTrack->dTimeFilter3BP_R;
		pEnv = (envFilter3BP_L.bLinked?&envFilter3BP_L:&envFilter3BP_R);
		GetValues(dStartTime, &(pTrack->dTimeFilter3BP_R),&fBPStart,&fBPEnd,dLength,
			pEnv, pTrack);

		if(pTrack->bSmoothingNow_R)
		{
			fCutoffStart = pTrack->fValueFilter3Cut_R;	
			fResStart = pTrack->fValueFilter3Res_R;	
			fLPStart = pTrack->fValueFilter3LP_R;	
			fHPStart = pTrack->fValueFilter3HP_R;	
			fBPStart = pTrack->fValueFilter3BP_R;	
		}

		pTrack->fValueFilter3Cut_R = fCutoffEnd;
		pTrack->fValueFilter3Res_R = fResEnd;
		pTrack->fValueFilter3LP_R = fLPEnd;
		pTrack->fValueFilter3HP_R = fHPEnd;
		pTrack->fValueFilter3BP_R = fBPEnd;
	}

	// CUTOFF SPECIFIC BIT
	// cutoff is relative to pitch (at octave shift point)
	// base is pitch
	// max is MAX_FILTER_CUTOFF
	float fBaseCutoff = this->pfPitch[0];
	float fCutoffRange = MAX_FILTER_CUTOFF - fBaseCutoff;
	if(fCutoffRange < 0.0f) fCutoffRange = 0.0f;

	fCutoffStart = fBaseCutoff + (fCutoffRange * fCutoffStart);	

	fBaseCutoff = this->pfPitch[numsamples - 1];
	fCutoffRange = MAX_FILTER_CUTOFF - fBaseCutoff;
	if(fCutoffRange < 0.0f) fCutoffRange = 0.0f;

	fCutoffEnd = fBaseCutoff + (fCutoffRange * fCutoffEnd);	

	// prevent cutoff from going too low
	if(fCutoffStart < 20.0f) fCutoffStart = 20.0f;
	if(fCutoffEnd < 20.0f) fCutoffEnd = 20.0f;


	// END CUTOFF SPECIFIC

	// RES SPECIFIC BIT
	// nothing special needs to be done here
	// just ensure res doesn't get too high
	// 
	if(fResStart > MAX_RES) fResStart = MAX_RES;
	if(fResEnd > MAX_RES) fResEnd = MAX_RES;
	// END RES SPECIFIC BIT

	// AMP SPECIFIC BITS
	// nothing, except to half the items to deal with the
	// serp_double sampled filters
	fLPStart *= 0.5f;
	fLPEnd *= 0.5f;
	fHPStart *= 0.5f;
	fHPEnd *= 0.5f;
	fBPStart *= 0.5f;
	fBPEnd *= 0.5f;
	// OSC AMP SPECIFIC BITS

	// figure out a lerp
	fCutoffInc = CALC_INCREMENT(fCutoffStart,fCutoffEnd,numsamples);
	float fCutoffBase = fCutoffStart;

	fResInc = CALC_INCREMENT(fResStart, fResEnd, numsamples);
	float fResBase = fResStart;

	fLPInc = CALC_INCREMENT(fLPStart, fLPEnd, numsamples);
	float fLPBase = fLPStart;

	fHPInc = CALC_INCREMENT(fHPStart, fHPEnd, numsamples);
	float fHPBase = fHPStart;

	fBPInc = CALC_INCREMENT(fBPStart, fBPEnd, numsamples);
	float fBPBase = fBPStart;

	int i = 0;

	int iSamplesPerSecond = this->pMasterInfo->SamplesPerSec;

		float fFiltCutoff;
	float fFiltRes;
	float fFiltDamp;
	float fFiltNotch;
	float fFiltLow;
	float fFiltHigh;
	float fFiltBand;

	if(bLeft)
	{
		fFiltCutoff = (pTrack->fFilt3Cutoff_L);
		fFiltRes = (pTrack->fFilt3Res_L);
		fFiltDamp = (pTrack->fFilt3Damp_L);
		fFiltNotch = (pTrack->fFilt3Notch_L);
		fFiltLow = (pTrack->fFilt3Low_L);
		fFiltHigh = (pTrack->fFilt3High_L);
		fFiltBand = (pTrack->fFilt3Band_L);
	} else {
		fFiltCutoff = (pTrack->fFilt3Cutoff_R);
		fFiltRes = (pTrack->fFilt3Res_R);
		fFiltDamp = (pTrack->fFilt3Damp_R);
		fFiltNotch = (pTrack->fFilt3Notch_R);
		fFiltLow = (pTrack->fFilt3Low_R);
		fFiltHigh = (pTrack->fFilt3High_R);
		fFiltBand = (pTrack->fFilt3Band_R);
	}

	// calculate the value
	while(numsamples--) {

		// update every 16 samples
		if(!(i & 0xF))
		{
			float fs = float(this->pMasterInfo->SamplesPerSec);
			float fMaxFilt = float(this->pMasterInfo->SamplesPerSec / 2);
			// set the filter up too
			fFiltCutoff = fCutoffBase;

			fFiltRes = fResBase;

			fFiltCutoff = (float)MIN(0.9, 2.0*sin(PI*(fFiltCutoff)/(fs*2)));  // the fs*2 is because it's serp_double sampled
			fFiltDamp = (float)MIN(2.0*(1.0 - pow((fFiltRes), 0.5)), MIN(2.0, 2.0/(fFiltCutoff) - (fFiltCutoff)*0.5));
		}

		// do the filter thing
		float in = this->pfClip[i];

		fFiltNotch = in - fFiltDamp * fFiltBand;
		fFiltLow = fFiltLow + fFiltCutoff * fFiltBand;
		fFiltHigh = fFiltNotch - fFiltLow;
		fFiltBand = fFiltCutoff * fFiltHigh + fFiltBand;// - (tv->fFiltBand * tv->fFiltBand * tv->fFiltBand * 0.05);
		
		this->pfFilterLP[i] = fFiltLow;
		this->pfFilterHP[i] = fFiltHigh;
		this->pfFilterBP[i] = fFiltBand;

		fFiltNotch = in - fFiltDamp * fFiltBand;
		fFiltLow = fFiltLow + fFiltCutoff * fFiltBand;
		fFiltHigh = fFiltNotch - fFiltLow;
		fFiltBand = fFiltCutoff * fFiltHigh + fFiltBand;
			
		this->pfFilterLP[i] += fFiltLow;
		this->pfFilterHP[i] += fFiltHigh;
		this->pfFilterBP[i] += fFiltBand;

		// then multiply by the amp
		pfFilterLP[i] *= fLPBase;
		pfFilterHP[i] *= fHPBase;
		pfFilterBP[i] *= fBPBase;

		fCutoffBase += fCutoffInc;
		fResBase += fResInc;
		fLPBase += fLPInc;
		fHPBase += fHPInc;
		fBPBase += fBPInc;

		i++;
	}

	if(bLeft)
	{
		pTrack->fFilt3Cutoff_L = fFiltCutoff;
		pTrack->fFilt3Res_L = fFiltRes;
		pTrack->fFilt3Damp_L = fFiltDamp;
		pTrack->fFilt3Notch_L = fFiltNotch;
		pTrack->fFilt3Low_L = fFiltLow;
		pTrack->fFilt3High_L = fFiltHigh;
		pTrack->fFilt3Band_L = fFiltBand;
	} else {
		pTrack->fFilt3Cutoff_R = fFiltCutoff;
		pTrack->fFilt3Res_R = fFiltRes;
		pTrack->fFilt3Damp_R = fFiltDamp;
		pTrack->fFilt3Notch_R = fFiltNotch;
		pTrack->fFilt3Low_R = fFiltLow;
		pTrack->fFilt3High_R = fFiltHigh;
		pTrack->fFilt3Band_R = fFiltBand;
	}

}

// Behemoth Work method
bool mi::MDKWork(float *psamples, int numsamples, int const mode)
{	
	if (mode==WM_NOIO) {
		// machine is not connected to anything
		return false;
	} else if (mode==WM_WRITE) {

		CSingleLock sl(&csEnvelopes, TRUE);

		float * pOutput = psamples;

		// zero out the samples		
		memset(psamples,0,numsamples * sizeof(float));

		unsigned int c;

		int iSamples = numsamples;//(numsamples > MAX_WORK_LENGTH ? MAX_WORK_LENGTH : numsamples);

		int i ;

		bool bGotSomething = false;

		// for each track
		for (c = 0; c < miNumberOfTracks; c++) {

			CTrack *myTrack=myTracks+c;

			// bLeft is a bit of a hack.
			if(bLeft && !myTrack->bPlaying_L)
			{
				continue;
			} else if(!bLeft && !myTrack->bPlaying_R)
			{
				continue;
			}
			
			if(this->IsFinished(myTrack, bLeft))
			{
				if(bLeft)
				{
					myTrack->bPlaying_L = false;
					myTrack->ResetOscillators(bLeft);
					myTrack->bSmoothingNow_L = false;
				} else {
					myTrack->bPlaying_R  = false;
					myTrack->ResetOscillators(bLeft);
					myTrack->bSmoothingNow_R = false;
				}
			}

			// first calculate the total time
			serp_double dTime = ((serp_double)iSamples / (serp_double)this->pMasterInfo->SamplesPerSec);
			myTrack->dTimeTotal += dTime;
			if(myTrack->bSustaining && !myTrack->bInfiniteSustain)
			{
				if(myTrack->dTimeTotal > myTrack->dSustainLength)
				{
					myTrack->bSustaining = false;
				}
			}

			bGotSomething = true;

			// going to skip everything except FM
			this->CalcNote1ToNote2(psamples,myTrack, iSamples, bLeft);
			this->CalcOctaveShift(psamples,myTrack, iSamples, bLeft);
			this->CalcFMPitch(psamples, myTrack, iSamples, bLeft);
			this->CalcFMOut(psamples, myTrack, iSamples, bLeft);


			// mix oscillator output into clip buffer
			// first test if its zero
			// if left, check left osc 1 amp envelope
			// if right, check right osc 1 amp envelope
			bool bOsc1 = this->CalcOsc1(pfOsc1Out, myTrack, iSamples, bLeft);

			bool bOsc2 = this->CalcOsc2(pfOsc2Out, myTrack, iSamples, bLeft);

			bool bOsc3 = this->CalcOsc3(pfOsc3Out, myTrack, iSamples, bLeft);

			// copy oscillators into pfClip
			if(bOsc1)
			{
				if(bOsc2)
				{
					if(bOsc3)
					{
						// all three oscillators
						for(i = 0; i < iSamples; i++ ) {
							pfClip[i] = pfOsc1Out[i] + pfOsc2Out[i] + pfOsc3Out[i];
						}
					} else {
						// only 1 & 2
						for(i = 0; i < iSamples; i++ ) {
							pfClip[i] = pfOsc1Out[i] + pfOsc2Out[i];
						}
					}
				} else {
					// not 2
					if(bOsc3)
					{
						// 1 & 3
						for(i = 0; i < iSamples; i++ ) {
							pfClip[i] = pfOsc1Out[i] + pfOsc3Out[i];
						}
					} else {
						// only 1
						for(i = 0; i < iSamples; i++ ) {
							pfClip[i] = pfOsc1Out[i];
						}
					}
				}
			} 
			else {
				// no 1
				if(bOsc2)
				{
					if(bOsc3)
					{
						// 2 & 3
						for(i = 0; i < iSamples; i++ ) {
							pfClip[i] = pfOsc2Out[i] + pfOsc3Out[i];
						}
					} else {
						// only 2
						for(i = 0; i < iSamples; i++ ) {
							pfClip[i] = pfOsc2Out[i];
						}
					}
				} else {
					// not 2
					if(bOsc3)
					{
						// only 3
						for(i = 0; i < iSamples; i++ ) {
							pfClip[i] = pfOsc3Out[i];
						}
					} else {
						// none!
						for(i = 0; i < iSamples; i++ ) {
							pfClip[i] = 0.0f;
						}
					}
				}
			}

			if(bOsc1 || bOsc2 || bOsc3)
			{
				this->CalcClip(psamples, myTrack, iSamples, bLeft);
			}

			this->CalcFilter1(psamples, myTrack, iSamples, bLeft);
			for(i = 0; i < iSamples; i++  ){ this->pfClip[i] = pfFilterLP[i] + pfFilterHP[i] + pfFilterBP[i];	}

			this->CalcFilter2(psamples, myTrack, iSamples, bLeft);

			for(i = 0; i < iSamples; i++  )	{ this->pfOutput[i] =  pfFilterLP[i] + pfFilterHP[i] + pfFilterBP[i]; }

			// then filter 3
			this->CalcFilter3(psamples, myTrack, iSamples, bLeft);

			for(i = 0; i < iSamples; i++  ) this->pfOutput[i] = pfOutput[i] + pfFilterLP[i] + pfFilterHP[i] + pfFilterBP[i];

			// then the final amp
			CalcAmp(psamples, myTrack, iSamples, bLeft);

			// then done this channel for this track!
			// check if smoothing should be enabled
			if(myTrack->bSmooth)
			{
				if(bLeft) myTrack->bSmoothingNow_L = true;
				else myTrack->bSmoothingNow_R = true;

			}

			// this track is done (both channels)
			// mix back into psamples
			pOutput = psamples;
			for(i = 0; i < iSamples; i++)
			{
				*pOutput += pfOutput[i];
				pOutput++;

			}

			
		}

		sl.Unlock();

		return bGotSomething;
	}
	return false;
}

int mi::WaveLevels(WaveType wt, int iPhaseInc, float * * pLevel1, float * * pLevel2)
{
	// pretty simple function,

	// if PhaseInc < 1, then return 0 and 1
	// if PhaseInc < 2, then return 1 and 2
	// if PhaseInc < 3, then return 2 and 3
	// if PhaseInc < 4, then return 3 and 4
	// etc

	// catch the ones that are frequency invariant
	switch(wt)
	{
	case sine:
		*pLevel1 = *pLevel2 = pfSineSamples;
		return 0;
		break;

	case noise1:
		*pLevel1 = *pLevel2 = pfNoise;
		return 0;
		break;
	case noise2:
		*pLevel1 = *pLevel2 = pfINoise;
		return 0;
		break;
	}

	int iPhaseCompare = OVERSAMPLING;
	for(int i = 0; i < (SAMPLE_SETS - 1); i++)
	{
		if(iPhaseInc < iPhaseCompare)
		{
			switch(wt)
			{
			case saw:
				*pLevel1 = ppfSaw[i];
				*pLevel2 = ppfSaw[i + 1];
				break;

			case square:
				*pLevel1 = ppfSquare[i];
				*pLevel2 = ppfSquare[i + 1];
				break;

			case triangle:
				*pLevel1 = ppfTriangle[i];
				*pLevel2 = ppfTriangle[i + 1];
				break;

			}
			return 0;
		}
		iPhaseCompare <<= 1;
	}

	// catch if nothing matched
	switch(wt)
	{
	case saw:
		*pLevel1 = ppfSaw[SAMPLE_SETS - 1];
		*pLevel2 = ppfSaw[SAMPLE_SETS - 1];
		break;

	case square:
		*pLevel1 = ppfSquare[SAMPLE_SETS - 1];
		*pLevel2 = ppfSquare[SAMPLE_SETS - 1];
		break;

	case triangle:
		*pLevel1 = ppfTriangle[SAMPLE_SETS - 1];
		*pLevel2 = ppfTriangle[SAMPLE_SETS - 1];
		break;
	}

	return 0;

}

// Bezier Functions
serp_double mi::Bezier(serp_double fFirst, serp_double fSecond, serp_double fThird, serp_double fFourth, serp_double u)
{
	// assume 0 <= t <= 1

	// calculate some values to save using pow or anything crazy
	serp_double u2 = u * u;
	serp_double u3 = u * u2;
	serp_double oneminusu = (1.0 - u);
	serp_double oneminusu2 = oneminusu * oneminusu;
	serp_double oneminusu3 = oneminusu2 * oneminusu;

	// return the weighted sum of the Bernsteins
	// Bernsteins have the property that their sum is unity
	// Bezier curves pass through the first and fourth points, but not the second and third
	return (
		(oneminusu3 * fFirst) +				// first bernstein
		(3 * u * oneminusu2 * fSecond) +	// second
		(3 * u2 * oneminusu * fThird) +		// third
		(u3 * fFourth) );					// fourth

}

// This is perhaps the neatest function in this whole thing.
CSerpentEnvelopePoint mi::Bezier(CSerpentEnvelope * env, serp_double u)
{
	serp_double u2 = u * u;
	serp_double u3 = u * u2;
	serp_double oneminusu = (1.0 - u);
	serp_double oneminusu2 = oneminusu * oneminusu;
	serp_double oneminusu3 = oneminusu2 * oneminusu;

	CSerpentEnvelopePoint p;

	// return the weighted sum of the Bernsteins
	
	p = (env->env.p1 * oneminusu3 ) +
		(env->env.c1 * 3 * u * oneminusu2) + 
		(env->env.c2 * 3 * u2 * oneminusu) + 
		(env->env.p2 * u3 );

	return p;
}

// Used for splitting
serp_double mi::FindUFromT(CSerpentEnvelope * pStartEnv, serp_double t, CSerpentEnvelope ** ppFoundEnvelope)
{
	// do a binary style search
	serp_double u = 0.5;
	serp_double dUInc = 0.25;
	serp_double dCloseEnough = (0.001);		// 1 millisecond
	serp_double dDistance;
	serp_double tFound;
	bool bFound = false;

	serp_double u2 = u * u;
	serp_double u3 = u * u2;
	serp_double oneminusu = (1.0 - u);
	serp_double oneminusu2 = oneminusu * oneminusu;
	serp_double oneminusu3 = oneminusu2 * oneminusu;

	CSerpentEnvelope * env = pStartEnv;

	*ppFoundEnvelope = NULL;

	if(t < env->env.p1.t) return -1.0;

	while(t > env->env.p2.t && env->pNextEnvelope)
	{
		env = env->pNextEnvelope;
	}

	if(t > env->env.p2.t) return -1.0;

	*ppFoundEnvelope = env;

	int iCount = 0;

	do
	{
		// only care about t right now

		tFound = (oneminusu3 * env->env.p1.t) +
			(3 * u * oneminusu2 * env->env.c1.t) +
			(3 * u2 * oneminusu * env->env.c2.t) + 
			(u3 * env->env.p2.t );

		dDistance = tFound - t;
		dDistance *= dDistance;

		if(dDistance < dCloseEnough)
		{
			break;
		} else {
			if(t > tFound) u += (dUInc);
			if(t < tFound) u -= (dUInc);
		}

		dUInc *= 0.5;

		u2 = u * u;
		u3 = u * u2;
		oneminusu = (1.0 - u);
		oneminusu2 = oneminusu * oneminusu;
		oneminusu3 = oneminusu2 * oneminusu;

		iCount++;

	} while(!bFound && iCount < 500);	// limit iterations

	return u;
}


// CkibibuSerpentApp

BEGIN_MESSAGE_MAP(CkibibuSerpentApp, CWinApp)
END_MESSAGE_MAP()


// CkibibuSerpentApp construction

CkibibuSerpentApp::CkibibuSerpentApp()
{
	// TODO: Remove MFC comments :)

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CkibibuSerpentApp object

CkibibuSerpentApp theApp;


// CkibibuSerpentApp initialization

BOOL CkibibuSerpentApp::InitInstance()
{
	CWinApp::InitInstance();
	g_hInstance = this->m_hInstance;

	return TRUE;
}




